/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

void add_group_edit_popup(gchar *group_id)
{
    add_group_edit(group_id, 1);
}

void add_group_edit(gchar *group_id, gint popup_flag)
{
    GtkWidget          *main_window;
    extern GtkWidget   *group_receiver_clist;
    add_group_data     *add_group;
    edit_group_data    *edit_group;


    add_group = g_malloc(sizeof(*add_group));    
    edit_group = g_malloc(sizeof(*edit_group));    
    edit_group->group_id = g_malloc(MAX_FIELD_LENGTH);

    strcpy(edit_group->group_id, group_id);
    if ( popup_flag )
    {
	add_group->refresh_flag = 0;
	add_group->edit_flag = 1;
	add_group->popup_flag = 1;
    }
    else
    {
	add_group->refresh_flag = 0;
	add_group->edit_flag = 1;
	add_group->popup_flag = 0;
    }
    
    main_window = create_groups(add_group, edit_group);
    gtk_widget_show(main_window);
    load_generic_list("RECEIVER.dat", GTK_CLIST(group_receiver_clist));
}

/*
 *
 *  FUNCTION ADD_GROUP_FROM_LIST
 *
 *  This function is called when the user clicks the add button from the 
 *  list_services dialog box. We need to set the refresh flag to make sure 
 *  we refresh the clist in the add_service dialog so the new service gets 
 *  added into the list
 *
 */

void add_group_from_list()
{
    GtkWidget *main_window;
    extern GtkWidget *group_receiver_clist;
    add_group_data *add_group;

    add_group = g_malloc(sizeof(*add_group));    

    add_group->refresh_flag = 1;
    add_group->edit_flag = 0;
    add_group->popup_flag = 0;
    main_window = create_groups(add_group, NULL);
    gtk_widget_show(main_window);
    load_generic_list("RECEIVER.dat", GTK_CLIST(group_receiver_clist));
}


void add_group()
{
    GtkWidget *group_window;
    extern GtkWidget *group_receiver_clist;
    add_group_data *add_group;

    add_group = g_malloc(sizeof(*add_group));        
    add_group->refresh_flag = 0;
    add_group->edit_flag = 0;
    add_group->popup_flag = 0;
    group_window = create_groups(add_group, NULL);
    gtk_widget_show(group_window);
    load_generic_list("RECEIVER.dat", GTK_CLIST(group_receiver_clist));
}



GtkWidget*
create_groups (add_group_data *group_data, edit_group_data *e_group_data)
{
  extern  GtkWidget *group_receiver_clist;
  extern  GtkWidget *group_clist;

  GtkWidget *hbox12;
  GtkWidget *scrolledwindow9;
  GtkWidget *group_receivers_label;
  GtkWidget *rec_id_label;
  GtkWidget *vbox15;
  GtkWidget *hbox13;
  GtkWidget *label38;
  GtkWidget *vbuttonbox4;
  GtkWidget *add_button;
  GtkWidget *remove_button;
  GtkWidget *scrolledwindow10;
  GtkWidget *group_member_label;
  GtkWidget *group_id_label;
  GtkWidget *vbox16;
  GtkWidget *vbuttonbox5;
  GtkWidget *save_group_button;
  GtkWidget *cancel_group_button;
  gchar     *line;
  gchar     *group_name = "";
  gint      group_members = 0;
  gint      i = 0;
  uid_list  *temp_array;
  uid_list  *head;

  temp_array = get_uid_node();
  
  if ( group_data->edit_flag )
  {
      group_data->group_id = g_malloc(MAX_FIELD_LENGTH);
      group_name = g_malloc(MAX_FIELD_LENGTH);

      line = get_uid_line("GROUP.dat", e_group_data->group_id, 3, 1, MAX_LENGTH);
      get_name_id(group_data->group_id, group_name, line);
      group_data->group_name_text = g_malloc(MAX_FIELD_LENGTH);
      strcpy(group_data->group_name_text, group_name);

      g_free(line);
  }


  group_data->groups = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (group_data->groups), "group_data->groups", group_data->groups);
  gtk_widget_set_usize (group_data->groups, 640, 350);

  if (group_data->edit_flag || group_data->popup_flag)
      gtk_window_set_title (GTK_WINDOW (group_data->groups), "Edit Group");
  else
      gtk_window_set_title (GTK_WINDOW (group_data->groups), "Add Group");

  gtk_window_set_modal (GTK_WINDOW (group_data->groups), TRUE);
  gtk_window_set_policy (GTK_WINDOW (group_data->groups), FALSE, FALSE, FALSE);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_container_add (GTK_CONTAINER (group_data->groups), hbox12);
  gtk_widget_set_usize (hbox12, 430, 168);

  scrolledwindow9 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow9);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "scrolledwindow9", scrolledwindow9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow9);
  gtk_box_pack_start (GTK_BOX (hbox12), scrolledwindow9, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow9, 150, 100);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow9), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  group_receiver_clist = gtk_clist_new (2);
  gtk_clist_set_column_visibility (GTK_CLIST(group_receiver_clist), 0, FALSE);
  gtk_clist_set_sort_column (GTK_CLIST(group_receiver_clist), 1);
  gtk_clist_set_auto_sort(GTK_CLIST(group_receiver_clist), TRUE);
  gtk_widget_ref (group_receiver_clist);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "group_receiver_clist", group_receiver_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_receiver_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow9), group_receiver_clist);
  gtk_widget_set_usize (group_receiver_clist, 179, 100);
  gtk_clist_set_column_width (GTK_CLIST (group_receiver_clist), 0, 10);
  gtk_clist_set_column_width (GTK_CLIST (group_receiver_clist), 1, 100);
  gtk_clist_set_selection_mode (GTK_CLIST (group_receiver_clist), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (group_receiver_clist));

  rec_id_label = gtk_label_new ("");
  gtk_widget_ref (rec_id_label);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "rec_id_label", rec_id_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_clist_set_column_widget (GTK_CLIST (group_receiver_clist), 0, rec_id_label);

  group_receivers_label = gtk_label_new ("Receivers");
  gtk_widget_ref (group_receivers_label);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "group_receivers_label", group_receivers_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_receivers_label);
  gtk_clist_set_column_widget (GTK_CLIST (group_receiver_clist), 1, group_receivers_label);
  gtk_label_set_justify (GTK_LABEL (group_receivers_label), GTK_JUSTIFY_LEFT);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox15);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "vbox15", vbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox15);
  gtk_box_pack_start (GTK_BOX (hbox12), vbox15, TRUE, TRUE, 0);
  gtk_widget_set_usize (vbox15, 100, 95);

  hbox13 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox15), hbox13, TRUE, FALSE, 0);

  label38 = gtk_label_new ("Name:");
  gtk_widget_ref (label38);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "label38", label38,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label38);
  gtk_box_pack_start (GTK_BOX (hbox13), label38, FALSE, FALSE, 5);

  group_data->group_name = gtk_entry_new_with_max_length (50);

  if ( group_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(group_data->group_name), group_name);

  gtk_widget_ref (group_data->group_name);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "group_data->group_name", group_data->group_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_data->group_name);
  gtk_box_pack_start (GTK_BOX (hbox13), group_data->group_name, TRUE, TRUE, 4);
  gtk_widget_set_usize (group_data->group_name, 50, 21);

  vbuttonbox4 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox4);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "vbuttonbox4", vbuttonbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox4);
  gtk_box_pack_start (GTK_BOX (vbox15), vbuttonbox4, TRUE, FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox4), GTK_BUTTONBOX_START);

  add_button = gtk_button_new_with_label ("Add\n-->");
  gtk_widget_ref (add_button);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "add_button", add_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox4), add_button);
  GTK_WIDGET_SET_FLAGS (add_button, GTK_CAN_DEFAULT);

  remove_button = gtk_button_new_with_label ("Remove\n<--");
  gtk_widget_ref (remove_button);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "remove_button", remove_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (remove_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox4), remove_button);
  GTK_WIDGET_SET_FLAGS (remove_button, GTK_CAN_DEFAULT);

  scrolledwindow10 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow10);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "scrolledwindow10", scrolledwindow10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow10);
  gtk_box_pack_start (GTK_BOX (hbox12), scrolledwindow10, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow10, 150, -2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow10), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  group_clist = gtk_clist_new (2);
  gtk_clist_set_column_visibility (GTK_CLIST(group_clist), 0, FALSE);
  gtk_clist_set_sort_column (GTK_CLIST(group_clist), 1);
  gtk_clist_set_auto_sort(GTK_CLIST(group_clist), TRUE);

  gtk_widget_ref (group_clist);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "group_clist", group_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_clist);

/*
 *  Load the receivers into the list if we are editing a group
 */

  if ( group_data->edit_flag )
  {
      head = temp_array;
      group_members = parse_group(group_data->group_id, temp_array);
      temp_array = head;
      for ( i = 0; i < group_members; i++)
      {
	  load_group_list( atoi(temp_array->uid), GTK_CLIST(group_clist));
	  temp_array = temp_array->next;
      }
  }

  gtk_container_add (GTK_CONTAINER (scrolledwindow10), group_clist);
  gtk_widget_set_usize (group_clist, 179, 100);
  gtk_clist_set_column_width (GTK_CLIST (group_clist), 0, 10);
  gtk_clist_set_column_width (GTK_CLIST (group_clist), 1, 100);
  gtk_clist_set_selection_mode (GTK_CLIST (group_clist), GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_show (GTK_CLIST (group_clist));

  group_member_label = gtk_label_new ("Group Members");
  gtk_widget_ref (group_member_label);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "group_member_label", group_member_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_member_label);
  gtk_clist_set_column_widget (GTK_CLIST (group_clist), 1, group_member_label);
  gtk_label_set_justify (GTK_LABEL (group_member_label), GTK_JUSTIFY_LEFT);

  group_id_label = gtk_label_new ("");
  gtk_widget_ref (group_id_label);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "group_id_label", group_id_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_clist_set_column_widget (GTK_CLIST (group_clist), 0, group_id_label);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_box_pack_start (GTK_BOX (hbox12), vbox16, TRUE, TRUE, 0);
  gtk_widget_set_usize (vbox16, 40, 168);

  vbuttonbox5 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox5);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "vbuttonbox5", vbuttonbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox5);
  gtk_box_pack_start (GTK_BOX (vbox16), vbuttonbox5, TRUE, TRUE, 0);
  gtk_widget_set_usize (vbuttonbox5, 60, -2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox5), GTK_BUTTONBOX_SPREAD);

  save_group_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (save_group_button);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "save_group_button", save_group_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_group_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox5), save_group_button);
  GTK_WIDGET_SET_FLAGS (save_group_button, GTK_CAN_DEFAULT);

  cancel_group_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_group_button);
  gtk_object_set_data_full (GTK_OBJECT (group_data->groups), "cancel_group_button", cancel_group_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_group_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox5), cancel_group_button);
  GTK_WIDGET_SET_FLAGS (cancel_group_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (group_data->group_name), "changed",
                      GTK_SIGNAL_FUNC (on_group_name_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (add_button), "clicked",
                      GTK_SIGNAL_FUNC (on_add_group_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (remove_button), "clicked",
                      GTK_SIGNAL_FUNC (on_remove_group_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (save_group_button), "clicked",
                      GTK_SIGNAL_FUNC (on_save_group_button_clicked),
                      group_data);
  gtk_signal_connect (GTK_OBJECT (cancel_group_button), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_group_button_clicked),
                      group_data);

  gtk_widget_grab_focus(cancel_group_button);

  if ( group_data->edit_flag || group_data->popup_flag)
  {
      g_free(e_group_data->group_id);
      g_free(e_group_data);
      g_free(group_name);
  }

  return group_data->groups;
}


