/*
 * g-page Copyright (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"


/**************************************************************/
/***                                                        ***/
/***    This function is called by the menu items only      ***/
/***                                                        ***/
/**************************************************************/

void service_call(void)
{
    add_service_function(NULL,  (gpointer) "no_refresh");
}

void add_service_list()
{
    add_service_function(NULL, (gpointer) "service_list_refresh");
}

void add_service_function(GtkWidget *w, gpointer flag)
{
    GtkWidget  *add_service_dialog;
    service   *service_data;

    service_data = g_malloc(sizeof(*service_data));
    service_data->edit_flag = 0;

    if ( !strcmp(flag, "service_list_refresh") )
	service_data->refresh_flag = 1;
    else
	service_data->refresh_flag = 0;

    if ( !strcmp(flag, "refresh") )
	service_data->add_rec_refresh_flag = 1;
    else
	service_data->add_rec_refresh_flag = 0;

    add_service_dialog = create_add_service( (char * ) flag, service_data, NULL);
    gtk_widget_show(add_service_dialog);
}

void edit_service(service_text *edit_service_data)
{
    GtkWidget *add_service_dialog;
    service   *service_data;

    service_data = g_malloc(sizeof(*service_data));
    service_data->edit_flag = 1;
    service_data->add_rec_refresh_flag = 0;
    service_data->refresh_flag = 0;

    add_service_dialog = create_add_service("no_refresh", service_data, edit_service_data);
    gtk_widget_show(add_service_dialog);

    g_free(edit_service_data->service_id);
    g_free(edit_service_data->service_name);
    g_free(edit_service_data->service_number);
    g_free(edit_service_data->service_wctp);
    g_free(edit_service_data->max_msg);
    g_free(edit_service_data->tap_checkbutton);
    g_free(edit_service_data->snpp_checkbutton);
    g_free(edit_service_data->smtp_checkbutton);
    g_free(edit_service_data->snpp_port);
    g_free(edit_service_data->snpp_url);
    g_free(edit_service_data->snpp_password);
    g_free(edit_service_data);

}

GtkWidget*
create_add_service (char *flag, service *service_data, service_text *edit_service_data)
{

  GtkWidget *add_service;
  GtkWidget *vbox8;
  GtkWidget *table3;
  GtkWidget *table_wctp;
  GtkWidget *service_name_label;
  GtkWidget *label23;
  GtkWidget *frame7;
  GtkWidget *frame_wctp;
  GtkWidget *hbox9;
  GtkWidget *hbox10;
  GtkWidget *hbox_wctp;
  GtkWidget *vbox10;
  GtkWidget *frame8;
  GtkWidget *frame_password;
  GtkWidget *table4;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *label_wctp;
  GtkWidget *hbuttonbox4;
  GtkWidget *save_button;
  GtkWidget *cancel_button;
  GSList    *password_group = NULL;
  add_service_window *service_window;

  service_window = g_malloc(sizeof(*service_window));

  add_service = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (add_service), "add_service", add_service);

  gtk_widget_set_usize (add_service, 350, 375);

  if (service_data->edit_flag)
        gtk_window_set_title (GTK_WINDOW (add_service), "Edit Service");
  else
      gtk_window_set_title (GTK_WINDOW (add_service), "Add Service");
  gtk_window_set_modal (GTK_WINDOW (add_service), TRUE);

  service_window->window = add_service;
  service_window->serv_data = service_data;

/*
 *   This is the entry box for the service name and the max msg length
 */

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (add_service), vbox8);

  table3 = gtk_table_new (3, 2, FALSE);
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_box_pack_start (GTK_BOX (vbox8), table3, TRUE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table3), 5);

  service_name_label = gtk_label_new ("Service Name: ");
  gtk_widget_ref (service_name_label);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "service_name_label", service_name_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_name_label);
  gtk_table_attach (GTK_TABLE (table3), service_name_label, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_padding (GTK_MISC (service_name_label), 0, 5);

  /* The service number is now defunct but I'm leaving this here in case it makes a comback */

  label23 = gtk_label_new ("Service Number: ");
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  /* gtk_widget_show (label23); */
  gtk_table_attach (GTK_TABLE (table3), label23, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  service_data->service_name = gtk_entry_new_with_max_length (64);
  gtk_widget_ref (service_data->service_name);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->service_name), edit_service_data->service_name);

  gtk_object_set_data_full (GTK_OBJECT (add_service), "service_name", service_data->service_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->service_name);
  gtk_table_attach (GTK_TABLE (table3), service_data->service_name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  service_data->service_number = gtk_entry_new_with_max_length (64);
  gtk_widget_ref (service_data->service_number);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->service_number), edit_service_data->service_number);

  gtk_object_set_data_full (GTK_OBJECT (add_service), "service_number", service_data->service_number,
                            (GtkDestroyNotify) gtk_widget_unref);
  /* gtk_widget_show (service_data->service_number); */
  gtk_table_attach (GTK_TABLE (table3), service_data->service_number, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label28 = gtk_label_new ("Max msg length: ");
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_table_attach (GTK_TABLE (table3), label28, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_padding (GTK_MISC (label28), 0, 5);

  service_data->max_msg = gtk_entry_new_with_max_length (5);
  gtk_widget_ref (service_data->max_msg);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->max_msg), edit_service_data->max_msg);

  gtk_object_set_data_full (GTK_OBJECT (add_service), "max_msg", service_data->max_msg,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->max_msg);
  gtk_table_attach (GTK_TABLE (table3), service_data->max_msg, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

/*
 *   This is the frame and check boxes for the protocols supported
 */

  frame7 = gtk_frame_new (" Protocols Supported: ");
  gtk_widget_ref (frame7);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "frame7", frame7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame7);
  gtk_box_pack_start (GTK_BOX (vbox8), frame7, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame7), 5);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_container_add (GTK_CONTAINER (frame7), hbox9);

  service_data->tap_checkbutton = gtk_check_button_new_with_label ("WCTP ");
  gtk_widget_ref (service_data->tap_checkbutton);

  if ( service_data->edit_flag)
  {
      if (!strcmp(edit_service_data->tap_checkbutton, "1"))
	  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(service_data->tap_checkbutton), TRUE);
  }

  gtk_object_set_data_full (GTK_OBJECT (add_service), "tap_checkbutton", service_data->tap_checkbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->tap_checkbutton);
  gtk_box_pack_start (GTK_BOX (hbox9), service_data->tap_checkbutton, FALSE, FALSE, 0);

  service_data->snpp_checkbutton = gtk_check_button_new_with_label ("SNPP");
  gtk_widget_ref (service_data->snpp_checkbutton);

  if ( service_data->edit_flag)
  {
      if (!strcmp(edit_service_data->snpp_checkbutton, "1"))
	  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(service_data->snpp_checkbutton), TRUE);
  }


  gtk_object_set_data_full (GTK_OBJECT (add_service), "snpp_checkbutton", service_data->snpp_checkbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->snpp_checkbutton);
  gtk_box_pack_start (GTK_BOX (hbox9), service_data->snpp_checkbutton, FALSE, FALSE, 0);

  service_data->smtp_checkbutton = gtk_check_button_new_with_label ("SMTP");
  gtk_widget_ref (service_data->smtp_checkbutton);

  if ( service_data->edit_flag)
  {
      if (!strcmp(edit_service_data->smtp_checkbutton, "1"))
	  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(service_data->smtp_checkbutton), TRUE);
  }

  else
      gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(service_data->smtp_checkbutton), FALSE);


  gtk_object_set_data_full (GTK_OBJECT (add_service), "smtp_checkbutton", service_data->smtp_checkbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->smtp_checkbutton);
  gtk_box_pack_start (GTK_BOX (hbox9), service_data->smtp_checkbutton, FALSE, FALSE, 0);

/*
 *   This is the frame and entry box for the WCTP Url
 */

  frame_wctp = gtk_frame_new (" WCTP Setup  ");
  gtk_widget_ref (frame_wctp);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "frame_wctp", frame_wctp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_wctp);
  gtk_box_pack_start (GTK_BOX (vbox8), frame_wctp, TRUE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_wctp), 5);

  hbox_wctp = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_wctp);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "hbox_wctp", hbox_wctp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_wctp);
  gtk_container_add (GTK_CONTAINER (frame_wctp), hbox_wctp);

  table_wctp = gtk_table_new (1, 2, FALSE);
  gtk_widget_ref (table_wctp);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "table_wctp", table_wctp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table_wctp);
  gtk_box_pack_start (GTK_BOX (hbox_wctp), table_wctp, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table_wctp), 5);

  label_wctp = gtk_label_new ("WCTP Url: ");
  gtk_widget_ref (label_wctp);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "label_wctp", label_wctp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_wctp);
  gtk_table_attach (GTK_TABLE (table_wctp), label_wctp, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_padding (GTK_MISC (label_wctp), 0, 0);


  service_data->service_wctp = gtk_entry_new_with_max_length (64);
  gtk_widget_ref (service_data->service_wctp);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "service_wctp", service_data->service_wctp,
                            (GtkDestroyNotify) gtk_widget_unref);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->service_wctp), edit_service_data->service_wctp);
  else
      gtk_entry_set_text( GTK_ENTRY(service_data->service_wctp), "http://");

  gtk_widget_show (service_data->service_wctp);
  gtk_table_attach (GTK_TABLE (table_wctp), service_data->service_wctp, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

/*
 *   This is the frame and radio buttons for the snpp password option
 */


  frame_password = gtk_frame_new (" Does this service require a password? ");
  gtk_widget_ref (frame_password);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "frame_password", frame_password,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_password);
  gtk_box_pack_start (GTK_BOX (vbox8), frame_password, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_password), 5);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (frame_password), hbox10);

  service_data->password_checkbutton_yes = gtk_radio_button_new_with_label (password_group, " Yes");
  password_group = gtk_radio_button_group (GTK_RADIO_BUTTON (service_data->password_checkbutton_yes));
  gtk_widget_ref (service_data->password_checkbutton_yes);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "service_data->password_checkbutton_yes", service_data->password_checkbutton_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->password_checkbutton_yes);
  gtk_box_pack_start (GTK_BOX (hbox10), service_data->password_checkbutton_yes, FALSE, FALSE, 0);

  service_data->password_checkbutton_no = gtk_radio_button_new_with_label (password_group, " No");
  password_group = gtk_radio_button_group (GTK_RADIO_BUTTON (service_data->password_checkbutton_no));
  gtk_widget_ref (service_data->password_checkbutton_no);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "service_data->password_checkbutton_no", service_data->password_checkbutton_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->password_checkbutton_no);
  gtk_box_pack_start (GTK_BOX (hbox10), service_data->password_checkbutton_no, FALSE, FALSE, 0);

  if ( service_data->edit_flag)
  {
      if (!strcmp(edit_service_data->password_checkbutton_yes, "1"))
	  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(service_data->password_checkbutton_yes), TRUE);
      else
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (service_data->password_checkbutton_no), TRUE);
  }
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (service_data->password_checkbutton_no), TRUE);

/*
 *   This is the frame and entry boxes for the SNPP setup
 */

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (vbox8), vbox10, TRUE, TRUE, 0);

  frame8 = gtk_frame_new (" SNPP Setup ");
  gtk_widget_ref (frame8);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "frame8", frame8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame8);
  gtk_box_pack_start (GTK_BOX (vbox10), frame8, TRUE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame8), 5);

  table4 = gtk_table_new (3, 2, FALSE);
  gtk_widget_ref (table4);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "table4", table4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table4);
  gtk_container_add (GTK_CONTAINER (frame8), table4);

  label25 = gtk_label_new (" Address: ");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_table_attach (GTK_TABLE (table4), label25, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label26 = gtk_label_new (" Port: ");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_table_attach (GTK_TABLE (table4), label26, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label27 = gtk_label_new (" Password: ");
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_table_attach (GTK_TABLE (table4), label27, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  service_data->snpp_port = gtk_entry_new_with_max_length (16);
  gtk_widget_ref (service_data->snpp_port);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->snpp_port), edit_service_data->snpp_port);

  gtk_object_set_data_full (GTK_OBJECT (add_service), "snpp_port", service_data->snpp_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->snpp_port);
  gtk_table_attach (GTK_TABLE (table4), service_data->snpp_port, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  service_data->snpp_url = gtk_entry_new_with_max_length (64);
  gtk_widget_ref (service_data->snpp_url);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->snpp_url), edit_service_data->snpp_url);

  gtk_object_set_data_full (GTK_OBJECT (add_service), "snpp_url", service_data->snpp_url,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->snpp_url);
  gtk_table_attach (GTK_TABLE (table4), service_data->snpp_url, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

  service_data->snpp_password = gtk_entry_new_with_max_length (64);
  gtk_widget_ref (service_data->snpp_password);

  if ( service_data->edit_flag)
      gtk_entry_set_text( GTK_ENTRY(service_data->snpp_password), edit_service_data->snpp_password);

  gtk_object_set_data_full (GTK_OBJECT (add_service), "snpp_password", service_data->snpp_password,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_data->snpp_password);
  gtk_table_attach (GTK_TABLE (table4), service_data->snpp_password, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 2, 2);

/*
 *   This is the save and cancel buttons
 */

  hbuttonbox4 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox4);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "hbuttonbox4", hbuttonbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox4);
  gtk_box_pack_start (GTK_BOX (vbox10), hbuttonbox4, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox4), GTK_BUTTONBOX_SPREAD);

  save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (save_button);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "save_button", save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), save_button);
  GTK_WIDGET_SET_FLAGS (save_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (add_service), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), cancel_button);
  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);


  gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_save_button_clicked),
                      service_window);


  if (service_data->edit_flag)
      gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			  GTK_SIGNAL_FUNC (on_cancel_button_clicked_unselect),
			  NULL);
	
  gtk_signal_connect_object (GTK_OBJECT (cancel_button), "clicked",
			     GTK_SIGNAL_FUNC (on_cancel_button_clicked),
			     GTK_OBJECT(add_service));

  gtk_widget_grab_focus (cancel_button);
  return add_service;
}



