/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

extern GtkWidget *receiver_clist;
extern GtkWidget *service_clist;
extern GtkWidget *text_entry;

void delete_item_popup(GtkWidget *w, gchar *id)
{
    if ( id[0] == 'G' )
	confirm_group_delete_popup(id);
    else
	confirm_receiver_delete_popup(id);
}

void exit_from_menu()
{
    check_for_exit(NULL, NULL);
}


void check_for_exit(GtkButton *b, gpointer userdata)
{
    GtkWidget  *exit_confirm;

    if ( get_status_script_page() )
    {
	exit_confirm = exit_anyway();
	gtk_widget_show(exit_confirm);
    }
    else
	exit_button_clicked(NULL, NULL);

}

void
exit_button_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

    extern char       named_pipe[32];  

    unlink(named_pipe); 
    gtk_main_quit();
    exit(EXIT_SUCCESS);
}

void clear_text()
{
    clear_button_clicked(NULL, GTK_EDITABLE(text_entry));
}

void clear_button_clicked (GtkButton *button, gpointer user_data)
{
    extern  GtkWidget  *receiver_clist;

    int text_length = 0;
    char *buff = "Ready";

    text_length = gtk_text_get_length( GTK_TEXT(text_entry) );
    gtk_text_set_point( GTK_TEXT( text_entry) , 0 );
    gtk_text_forward_delete ( GTK_TEXT(text_entry), text_length );
    gtk_widget_grab_focus (text_entry);
    update_status_line(buff);
    count_receivers(receiver_clist, 0,0,NULL, NULL);
    //update_status_line_small(" ");
}
 
void
text_entry_changed                     (GtkEditable     *editable,
                                        gpointer         user_data)
{
    extern   gint       sig_length;
    extern   GtkWidget  *receiver_clist;
    int                 text_length = 0;
    int                 temp;
    char                *buff;

    text_length = gtk_text_get_length( GTK_TEXT(text_entry) );

    if ( text_length == 1 )
	count_receivers(receiver_clist, 0,0,NULL, NULL);

    if ( text_length > MAX_PAGE_LENGTH )
    {
	gtk_text_set_point( GTK_TEXT( text_entry) , text_length );
	temp = text_length - MAX_PAGE_LENGTH;
	gtk_text_backward_delete ( GTK_TEXT(text_entry), temp );

	text_length = gtk_text_get_length( GTK_TEXT(text_entry) );
	buff = g_strdup_printf("You have reached the character limit. Characters to send: %d", text_length);
	
	update_status_line(buff);
	return;
    }	
    text_length += sig_length;
    buff = g_strdup_printf("Characters to send: %d", text_length);
    update_status_line(buff);
    //update_status_line_small(" ");
    g_free(buff);
}

void clear_list(GtkCList *list)
{

  if (list)
      gtk_clist_clear( (GtkCList *)list);  
  
}

void
qpage_active                          (GtkToggleButton *togglebutton,
                                          gpointer         user_data)
{
    edit_item("qpage_active", "CONFIG.dat", 2, 1, "qpage_active=yes\n", EDIT, '=');
}

void
qpage_disabled                          (GtkToggleButton *togglebutton,
                                          gpointer         user_data)
{
    edit_item("qpage_active", "CONFIG.dat", 2, 1, "qpage_active=no\n", EDIT, '=');
}




