/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"

typedef struct {
    GtkWidget *receiver_name;
    GtkWidget *receiver_number;
    GtkWidget *checkbutton_wctp;
    GtkWidget *checkbutton_snpp;
    GtkWidget *checkbutton_smtp;
    GtkWidget *receiver_smtp;
    GtkWidget *radio_wctp_one_way;
    GtkWidget *radio_wctp_respond_read;
    GtkWidget *radio_wctp_query_response;
    GtkWidget *radio_wctp_two_way;
    GtkWidget *radio_snpp_one_way;
    GtkWidget  *radio_snpp_respond_read;
    GtkWidget *radio_snpp_two_way;
    GtkWidget *autosplit_yes_radio_button;
    GtkWidget *autosplit_no_radio_button;
    GtkWidget *msg_method_1;
    GtkWidget *msg_method_2;
    GtkWidget *msg_method_3;
    gchar     *uid;
    gchar     *sid;
    gchar     *autosplit;
    gint      edit_flag;
    gint      refresh_list_flag;
    gint      popup_flag;    
} receiver;

typedef struct {
    gchar     *receiver_name;
    gchar     *receiver_number;
    gchar     *checkbutton_wctp;
    gchar     *checkbutton_snpp;
    gchar     *checkbutton_smtp;
    gchar     *receiver_smtp;
    gchar     *radio_wctp_one_way;
    gchar     *radio_wctp_respond_read;
    gchar     *radio_wctp_query_response;
    gchar     *radio_wctp_two_way;
    gchar     *radio_snpp_one_way;
    gchar     *radio_snpp_respond_read;
    gchar     *radio_snpp_two_way;
    gchar     *autosplit_yes_radio_button;
    gchar     *autosplit_no_radio_button;
    gchar     *msg_method_1;
    gchar     *msg_method_2;
    gchar     *msg_method_3;
    gchar     *uid;
    gchar     *sid;
    gchar     *autosplit;
    gint      edit_flag;
    gint      refresh_list_flag;
    gint      popup_flag;
} receiver_text;


typedef struct {
    GtkWidget *service_id;
    GtkWidget *service_name;
    GtkWidget *service_wctp;
    GtkWidget *service_number;
    GtkWidget *max_msg;
    GtkWidget *tap_checkbutton;
    GtkWidget *snpp_checkbutton;
    GtkWidget *smtp_checkbutton;
    GtkWidget *password_checkbutton_no;
    GtkWidget *password_checkbutton_yes;
    GtkWidget *snpp_port;
    GtkWidget *snpp_url;
    GtkWidget *snpp_password;
    gint       edit_flag;
    gint       refresh_flag;
    gint       add_rec_refresh_flag;
}service;

typedef struct {
    gchar *service_id;
    gchar *service_name;
    gchar *service_wctp;
    gchar *service_number;
    gchar *max_msg;
    gchar *tap_checkbutton;
    gchar *snpp_checkbutton;
    gchar *smtp_checkbutton;
    gchar *password_checkbutton_no;
    gchar *password_checkbutton_yes;
    gchar *snpp_port;
    gchar *snpp_url;
    gchar *snpp_password;
    gint  edit_flag;
    gint  refresh_flag;
    gint  add_rec_refresh_flag;
}service_text;

typedef  struct {
      GtkWidget *window;
      receiver  *rec_data;
}window_data;

typedef struct {
    GtkWidget *window;
    service   *serv_data;
}add_service_window;

typedef struct {
    GtkWidget  *port;
    GtkWidget  *ip_address;
    GtkWidget  *timeout;
    GtkWidget  *isp_domain;
    GtkWidget  *isp_email_domain;
    GtkWidget  *email_adr;
    GtkWidget  *main_window;
}config_data_struct;

typedef struct {
    GtkWidget  *groups;
    GtkWidget  *group_name;
    gchar      *group_name_text;
    gchar      *group_id;
    gint       edit_flag;
    gint       refresh_flag;
    gint       popup_flag;
}add_group_data;

typedef struct {
    GtkWidget    *groups;
    gchar        *group_name;
    gchar        *group_id;
    gint         edit_flag;
    gint         refresh_flag;
    gint         popup_flag;
}edit_group_data;

typedef struct {
    GtkWidget *log_window;
    GtkWidget *radiobutton_date;
    GtkWidget *radiobutton_name;
    GtkWidget *log_list_clist;
    gint       date;
}log_window_data;

typedef struct {
    GtkWidget  *st_bar;
    GtkWidget  *main_window;
    GtkWidget  *text_box;
    gint       s_options;
}log_status_bar_data;

typedef struct list {
    gchar   *name;
    gint    count;
    gint    hash;
    struct list *next;
}list;


typedef struct {
    GtkWidget   *main;
    GtkWidget   *dir_label;
    GtkWidget   *radio_auto_yes;
    GtkWidget   *radio_auto_no;
    GtkWidget   *spin_num_days;
    GtkWidget   *radio_sig_yes;
    GtkWidget   *radio_sig_no;
    GtkWidget   *radio_sig_before;
    GtkWidget   *radio_sig_after;
    GtkWidget   *signature;
    GtkWidget   *time_stamp_yes;
    GtkWidget   *time_stamp_no;
    GtkWidget   *cc_email_yes;
    GtkWidget   *cc_email_no;
    GtkWidget   *set_protocols_yes;
    GtkWidget   *set_protocols_no;
    GtkWidget   *wctp_one;
    GtkWidget   *wctp_two;
    GtkWidget   *wctp_three;
    GtkWidget   *snpp_one;
    GtkWidget   *snpp_two;
    GtkWidget   *snpp_three;
    GtkWidget   *smtp_one;
    GtkWidget   *smtp_two;
    GtkWidget   *smtp_three;
    GtkWidget   *show_options_yes;
    GtkWidget   *show_options_no;
    GtkWidget   *qpage_adr;
    GtkWidget   *qpage_port;
    GtkWidget   *interface_widget;
    GtkWidget   *status_yes;
    GtkWidget   *status_no;
    GtkWidget   *connect_yes;
    GtkWidget   *connect_no;
    GtkWidget   *asynch_mode;
    GtkWidget   *serial_mode;
    GtkWidget   *script_delay;
    GtkWidget   *default_polling;
    GtkWidget   *retries;
    GtkWidget   *radio_local;
    GtkWidget   *radio_network;
    GtkWidget   *database_adr;
    GtkWidget   *update_interval;
    GtkWidget   *db_port;
    GtkWidget   *log_delete_poll;
    GtkWidget   *msg_entry_options_always;
    GtkWidget   *msg_entry_options_never;
    GtkWidget   *msg_entry_options_success;
    GtkWidget   *create_error_status_yes;
    GtkWidget   *create_error_status_no;
    GtkWidget   *rollover_yes;
    GtkWidget   *rollover_no;

}pref_widgets;

typedef struct {
    GtkWidget     *main;
    gchar         *current_dir;
    gchar         *log_delete;
    gchar         *days_before_delete;
    gchar         *signature_yes_no;
    gchar         *signature_before;
    gchar         *signature;
    gchar         *cc_email;
    gchar         *set_protocols;
    gchar         *order_of_protocols;
    gchar         *show_options;
    gchar         *qpage_adr;
    gchar         *qpage_port;
    gchar         *show_status;
    gchar         *asynch_mode;
    gchar         *serial_mode;
    gchar         *time_stamp;
    gchar         *script_delay;
    gchar         *default_polling;
    gchar         *retries;
    gchar         *msg_entry_options;
    gchar         *database_location;
    gchar         *database_adr;
    gchar         *update_interval;
    gchar         *db_port;
    gchar         *log_delete_poll;
    gchar         *rollover;
    gchar         *connect_yes;
    gchar         *create_error_status_file;
    pref_widgets  *prefs;
}pref_data;

typedef struct {
    GtkWidget *main_db_box;
    GtkWidget *auto_delete_logs_box;
    GtkWidget *signature_box;
    GtkWidget *protocols_box;
    GtkWidget *auto_page_box;
    GtkWidget *msg_entry_box;
    GtkWidget *advanced_box;
    GtkWidget *advanced_box_sending;
    GtkWidget *advanced_box_qpage;
    GtkWidget *active_box;
    GtkWidget *vbox_network_settings;
    gchar     *data;
}dynamic_box_data;

typedef struct {
    GtkWidget *main_window;
    GtkWidget *msg_list;
    GtkWidget *msg_text_box;
}stored_msg;

typedef struct {
    GtkWidget *cal;
    GtkWidget *main_win;
    GtkWidget *am_sch;
    GtkWidget *hour;
    GtkWidget *minutes;
    GtkWidget *radio_no;
    GtkWidget *radio_hourly;
    GtkWidget *radio_daily;
    GtkWidget *radio_weekly;
}sched_msg_info;

typedef struct {
    gchar  *sch_time;
    gchar  *sch_msg;
}sched_data;

typedef struct {
    gchar   *status;
    gchar   *error_msg;
    gint    action;
}sched_update;

typedef struct {
    GtkWidget   *text_box;
    GtkWidget   *clist;
    GtkWidget   *count_label;
    GtkWidget   *time_label;
    GtkWidget   *main_win;
}sched_win_data;

typedef struct {
    gchar     *year;
    gchar     *month;
    gchar     *date;
    gchar     *hour_spin;
    gchar     *minute_spin;
    gchar     *am_pm_radio;
    gchar     *how_often;
    gchar     *manual_time;
    gchar     *script_entry;
    gchar     *target_entry;
    gchar     *rename_delete_ignore;
    gchar     *manual_user;
    gchar     *all_or_parse;
    gchar     *number_of_fields;
    gchar     *one_start;
    gchar     *one_end;
    gchar     *two_start;
    gchar     *two_end;
    gchar     *three_start;
    gchar     *three_end;
    gchar     *four_start;
    gchar     *four_end;
    gchar     *send_to;
    gint      fix_time_flag;
    gint      run_flag;
    gint      run_status;
}script_text;

typedef struct {
    GtkWidget *script_page;
    GtkWidget *auto_calender;
    GtkWidget *hour_spin;
    GtkWidget *minute_spin;
    GtkWidget *am_radio;
    GtkWidget *pm_radio;
    GtkWidget *once_radio;
    GtkWidget *hourly_radio;
    GtkWidget *daily_radio;
    GtkWidget *manual_radio;
    GtkWidget *interval_spin;
    GtkWidget *script_entry;
    GtkWidget *browse_script_button;
    GtkWidget *browse_script_button1;
    GtkWidget *target_entry;
    GtkWidget *rename_radio;
    GtkWidget *delete_radio;
    GtkWidget *ignore_radio;
    GtkWidget *select_user_radio;
    GtkWidget *manual_user_radio;
    GtkWidget *send_all_radio;
    GtkWidget *define_fields_radio;
    GtkWidget *fields_spin;
    GtkWidget *one_start;
    GtkWidget *one_end;
    GtkWidget *two_start;
    GtkWidget *two_end;
    GtkWidget *three_start;
    GtkWidget *three_end;
    GtkWidget *four_start;
    GtkWidget *four_end;
    GtkWidget *browse_users_button;
    GtkWidget *auto_save_button;
    GtkWidget *auto_cancel_button;
    GtkWidget *data_clist;
    GtkWidget *profile_save_widget;
    GtkWidget *profile_save_dialog;
    gint      run_flag;
    gchar     *profile_name;
    script_text  *active_script;
}script_data;

typedef struct list_tag {
    gchar     *uid;
    struct list_tag  *next;
}uid_list;

typedef struct {
    gint        sock;
    uid_list    *active_uids;
    gchar       *msg;
    gchar       *sched_msg;
    gchar       *tracking_number;
    sched_data  *sched_obj;
    gint        mode;
    gint        fd;
}pg_data;

typedef struct {
    GtkWidget   *label;
    GtkWidget   *spinbox;
}manual_widgets;

typedef struct {
    GtkWidget *main_win;
    GtkWidget  *list;
    GtkWidget  *box;
    GtkWidget  *entry1;
    GtkWidget  *entry2;
    GtkWidget  *entry3;
    GtkWidget  *red_button;
    GtkWidget  *green_button;
    gchar      *edit_string;
    gint       edit_flag;
}response_info;

typedef struct {
    GtkWidget  *pending_clist;
    GtkWidget  *old_clist;
    GtkWidget  *status_label;
    GtkWidget  *tracking_number;
    GtkWidget  *reply_box;
    gchar      *msg;
    gchar      *track;
    gint       file_desc;
    gint       write_file_desc;
} reply_info;

typedef struct {
    GtkWidget  *new_list;
    GtkWidget  *old_list;
    GtkWidget  *text_box;
    GtkWidget  *reply_box;
}update_text;

typedef struct {
    GtkWidget   *main_win;
    reply_info  *reply_data;
    update_text *text_info;
}window_info;

GtkWidget*
create_scheduled_paging (void);

typedef void Sigfunc (int);	

void sig_child(int signo);

void count_receivers(GtkWidget *rec_list, gint row, gint column, GdkEventButton *event, gpointer data);

/*****************************************************************************/
/*

main.c

*/
/*****************************************************************************/

int initialize_main();
gint destroy_event( GtkWidget *widget, GdkEvent  *event, gpointer  data );
Sigfunc *Signal(int signo, Sigfunc *func);
void check_server();
gint automated_check_for_log_delete();

/*****************************************************************************/
/*

my_functions.c

*/
/*****************************************************************************/

void load_receiver_list(gchar *filename, GtkCList *generic_clist);
void load_generic_list(gchar *filename, GtkCList *generic_clist);
void send_text();
void get_text(GtkWidget *w, gpointer *text_data);
char *clean_text(char *buffer);
void load_list_clist(GtkCList *list);
void load_list_service(GtkCList *list);
int get_id(char *group);
int recycle_id(char *group, char *id);
void update_status_line(char *data);
void load_group_list(gint rec_id, GtkCList *generic_clist);
gint parse_group(gchar *id, uid_list *current_uid);
void  load_group_tree(GtkWidget *tree);
GtkCTreeNode *make_node(GtkWidget *tree_widget, GtkCTreeNode *parent, GtkCTreeNode *sibling, gchar *id, gchar *name);
void  get_name_id(gchar *id, gchar *name, gchar *line);
gchar  *clean_string(gchar *buffer);
gint handle_auto_log_delete();
void  delete_logs(gchar *mark);
gchar  *handle_mem(gchar *function, gint size, gchar *action, gchar *id, gchar *var);
gint   load_scheduled_pages(GtkWidget *schedule_clist);
gint  parse_line(gchar *line, gchar *id, gchar *sch_id, gchar *s_time, gchar *msg, gchar *recur, gchar *count, gint flag);
void load_main_list_with_pixmaps();
void update_status_line_small(char *data);
uid_list *load_members(void);
uid_list *get_uid_node();
void load_pending_clist(GtkWidget *list);
gint get_data(gchar *line, gchar *date, gint date_length, gchar *id, gint id_length, gchar *status, gint status_length, 
	      gchar *name, gint name_length, gchar *protocol, gint protocol_length, gchar *tracking, gint tracking_length, gchar *msg, gint msg_length);

void load_old_clist(GtkWidget *list);
void  delete_text_in_text_box(GtkWidget *text_box);

/*****************************************************************************/
/*

message_transactions.c

*/
/*****************************************************************************/

void  monitor_message_transactions(int socket_fd, char *pg_message, gint file_desc, gint gui_mode);
void log_all(char *data_buffer);
void  save_for_logging(char *buffer, int flag, gint file_desc);
void remove_carrige_return(gchar *buffer);

/*****************************************************************************/
/*

callbacks.c

*/
/*****************************************************************************/

void exit_from_menu();
void check_for_exit(GtkButton *b, gpointer userdata);
void delete_item_popup(GtkWidget *w, gchar *id);
void
exit_button_clicked                    (GtkButton       *button,
                                      gpointer         user_data);

void clear_text();
void clear_button_clicked (GtkButton *button, gpointer user_data);

void
text_entry_changed                     (GtkEditable     *editable,
                                        gpointer         user_data);

void
qpage_active                          (GtkToggleButton *togglebutton,
				       gpointer         user_data);

void
qpage_disabled                          (GtkToggleButton *togglebutton,
					 gpointer         user_data);


/*****************************************************************************/
/*

add_receiver_callbacks.c

*/
/*****************************************************************************/

void
on_save_receiver_button_clicked        (GtkButton       *button,
                                        window_data     *win_data);

void on_cancel_receiver_button_clicked  (GtkWidget *window, window_data  *user_data);
void on_cancel_receiver_unselect (GtkWidget    *window, window_data *user_data);


/*****************************************************************************/
/*

add_service_callbacks.c

*/
/*****************************************************************************/

void
on_save_button_clicked                 (GtkButton           *button,
                                        add_service_window  *s_data);

void
on_cancel_button_clicked               (GtkWidget       *window,
                                        service        *user_data);


void on_cancel_button_clicked_unselect (GtkWidget *window, service *user_data);

int is_empty_string(gchar *string, gchar *error_msg);

/*****************************************************************************/
/*

list_receiver_callbacks.c

*/
/*****************************************************************************/

void copy_receiver_entry(GtkButton  *button, gpointer user_data);

void
on_add_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_edit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_okay_button_clicked                 (GtkWidget       *windwo,
                                        gpointer         user_data);

void
on_list_cancel_button_clicked               (GtkWidget       *window,
                                        gpointer         user_data);

void
on_delete_button_clicked                 (GtkWidget       *confirm_box,
                                        gpointer         user_data);

void  delete_receiver_from_groups(gchar *receiver_id);
void confirm_receiver_delete(void);
void confirm_receiver_delete_popup(gchar *id);
void delete_receiver_popup(GtkWidget *w, gchar *id);
void on_click_column(GtkWidget *w, gint col, gpointer data);

/*****************************************************************************/
/*

client_process.c

*/
/*****************************************************************************/

void write_to_status_line(char *status);
void sig_child(int signo);
void connect_to_server(uid_list *active_list, gchar *msg, gchar *sched_msg, sched_data *sched_obj, int mode, gchar *tracking_number, gint file_desc);

/*****************************************************************************/
/*

client_connect.c

*/
/*****************************************************************************/

gint server_connection(gint mode);
void free_the_mem(gchar *one, gchar *two, gchar *three);

/*****************************************************************************/
/*

data_base_functions.c

*/
/*****************************************************************************/

int  add_data(char *str, char *file_name);
int  match_in_string(char buffer[MAX_LENGTH], char *match, int fields, int match_field, char delimiter);
int  edit_item(char *item_id, char *file_name, int number_of_fields, int item_field, char *new_string, int action_flag, char delimiter);
gchar  *read_file_by_line(FILE *fp);
int  get_fields_from_string(char *return_string[NUM_FIELDS], char string_to_parse[MAX_LENGTH], int num_fields, char delimiter);
gchar  *get_resource_data(gchar *filename, gchar *match, gint max_size);
gint delete_receivers_with_service_id(char *service_id);
char *get_field(char buffer[MAX_FIELD_LENGTH], int number_of_fields, int field);

//void get_uid_line(char *file_name, char *uid, char *line, int num_fields, gint group_flag);
gchar *get_uid_line(gchar *file_name, gchar *uid, gint num_fields, gint group_flag, gint mem_size);

gchar  *read_big_file_by_line(FILE *fp, gint mem_size);
FILE *get_file_pointer(char *file_name, char *options);
gchar *get_config_path();
FILE  *get_temp_file();
gchar *get_working_dir();
void sys_error(gchar *error_msg, gint action);
int get_network_database();
gint network_db_refresh();
int connect_no_block(int sockfd, struct sockaddr *serv_addr, int addrlen, int timeout);

/*****************************************************************************/
/*

client_send.c

*/
/*****************************************************************************/

void load_string(char *buffer, char data_to_copy[MAX_LENGTH]);
int commit_transaction(int socket_fp, char *buffer);
void die(char *message);
void log_for_debug(char *buffer);
void log_schedule_data(gchar *time_data, gchar *sch_id, gchar *sch_msg, gchar *receiver);
int send_page(int socket_fd, uid_list *active_list, char *message, gchar *sched_msg, sched_data *sched_obj, gint mode, gchar *tracking_number, gint fd);

/*****************************************************************************/
/*

add_receiver.c

*/
/*****************************************************************************/

void receiver_call(void);
void list_receiver_call(void);
void add_receiver(GtkWidget *w, gchar *my_data);
void edit_receiver(receiver_text *edit_receiver_data);
GtkWidget *create_add_receiver(receiver *receiver_data, receiver_text *edit_data);
void edit_receiver_popup(GtkWidget *w, gchar *rec_id);

/*****************************************************************************/
/*

list_receivers.c

*/
/*****************************************************************************/

GtkWidget *create_list_receivers (void);
void list_receivers(void);


/*****************************************************************************/
/*

list_service_callbacks.c

*/
/*****************************************************************************/

void duplicate_service_entry(GtkButton  *button, gpointer user_data);

void
on_list_add_service_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_list_edit_service_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_list_delete_service_clicked         (GtkWidget       *dialog_window,
                                        gpointer         user_data);

void
on_list_ok_service_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_list_cancel_service_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void on_list_delete_confirm            (GtkButton    *button, gpointer data);
void on_click_column_service(GtkWidget *w, gint col, gpointer data);

/*****************************************************************************/
/*

list_service.c

*/
/*****************************************************************************/

GtkWidget *create_list_service_dialog (void);
void list_services(void);

/*****************************************************************************/
/*

dialogs.c

*/
/*****************************************************************************/

GtkWidget *confirm_restore(void);
GtkWidget *confirm_convert (void);
void generic_error(gchar *error_string, gchar *window_title);
void about_box();
GtkWidget *create_ok_delete (void);
GtkWidget *generic_confirm_delete (GtkWidget *selection_clist, gchar *delete_function, gchar *id);
void notify_user();
void show_pre_defined_list();
GtkWidget *confirm_log_delete (log_window_data  *user_data);
GtkWidget *exit_anyway();
GtkWidget *profile_confirm_delete (GtkWidget *combo_box);

/*****************************************************************************/
/*

configure.c

*/
/*****************************************************************************/

GtkWidget *create_config_window (void);
void config_client();

/*****************************************************************************/
/*

configure_callbacks.c

*/
/*****************************************************************************/


void on_config_save_button_clicked   (GtkButton  *button, config_data_struct  *user_data);
void on_config_cancel_button_clicked (GtkWidget  *window, config_data_struct  *user_data);


/*****************************************************************************/
/*

add_service.c

*/
/*****************************************************************************/

void service_call(void);
void add_service_list();
void add_service_function(GtkWidget *w, gpointer flag);
void edit_service(service_text *edit_service_data);
GtkWidget *create_add_service (char *flag, service *service_data, service_text *edit_service_data);


/*****************************************************************************/
/*

io_utilities.c

*/
/*****************************************************************************/

ssize_t write_num(int file_desc, char *strptr, size_t num);
ssize_t read_a_line(int file_desc, char return_buff[MAX_LENGTH], size_t maxlen);
gint read_cached_line(gint file_desc, gchar *return_buff, gint max_length);
gchar *read_a_big_line(gint file_desc);

/*****************************************************************************/
/*

add_group_callbacks.c

*/
/*****************************************************************************/

void
on_group_name_changed                  (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_add_group_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_remove_group_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_save_group_button_clicked           (GtkButton       *button,
                                        add_group_data  *user_data);

void
on_cancel_group_button_clicked         (GtkButton       *button,
                                        add_group_data         *user_data);


/*****************************************************************************/
/*

add_group.c

*/
/*****************************************************************************/

void add_group();
GtkWidget *create_groups(add_group_data *group_data, edit_group_data *e_group_data);
void add_group_from_list();
void add_group_edit(gchar *group_id, gint popup_flag);
void add_group_edit_popup(gchar *group_id);

/*****************************************************************************/
/*

list_group.c

*/
/*****************************************************************************/

void list_groups();
GtkWidget *create_list_groups (void);



/*****************************************************************************/
/*

list_group_callbacks.c

*/
/*****************************************************************************/


void
on_list_group_add_button_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_list_group_edit_button_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void
on_list_group_delete_button_clicked    (GtkWidget       *confirm_box,
                                        gpointer         user_data);

void
on_list_okay_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void delete_rec_by_id(gchar *group_id);
void confirm_group_delete(void);
void confirm_group_delete_popup(gchar *gid);
void delete_group_popup(GtkWidget *w, gchar *gid);

/*****************************************************************************/
/*

list_log.c

*/
/*****************************************************************************/

void view_log_main(void);
GtkWidget *create_view_log (void);


/*****************************************************************************/
/*

list_log_callbacks.c

*/
/*****************************************************************************/

void
on_radiobutton_name_toggled            (GtkToggleButton  *togglebutton,
					log_window_data  *user_data);
void
on_radiobutton_date_toggled            (GtkToggleButton  *togglebutton,
                                        log_window_data  *user_data);
void
on_cancel_log_button_clicked           (GtkButton        *button,
                                        log_window_data  *user_data);
void
on_log_view_button_clicked             (GtkCList        *list,
                                        log_window_data  *user_data);
void
on_log_refresh_button_clicked          (GtkButton        *button,
                                        log_window_data  *user_data);

void on_click_column_log(GtkWidget *w, gint col, gpointer data);

void
on_delete_log_button_clicked            (GtkButton       *button,
					 log_window_data  *user_data);

void catch_log_delete                   (GtkButton       *button,
					 log_window_data  *user_data);

/*****************************************************************************/
/*

logging_functions.c

*/
/*****************************************************************************/

void load_log_for_list(log_window_data *log_data, gint options);
gchar *get_name(char *log_line);
void load_log_list(GtkWidget *log_clist, gchar *field, gint options);
list *get_list_mem(list *node);
gchar *get_date(char *log_line);
gchar *get_message(gchar *line);
gchar  *get_log_status(gchar *line);
gchar *get_via(gchar *line);
gchar *get_log_date(gchar *line);
gint delete_log_data(char *name, gint what);
void dump_debug_data(gchar *data);

/*****************************************************************************/
/*

view_log.c

*/
/*****************************************************************************/

void show_log_window(char *name, gint options);
GtkWidget  *create_log_window (char *name, gint options);

/*****************************************************************************/
/*

view_log_callbacks.c

*/
/*****************************************************************************/

void
on_close_button_clicked         (GtkButton                    *button,
                                 log_status_bar_data          *user_data);

void select_row_callback_log(GtkCList *list, gint row, gint col, GdkEventButton *event, log_status_bar_data *data);
void select_row_popup(GtkCList *list, GdkEventButton *event, gpointer data);
void reload_from_log(gchar *msg, GdkEventButton *event);
void select_row_popup_date(GtkCList *list, GdkEventButton *event, gpointer data);
gchar *get_error_string(gchar *error_code);
void on_click_column_log_name(GtkWidget *w, gint col, gpointer data);

/*****************************************************************************/
/*

pref.c

*/
/*****************************************************************************/

void preferences(GtkWidget *w, gpointer *data);
GtkWidget *create_preferences_window (pref_data *user_data, gpointer *interface_widget);
GtkWidget *create_preferences (pref_data *user_data, gpointer *interface_widget);

/*****************************************************************************/
/*

pref_callbacks.c

*/
/*****************************************************************************/

void selection_made(GtkWidget *w, GtkCTreeNode *node, gint row, dynamic_box_data *vbox_data);
void reset_interface(GtkWidget *w, pref_data *user_data);
void convert_database_okay(GtkWidget *w, gchar *user_data);
void convert_database(GtkWidget *w, pref_data *user_data);
pref_data  *get_pref_mem(pref_data *prefs);

void load_prefs(pref_data *user_pref);

void
on_change_dir_clicked                   (GtkWidget       *w,
                                        pref_widgets    *user_data);
void
on_pref_save_button_clicked                 (GtkWidget       *w,
					     pref_data    *user_data);

void
on_pref_cancel_button_clicked               (GtkWidget       *w,
					     pref_data       *user_data);

void
on_set_precedence_toggled                (GtkToggleButton *togglebutton,
                                          gpointer         user_data);

void
on_set_no_precedence_toggled                (GtkToggleButton *togglebutton,
					     gpointer         user_data);

void
on_show_options_toggled                   (GtkToggleButton *togglebutton,
					   gpointer         user_data);
void
on_hide_options_toggled                   (GtkToggleButton *togglebutton,
					   gpointer         user_data);

void
on_pref_apply_button_clicked                 (GtkWidget       *w,
					      pref_data    *user_data);

/*****************************************************************************/
/*

pre_def_msg.c

*/
/*****************************************************************************/

void pre_defined_msg(void);
GtkWidget *create_pre_defined (void);
void load_pre_def_list(GtkWidget *list, gchar *file_name);

/*****************************************************************************/
/*

pre_def_msg_callbacks.c

*/
/*****************************************************************************/


void
on_add_pre_clicked                     (GtkButton       *button,
                                        stored_msg      *user_data);
void
on_update_pre_clicked                  (GtkButton       *button,
                                        stored_msg      *user_data);
void
on_delete_pre_clicked                  (GtkButton       *button,
                                        stored_msg      *user_data);
void
on_ok_pref_clicked                     (GtkWidget       *w,
                                        stored_msg      *user_data);
void
on_cancel_pre_clicked                  (GtkButton       *button,
                                        stored_msg      *user_data);

void del_pre_def(gchar  *msg, gchar *file_name);


/*****************************************************************************/
/*

schedule.c

*/
/*****************************************************************************/

void schedule_page();
GtkWidget *create_schedule_window (void);



/*****************************************************************************/
/*

schedule_callbacks.c

*/
/*****************************************************************************/

void
on_sched_ok_clicked                    (GtkButton         *button,
                                        sched_msg_info    *user_data);

void
on_sched_cancel_clicked                (GtkButton       *button,
                                        sched_msg_info    *user_data);

/*****************************************************************************/
/*

list_scheduled_callbacks.c

*/
/*****************************************************************************/


void
on_delete_schedule_clicked             (GtkButton       *button,
                                        sched_win_data   *user_data);

void
on_ok_schedule_clicked               (GtkButton       *button,
				      sched_win_data   *user_data);

void
on_status_schedule_clicked               (GtkButton       *button,
					  sched_win_data   *user_data);

sched_update  *obtain_schedule_status(int sock, gchar *id, GtkWidget *text, GtkWidget *list, char *msg_time, sched_win_data *user_data, gchar *count);

void
on_view_button_clicked             (GtkButton        *button,
                                    sched_win_data   *user_data);

void updata_message_count(gchar *count, gchar *id);
void  delete_msg_id(gchar *id, GtkWidget *list);
void parse_status_data(gchar *line, gchar *epoch, gchar *code, gchar *sdata, gchar *sreceiver, gchar *track, gchar *uid, gchar *msg);

/*****************************************************************************/
/*

list_scheduled_.c

*/
/*****************************************************************************/

void list_scheduled();
GtkWidget *create_maintain_schedule (void);

/*****************************************************************************/
/*

script_page.c

*/
/*****************************************************************************/

void edit_script_page(int id);
void show_script_page();
GtkWidget *create_script_page (int flag, script_text *data);
void load_script_list(gpointer clist1);
void unlink_profile(GtkWidget *w, GtkWidget *combo_box);

/*****************************************************************************/
/*

script_page_callbacks.c

*/
/*****************************************************************************/

typedef struct reload_tag {
    GtkWidget  *list;
    GtkWidget  *reload_button;
    GtkWidget  *deactivate_button;
    GtkWidget  *combo_box;
}reload_data;

void
on_browse_script_button_clicked        (GtkButton       *button,
                                        script_data     *user_data);

void
on_auto_save_button_clicked            (GtkButton       *button,
					script_data     *user_data);

void
on_auto_cancel_button_clicked          (GtkButton       *button,
					script_data     *user_data);

script_text  *get_script_memory();
void  free_script_memory(script_text *data);

typedef struct {
    GtkWidget   *entry_box;
    gchar       *script_name_sel;  
    GtkWidget   *sel_box;
}script_struct;

void file_has_been_selected(GtkWidget  *w, script_struct  *data);
void start_script_page(GtkButton   *button, script_data *user_data);
void reload_previous_script_after(script_data *user_data);
void deactivate_script(GtkWidget *w, reload_data *user_data);
void on_show_minutes_toggled(GtkWidget *w, manual_widgets *user_data);
void on_hide_minutes_toggled(GtkWidget *w, manual_widgets *user_data);
void on_browse_target_button_clicked(GtkButton *button, script_data *user_data);
void target_has_been_selected(GtkWidget  *w,script_struct  *data);
GtkWidget *create_save_profile_dialog (script_data *data);
void show_profile_save_dialog(GtkWidget *w, script_data *data);
void reload_previous_script_daemon(gchar  *file_name);
void  register_autopage_thread(pthread_t thread_id);
void kill_autopage_thread(pthread_t thread_id);
void view_script(GtkWidget *w, reload_data *user_data);
gchar *get_id_from_receiver_name(gchar *name);
gchar *get_id_from_group_name(gchar *name);

/*****************************************************************************/
/*

list_active_script_callbacks.c

*/
/*****************************************************************************/

void show_active_script();
GtkWidget *create_active_script (void);


/*****************************************************************************/
/*

list_active_script_callbacks.c

*/
/*****************************************************************************/


gint activate_script_page(script_data *data, gint mode, gchar *profile);

gint deactivate_script_page(void);

gint get_status_script_page(void);

void init_script_page_data(void);

void *run_auto_page(void *arg);

void reload_previous_script(GtkWidget *w, reload_data *user_data);

/*****************************************************************************/
/*

two_way.c

*/
/*****************************************************************************/

void show_response_window();
GtkWidget *create_response_windows (void);
GtkWidget *create_edit_response_box (response_info *user_data);
void show_edit_box(response_info *user_data);

/*****************************************************************************/
/*

two_way_callbacks.c

*/
/*****************************************************************************/


void on_two_way_close_button_clicked (GtkButton  *button, response_info *user_data);
void on_two_way_edit_button_clicked (GtkButton *button, response_info *user_data);
void on_two_way_add_button_clicked (GtkButton *button ,response_info  *user_data);
void on_two_way_delete_button_clicked (GtkButton  *button, gpointer user_data);
void on_edit_text_box_changed (GtkEditable *editable, response_info *user_data);
void on_edit_cancel_button_clicked  (GtkButton *button, gpointer user_data);
void on_edit_save_button_clicked (GtkButton *button, gpointer user_data);
void load_two_way_response(GtkWidget *selection_clist);
void on_two_way_apply_button_clicked(GtkWidget *w, response_info *user_data);
void on_two_way_deactivate_button_clicked(GtkWidget *w, response_info *user_data);

/*****************************************************************************/
/*

reply_status_callbacks.c

*/
/*****************************************************************************/

void on_reply_status_button_clicked  (GtkButton  *button, reply_info  *user_data);
void on_reply_delete_button_clicked (GtkButton  *button, reply_info  *user_data);
void on_reply_okay_button_clicked  (GtkButton  *button, window_info  *user_data);
void on_click_column_reply (GtkCList *list, gint row, gint col, GdkEventButton *event, update_text *data);
void on_reply_refresh_button_clicked  (GtkButton  *button, reply_info *user_data);

/*****************************************************************************/
/*

reply_status.c

*/
/*****************************************************************************/

GtkWidget *create_two_way_reply (void);
void show_reply_window ();

/*****************************************************************************/
/*

test_code.c

*/
/*****************************************************************************/

void *new_run_auto_page(void *arg);

/*****************************************************************************/
/*

logging.c

*/
/*****************************************************************************/

void debug_log(const char *fmt,...);
void error_ret(const char *fmt,...);
void info_msg(const char *fmt,...);
void error_sys(const char *fmt,...);
void error_core(const char *fmt,...);
void error_quit(const char *fmt,...);
void debug_data(const char *fmt,...);
void log_daemon_data(const char *fmt,...);

