/*
 * g-page Copyright (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

void config_client()
{
    GtkWidget  *config_window;
    
    config_window = create_config_window();
    gtk_widget_show(config_window);
}

GtkWidget*
create_config_window (void)
{
  GtkWidget *config_window;
  GtkWidget *vbox13;
  GtkWidget *table5;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label31;
  GtkWidget *label32;
  GtkWidget *label33;
  GtkWidget *label34;
  GtkWidget *hbuttonbox8;
  GtkWidget *save_button;
  GtkWidget *cancel_button;
  gchar      *address_data;
  gchar      *port_data;
  gchar      *timeout_data;
  gchar      *isp_domain;
  gchar      *isp_email_domain;
  gchar      *email_adr;
  config_data_struct *config_data;

  config_data = g_malloc(sizeof(*config_data));

  config_window = gtk_window_new (GTK_WINDOW_DIALOG);
  config_data->main_window = config_window;
  gtk_object_set_data (GTK_OBJECT (config_window), "config_window", config_window);
  gtk_window_set_title (GTK_WINDOW (config_window), "Configure");
  gtk_window_set_modal (GTK_WINDOW (config_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (config_window), FALSE, FALSE, FALSE);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_container_add (GTK_CONTAINER (config_window), vbox13);

  table5 = gtk_table_new (6, 2, FALSE);
  gtk_widget_ref (table5);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "table5", table5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table5);
  gtk_box_pack_start (GTK_BOX (vbox13), table5, TRUE, TRUE, 0);

  label29 = gtk_label_new (" Server IP Address: ");
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_table_attach (GTK_TABLE (table5), label29, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label30 = gtk_label_new (" Server Port Number: ");
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_table_attach (GTK_TABLE (table5), label30, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
/**************************************************************************/
  label32 = gtk_label_new (" ISP Domain: ");
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_table_attach (GTK_TABLE (table5), label32, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  config_data->isp_domain = gtk_entry_new_with_max_length (32);

  if ( (isp_domain = get_resource_data("CONFIG.dat", "isp_domain", MAX_FIELD_LENGTH)) == NULL)
  {
      update_status_line("Error: corrupt file: CONFIG.dat");
  }
  else
  {
      gtk_entry_set_text( GTK_ENTRY(config_data->isp_domain), isp_domain); 
      g_free(isp_domain);
  }


  gtk_widget_ref (config_data->isp_domain);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "config_data->isp_domain", config_data->isp_domain,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config_data->isp_domain);
  gtk_table_attach (GTK_TABLE (table5), config_data->isp_domain, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);  


  label33 = gtk_label_new (" Email Domain: ");
  gtk_widget_ref (label33);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label33", label33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label33);
  gtk_table_attach (GTK_TABLE (table5), label33, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  config_data->isp_email_domain = gtk_entry_new_with_max_length (32);

  if ( (isp_email_domain = get_resource_data("CONFIG.dat", "isp_email_domain", MAX_FIELD_LENGTH)) == NULL)
  {
      update_status_line("Error: corrupt file: CONFIG.dat");
  }
  else
  {
      gtk_entry_set_text( GTK_ENTRY(config_data->isp_email_domain), isp_email_domain); 
      g_free(isp_email_domain);
  }

  gtk_widget_ref (config_data->isp_email_domain);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "config_data->isp_email_domain", config_data->isp_email_domain,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config_data->isp_email_domain);
  gtk_table_attach (GTK_TABLE (table5), config_data->isp_email_domain, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);  

/*************************************************************************/
  config_data->ip_address = gtk_entry_new_with_max_length (32);

  if ( (address_data = get_resource_data("CONFIG.dat", "ip_address", MAX_FIELD_LENGTH)) == NULL)
  {
      update_status_line("Error: corrupt file: CONFIG.dat");
  }
  else
  {
      gtk_entry_set_text( GTK_ENTRY(config_data->ip_address), address_data); 
      g_free(address_data);
  }

  gtk_widget_ref (config_data->ip_address);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "config_data->ip_address", config_data->ip_address,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config_data->ip_address);
  gtk_table_attach (GTK_TABLE (table5), config_data->ip_address, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  config_data->port = gtk_entry_new_with_max_length (8);

  if ( (port_data = get_resource_data("CONFIG.dat", "port", MAX_FIELD_LENGTH)) == NULL)
  {
      update_status_line("Error: corrupt file: CONFIG.dat");
  }
  else
  {
      gtk_entry_set_text( GTK_ENTRY(config_data->port), port_data); 
      g_free(port_data);
  }

  gtk_widget_ref (config_data->port);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "config_data->port", config_data->port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config_data->port);
  gtk_table_attach (GTK_TABLE (table5), config_data->port, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

/***********************************************************************/

 label31 = gtk_label_new (" Timeout: ");
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_table_attach (GTK_TABLE (table5), label31, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  config_data->timeout = gtk_entry_new_with_max_length (8);

  if ( (timeout_data = get_resource_data("CONFIG.dat", "timeout", MAX_FIELD_LENGTH)) == NULL)
  {
      update_status_line("Error: corrupt file: CONFIG.dat");
  }
  else
  {
      gtk_entry_set_text( GTK_ENTRY(config_data->timeout), timeout_data); 
      g_free(timeout_data);
  }

  gtk_widget_ref (config_data->timeout);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "config_data->timeout", config_data->timeout,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config_data->timeout);
  gtk_table_attach (GTK_TABLE (table5), config_data->timeout, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);    

/**************************************************************************/
 label34 = gtk_label_new (" Email Address: ");
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label34);
  gtk_table_attach (GTK_TABLE (table5), label34, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  config_data->email_adr = gtk_entry_new_with_max_length (50);
  if ( (email_adr = get_resource_data("CONFIG.dat", "email_adr", MAX_FIELD_LENGTH)) == NULL)
  {
      update_status_line("Error: corrupt file: CONFIG.dat");
  }
  else
  {
      gtk_entry_set_text( GTK_ENTRY(config_data->email_adr), email_adr); 
      g_free(email_adr);
  }

  gtk_widget_ref (config_data->email_adr);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "config_data->email_adr", config_data->email_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config_data->email_adr);
  gtk_table_attach (GTK_TABLE (table5), config_data->email_adr, 1, 2, 4, 5, 
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

/***********************************************/
  hbuttonbox8 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox8);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "hbuttonbox8", hbuttonbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox8);
  gtk_box_pack_start (GTK_BOX (vbox13), hbuttonbox8, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox8), GTK_BUTTONBOX_SPREAD);

  save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (save_button);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "save_button", save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox8), save_button);
  GTK_WIDGET_SET_FLAGS (save_button, GTK_CAN_DEFAULT);

  cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (config_window), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox8), cancel_button);
  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_config_save_button_clicked),
                      config_data);

  gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_config_cancel_button_clicked),
                      config_data);

  gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_config_cancel_button_clicked),
                      config_data);

  gtk_widget_grab_focus(cancel_button);


  return config_window;
}








