/*
 * g-page Copyright (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        


#include "constants.h"
#include "callbacks.h"

void on_config_cancel_button_clicked  (GtkWidget  *window, config_data_struct  *user_data)
{
    gtk_widget_destroy(user_data->main_window);
    g_free(user_data);
}


void on_config_save_button_clicked   (GtkButton   *button, config_data_struct  *user_data)
{
    gchar  *address;
    gchar  *port;
    gchar  *timeout;
    gchar  *isp_domain;
    gchar  *isp_email_domain;
    gchar  *email_adr;
    char   *temp_buffer;

     address = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data->ip_address)));
     port = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data->port)));
     timeout = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data->timeout)));
     isp_domain = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data->isp_domain)));
     isp_email_domain = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data->isp_email_domain)));
     email_adr = g_strdup(gtk_entry_get_text(GTK_ENTRY(user_data->email_adr)));

     if ( (strlen(address) == 0))
     {
	 g_free(address);
	 address = g_malloc(MAX_LENGTH);
	 strcpy(address, "localhost");
     }
     else
	 address = clean_string(address);

     if ( (strlen(port) == 0) )
     {
	 g_free(port);
	 port = g_malloc(MAX_LENGTH);
	 strcpy(port, "1299");
     }
     else
	 port = clean_string(port);


     if ( (strlen(timeout) == 0) )
     {
	 g_free(timeout);
	 timeout = g_malloc(MAX_LENGTH);
	 strcpy(timeout, "60");
     }
     else
	 timeout = clean_string(timeout);


     if ( (strlen(isp_domain) == 0) )
     {
	 g_free(isp_domain);
	 isp_domain = g_malloc(MAX_LENGTH);
	 strcpy(isp_domain, "localhost");
     }
     else
	 isp_domain = clean_string(isp_domain);


     if ( (strlen(isp_email_domain) == 0) )
     {
	 g_free(isp_email_domain);
	 isp_email_domain = g_malloc(MAX_LENGTH);
	 strcpy(isp_email_domain, "localhost");
     }
     else
	 isp_email_domain = clean_string(isp_email_domain);


     if ( (strlen(email_adr) == 0) )
     {
	 g_free(email_adr);
	 email_adr = g_malloc(MAX_LENGTH);
	 strcpy(email_adr, "localhost@localdomain");
     }
     else
	 email_adr = clean_string(email_adr);


     temp_buffer = g_malloc(MAX_LENGTH);
     strcpy(temp_buffer, "ip_address=");
     strcat(temp_buffer, address);
     strcat(temp_buffer, "\n");
     edit_item("ip_address", "CONFIG.dat", 2, 1, temp_buffer, EDIT, '=');

     strcpy(temp_buffer, "port=");
     strcat(temp_buffer, port);
     strcat(temp_buffer, "\n");
     edit_item("port", "CONFIG.dat", 2, 1, temp_buffer, EDIT, '=');

     strcpy(temp_buffer, "timeout=");
     strcat(temp_buffer, timeout);
     strcat(temp_buffer, "\n");
     edit_item("timeout", "CONFIG.dat", 2, 1, temp_buffer, EDIT, '=');

     strcpy(temp_buffer, "isp_domain=");
     strcat(temp_buffer, isp_domain);
     strcat(temp_buffer, "\n");
     edit_item("isp_domain", "CONFIG.dat", 2, 1, temp_buffer, EDIT, '=');

     strcpy(temp_buffer, "isp_email_domain=");
     strcat(temp_buffer, isp_email_domain);
     strcat(temp_buffer, "\n");
     edit_item("isp_email_domain", "CONFIG.dat", 2, 1, temp_buffer, EDIT, '=');

     strcpy(temp_buffer, "email_adr=");
     strcat(temp_buffer, email_adr);
     strcat(temp_buffer, "\n");
     edit_item("email_adr", "CONFIG.dat", 2, 1, temp_buffer, EDIT, '=');

     g_free(temp_buffer);
     g_free(address);
     g_free(port);
     g_free(timeout);
     g_free(isp_domain);
     g_free(isp_email_domain);
     g_free(email_adr);

}



