/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <gdk/gdkkeysyms.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h> 
#include <sys/select.h>
#include <sys/time.h>
#include <pthread.h>
#include <syslog.h>

#include "interface.h"
#include "support.h"

/*
 *    GLOBAL VARIABLES
 */

gint        my_pid;
char        named_pipe[32];
GtkWidget   *group_receiver_clist;
GtkWidget   *group_clist;
GtkWidget   *text_entry;
GtkWidget   *group_tree;
GtkWidget   *receiver_clist;
GtkWidget   *statusbar1;
GtkWidget   *statusbar_small;
GtkWidget   *service_clist;
GtkWidget   *list_service_clist;
GtkWidget   *list_receiver_clist;


/*
 *    CONSTANTS
 */

#define MAX_GROUP_UID_CHAR  16
#define MAX_NUM_GROUPS 500
#define MAX_LENGTH_GROUP_DATA 16 + 150 + (500 * 8)
#define MAX_LENGTH 2500
#define MAX_LOG_LENGTH 3000
#define MAX_FIELD_LENGTH 150
#define MAX_PAGE_LENGTH 1000
#define USER 2
#define EDIT 1
#define CREATE 3
#define DELETE 2
#define ADD 1
#define NUM_FIELDS 15		/* This used as the maximun number of fields */
#define SERVICE_FIELDS 15
#define RECEIVER_FIELDS 15
#define GROUP_FIELDS 2

#define UPDATE   0
#define EXIT     1
#define PERROR   2

#define NORMAL      1
#define AUTO        2
#define TRACK_WCTP  3
#define TRACK_SNPP  4

#define NEW_SCRIPT     1
#define RELOAD_SCRIPT  2
#define VIEW_SCRIPT    3

#define PORT 1299

#define ONE_SECOND             1000
#define THREE_QUARTER_SECOND   750
#define HALF_SECOND            500
#define QUARTER_SECOND         250

/* These are used when loading receiver or service fields into a CList  */

#define REC_ID              0
#define REC_NAME            1
#define REC_NUMBER          2
#define REC_SERVICE_ID      3
#define REC_EMAIL_ADR       4
#define REC_AUTOSPLIT       5
#define REC_WCTP            6
#define REC_SNPP            7
#define REC_SMTP            8
#define REC_WCTP_OPTIONS    9
#define REC_SNPP_OPTIONS    10


#define SERVICE_ID          0
#define SERVICE_NAME        1
#define SERVICE_WCTP_URL    2
#define SERVICE_MAX_MSG     3 
#define SERVICE_TAP         4
#define SERVICE_SNPP        5
#define SERVICE_SMTP        6
#define SERVICE_SNPP_URL    7
#define SERVICE_SNPP_PORT   8
#define SERVICE_SNPP_PASS   9
#define SERVICE_PASS_YES_NO 10

#define GROUP_ID        0
#define GROUP_NAME      1

#define DATE 0
#define NAME 1
