/*
 * g-page
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

typedef int BOOL;
typedef void Sigfunc (int);	

Sigfunc *Signal(int signo, Sigfunc *func);

/***********************************************************
************************************************************

  This is the data structure for the reciever. Bit fields 
   are used to make the serialization process easier 
   when passing the data to a server 

************************************************************
************************************************************/

typedef struct {
    unsigned log_page             : 1;
    unsigned tap_protocol         : 1;
    unsigned snpp_protocol        : 1;
    unsigned smtp_protocol        : 1;
    unsigned rollover_on_failure  : 1;
    unsigned empty_01             : 1;
    unsigned empty_02             : 1;
    unsigned empty_03             : 1;
} receiver_properties;

typedef struct {
    char                 *username;
    char                 *user_id;
    char                 *receiver_number;
    char                 *service_id;
    char                 *service_number;
    char                 *max_msg_length;
    char                 *group_id;
    char                 *text;
    receiver_properties  *properties;
} receiver_profile;

/***********************************************************
 ***********************************************************

 Data structure for the service provider. 

************************************************************
************************************************************/

typedef struct {
    char        *service_name;
    char        *service_id;
    char        *service_number;
    char        *max_msg_length;
    BOOL        log_page;
    BOOL        tap_protocol;
    BOOL        snpp_protocol;
} service_profile;

/***********************************************************
 ***********************************************************

 Data structure for the page queue. This will be a series 
 of pointers that point to all of the pages being sent
 to the paging server. A double linked list is used to 
 make it easy to manipulate (sorting etc..)

************************************************************
************************************************************/
    
typedef struct active_page_queue  {
    receiver_profile               *user;
    struct active_page_queue       *previous;
    struct active_page_queue       *next;
} page_queue;

/***********************************************************
 ***********************************************************



************************************************************
************************************************************/




