/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"


void list_groups()
{
    GtkWidget  *list_groups_window;
    extern GtkWidget *group_tree;
    list_groups_window = create_list_groups();
    load_group_tree(group_tree);
    gtk_widget_show(list_groups_window);
}

GtkWidget*
create_list_groups (void)
{
  extern GtkWidget *group_tree;

  GtkWidget *list_groups;
  GtkWidget *hbox14;
  GtkWidget *scrolledwindow11;
  GtkWidget *label39;
  GtkWidget *list_group_title;
  GtkWidget *vbox17;
  GtkWidget *vbuttonbox6;
  GtkWidget *list_group_add_button;
  GtkWidget *list_group_edit_button;
  GtkWidget *list_group_delete_button;
  GtkWidget *hbuttonbox10;
  GtkWidget *list_okay_button;

  list_groups = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (list_groups), "list_groups", list_groups);
  gtk_widget_set_usize (list_groups, 400, 450);
  gtk_window_set_title (GTK_WINDOW (list_groups), "List Groups");
  gtk_window_set_modal (GTK_WINDOW (list_groups), TRUE);
  gtk_window_set_policy (GTK_WINDOW (list_groups), FALSE, FALSE, FALSE);

  hbox14 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox14);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "hbox14", hbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox14);
  gtk_container_add (GTK_CONTAINER (list_groups), hbox14);

  scrolledwindow11 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow11);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "scrolledwindow11", scrolledwindow11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow11);
  gtk_box_pack_start (GTK_BOX (hbox14), scrolledwindow11, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow11, 300, -2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow11), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  group_tree = gtk_ctree_new (2, 0);
  gtk_ctree_set_expander_style( GTK_CTREE( group_tree ), GTK_CTREE_EXPANDER_TRIANGLE);
  gtk_ctree_set_line_style( GTK_CTREE( group_tree ), GTK_CTREE_LINES_NONE);
  gtk_widget_ref (group_tree);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "group_tree", group_tree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_tree);
  gtk_container_add (GTK_CONTAINER (scrolledwindow11), group_tree);
  gtk_clist_set_column_width (GTK_CLIST (group_tree), 0, 150);
  gtk_clist_set_column_visibility (GTK_CLIST(group_tree), 1, FALSE);
  gtk_clist_set_column_width (GTK_CLIST (group_tree), 1, 10);
  gtk_clist_column_titles_show (GTK_CLIST (group_tree));

  list_group_title = gtk_label_new ("Groups");
  gtk_widget_ref (list_group_title);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "list_group_title", list_group_title,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_group_title);
  gtk_clist_set_column_widget (GTK_CLIST (group_tree), 0, list_group_title);


  label39 = gtk_label_new ("");
  gtk_widget_ref (label39);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "label39", label39,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_clist_set_column_widget (GTK_CLIST (group_tree), 1, label39);


  vbox17 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox14), vbox17, TRUE, TRUE, 0);

  vbuttonbox6 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox6);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "vbuttonbox6", vbuttonbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox6);
  gtk_box_pack_start (GTK_BOX (vbox17), vbuttonbox6, TRUE, FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox6), GTK_BUTTONBOX_SPREAD);

  list_group_add_button = gtk_button_new_with_label ("Add");
  gtk_widget_ref (list_group_add_button);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "list_group_add_button", list_group_add_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_group_add_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox6), list_group_add_button);
  GTK_WIDGET_SET_FLAGS (list_group_add_button, GTK_CAN_DEFAULT);

  list_group_edit_button = gtk_button_new_with_label ("Edit");
  gtk_widget_ref (list_group_edit_button);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "list_group_edit_button", list_group_edit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_group_edit_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox6), list_group_edit_button);
  GTK_WIDGET_SET_FLAGS (list_group_edit_button, GTK_CAN_DEFAULT);

  list_group_delete_button = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (list_group_delete_button);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "list_group_delete_button", list_group_delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_group_delete_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox6), list_group_delete_button);
  GTK_WIDGET_SET_FLAGS (list_group_delete_button, GTK_CAN_DEFAULT);

  hbuttonbox10 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox10);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "hbuttonbox10", hbuttonbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox10);
  gtk_box_pack_start (GTK_BOX (vbox17), hbuttonbox10, TRUE, TRUE, 0);

  list_okay_button = gtk_button_new_with_label ("OK");
  gtk_widget_ref (list_okay_button);
  gtk_object_set_data_full (GTK_OBJECT (list_groups), "list_okay_button", list_okay_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_okay_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox10), list_okay_button);
  GTK_WIDGET_SET_FLAGS (list_okay_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (list_group_add_button), "clicked",
                      GTK_SIGNAL_FUNC (add_group_from_list),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (list_group_edit_button), "clicked",
                      GTK_SIGNAL_FUNC (on_list_group_edit_button_clicked),
                      GTK_OBJECT(list_groups));
  gtk_signal_connect (GTK_OBJECT (list_group_delete_button), "clicked",
                      GTK_SIGNAL_FUNC (confirm_group_delete),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (list_okay_button), "clicked",
                      GTK_SIGNAL_FUNC (on_list_okay_button_clicked),
                      GTK_OBJECT(list_groups));

  gtk_widget_grab_focus(list_okay_button);
  return list_groups;
}

