/*
 * g-page Copyright (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"


void
on_list_group_add_button_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_list_group_edit_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
    extern GtkWidget *group_tree;

    gchar            *group_id;
    
    if (GTK_CLIST(group_tree)->selection == NULL)
    {
	generic_error("\n  You must select a group to edit \n", "G-Page Error");
	return;
    }
    gtk_ctree_node_get_text( (GtkCTree *)group_tree, GTK_CLIST(group_tree)->selection->data, 1, &group_id);
    if (group_id[0] != 'G')
    {
	generic_error("\n  You cannot edit a receiver from this list  \n  You must select a group to edit  \n", "G-Page Error");
	return;
    }
    add_group_edit(group_id, 0);
    
}

void confirm_group_delete_popup(gchar *gid)
{
    GtkWidget   *confirm_box;

    confirm_box = generic_confirm_delete (group_tree, "group", gid);
    if ( confirm_box != NULL )
	gtk_widget_show(confirm_box);    
}

void delete_group_popup(GtkWidget *w, gchar *gid)
{
    gchar   *t_id;
    
    t_id = g_malloc(32);
    strcpy(t_id, gid);

    edit_item(gid, "GROUP.dat", 3, 1, NULL, DELETE, ',');
    delete_rec_by_id(gid); 
    recycle_id("GROUP", (t_id + 1) ); /* We need to skip the "G" on the id */
    g_free(t_id);
}

void confirm_group_delete(void)
{
    GtkWidget  *confirm_box;

    confirm_box = generic_confirm_delete (group_tree, "group", NULL);
    if ( confirm_box != NULL )
	gtk_widget_show(confirm_box);

}

void
on_list_group_delete_button_clicked    (GtkWidget       *confirm_box,
                                        gpointer         user_data)
{
    extern GtkWidget *group_tree;

    gchar            *group_id;
    gchar            *temp;
    
    temp = g_malloc(MAX_FIELD_LENGTH);
    memset(temp, '\0', MAX_FIELD_LENGTH);

    gtk_ctree_node_get_text( (GtkCTree *)group_tree, GTK_CLIST(group_tree)->selection->data, 1, &group_id);
    if ( group_id[0] != 'G' )
    {
	generic_error("\n  You cannot delete a receiver from this list \n  Please select a group to delete \n", "G-Page Error");
	return;
    }
    strcpy(temp, group_id);
    delete_rec_by_id(temp);	/* Take this entry out of the main receiver list */

    edit_item(group_id, "GROUP.dat", 3, 1, NULL, DELETE, ',');
    gtk_ctree_remove_node( (GtkCTree *)group_tree, GTK_CLIST(group_tree)->selection->data);

    recycle_id("GROUP", (temp + 1) ); /* We need to skip the "G" on the id, thus we (temp+1) */

    gtk_widget_destroy(confirm_box);
    g_free(temp);
    
}

void
on_list_okay_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(user_data);
}

void delete_rec_by_id(gchar *group_id)
{


    extern GtkWidget *receiver_clist;

    gint             i = 0;
    gchar            *rec_id;

    while ( gtk_clist_get_selectable(GTK_CLIST(receiver_clist), i) ) 
    {
	gtk_clist_get_text(GTK_CLIST(receiver_clist), i, 0, &rec_id);
	if ( !strcmp(group_id, rec_id))
	{
	    gtk_clist_remove(GTK_CLIST(receiver_clist), i);
	    return;
	}
	i++;
    }

}




