/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

static void catch_double_click (GtkWidget *widget, gint row, gint col, GdkEvent *event, gpointer data);

void view_log_main(void)
{

    GtkWidget   *log_window;

    log_window = create_view_log();
    gtk_widget_show(log_window);
}


GtkWidget*
create_view_log (void)
{
  log_window_data *view_log;

  GtkWidget       *vbox18;
  GtkWidget       *frame10;
  GtkWidget       *hbox15;
  GSList          *view_group_group = NULL;

  GtkWidget       *hbuttonbox11;
  GtkWidget       *list_log_button;
  GtkWidget       *cancel_log_button;
  GtkWidget       *delete_log_button;
  GtkWidget       *refresh_list_button;

  GtkWidget       *hbox16;
  GtkWidget       *scrolledwindow12;
  GtkWidget       *view_log_name;
  GtkWidget       *number_of_log;

  gint            column_zero_width = 171;
  gint            column_one_width = 80;
  gint            column_two_width = 80;
  gint            list_heigth = 220;
  gint            list_width = 200;

  view_log = g_malloc(sizeof(*view_log));

  view_log->date = 1;		/* The default view is list by name */

  view_log->log_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (view_log->log_window), "view_log->log_window", view_log->log_window);
  gtk_widget_set_usize (view_log->log_window, 340, 400);
  gtk_window_set_title (GTK_WINDOW (view_log->log_window), "View Log");
  gtk_window_set_policy (GTK_WINDOW (view_log->log_window), FALSE, FALSE, FALSE);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_container_add (GTK_CONTAINER (view_log->log_window), vbox18);

  frame10 = gtk_frame_new (" View By: ");
  gtk_widget_ref (frame10);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "frame10", frame10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame10), 2);
  gtk_widget_show (frame10);

  gtk_box_pack_start (GTK_BOX (vbox18), frame10, TRUE, TRUE, 0);
  gtk_widget_set_usize (frame10, -2, 10);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox15);
  gtk_container_add (GTK_CONTAINER (frame10), hbox15);
  gtk_widget_set_usize (hbox15, 104, 10);

  view_log->radiobutton_name = gtk_radio_button_new_with_label (view_group_group, "Name");
  view_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (view_log->radiobutton_name));
  gtk_widget_ref (view_log->radiobutton_name);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "view_log->radiobutton_name", view_log->radiobutton_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_log->radiobutton_name);
  gtk_box_pack_start (GTK_BOX (hbox15), view_log->radiobutton_name, FALSE, FALSE, 2);
  gtk_widget_set_usize (view_log->radiobutton_name, -2, 10);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (view_log->radiobutton_name), TRUE);

  view_log->radiobutton_date = gtk_radio_button_new_with_label (view_group_group, "Date");
  view_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (view_log->radiobutton_date));
  gtk_widget_ref (view_log->radiobutton_date);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "view_log->radiobutton_date", view_log->radiobutton_date,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_log->radiobutton_date);
  gtk_box_pack_start (GTK_BOX (hbox15), view_log->radiobutton_date, FALSE, FALSE, 0);
  gtk_widget_set_usize (view_log->radiobutton_date, 52, 10);

/*
 *  Here is the button box
 */

  hbuttonbox11 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox11);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "hbuttonbox11", hbuttonbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox11);
  gtk_box_pack_start (GTK_BOX (vbox18), hbuttonbox11, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbuttonbox11, 260, 10);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox11), GTK_BUTTONBOX_SPREAD);

/*
 *  List log button
 */

  list_log_button = gtk_button_new_with_label ("List");
  gtk_widget_ref (list_log_button);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "list_log_button", list_log_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_log_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox11), list_log_button);
  GTK_WIDGET_SET_FLAGS (list_log_button, GTK_CAN_DEFAULT);

/*
 *  Refresh log button
 */

  refresh_list_button = gtk_button_new_with_label ("Refresh");
  gtk_widget_ref (refresh_list_button);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "refresh_list_button", refresh_list_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (refresh_list_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox11), refresh_list_button);
  GTK_WIDGET_SET_FLAGS (refresh_list_button, GTK_CAN_DEFAULT);

/*
 *  Delete log button
 */

  delete_log_button = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (delete_log_button);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "delete_log_button", delete_log_button,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_log_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox11), delete_log_button);
  GTK_WIDGET_SET_FLAGS (delete_log_button, GTK_CAN_DEFAULT);

/*
 *   Cancel log button
 */

  cancel_log_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_log_button);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "cancel_log_button", cancel_log_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_log_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox11), cancel_log_button);
  GTK_WIDGET_SET_FLAGS (cancel_log_button, GTK_CAN_DEFAULT);

/*
 *   Here we load the message list into a clist into a scrolled window
 */

  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox18), hbox16, TRUE, TRUE, 0);

  scrolledwindow12 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow12);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "scrolledwindow12", scrolledwindow12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow12);
  gtk_box_pack_start (GTK_BOX (hbox16), scrolledwindow12, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow12), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  view_log->log_list_clist = gtk_clist_new (3);

  gtk_clist_set_sort_column (GTK_CLIST(view_log->log_list_clist), 2);
  gtk_clist_set_auto_sort(GTK_CLIST(view_log->log_list_clist), TRUE);
  gtk_clist_set_sort_type(GTK_CLIST(view_log->log_list_clist), GTK_SORT_DESCENDING);

  gtk_widget_ref (view_log->log_list_clist);
  gtk_clist_set_column_visibility (GTK_CLIST(view_log->log_list_clist), 2, FALSE);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "view_log->log_list_clist", view_log->log_list_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_log->log_list_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow12), view_log->log_list_clist);
  gtk_widget_set_usize (view_log->log_list_clist, list_width, list_heigth);
  gtk_clist_set_column_width (GTK_CLIST (view_log->log_list_clist), 0, column_zero_width);
  gtk_clist_set_column_width (GTK_CLIST (view_log->log_list_clist), 1, column_one_width);
  gtk_clist_set_column_width (GTK_CLIST (view_log->log_list_clist), 2, column_two_width);
  gtk_clist_set_column_justification (GTK_CLIST (view_log->log_list_clist), 1, GTK_JUSTIFY_CENTER);
  gtk_clist_column_titles_show (GTK_CLIST (view_log->log_list_clist));

  view_log_name = gtk_label_new ("List by:");
  gtk_widget_ref (view_log_name);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "view_log_name", view_log_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_log_name);
  gtk_clist_set_column_widget (GTK_CLIST (view_log->log_list_clist), 0, view_log_name);

  number_of_log = gtk_label_new ("Msgs");
  gtk_widget_ref (number_of_log);
  gtk_object_set_data_full (GTK_OBJECT (view_log->log_window), "number_of_log", number_of_log,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (number_of_log);
  gtk_clist_set_column_widget (GTK_CLIST (view_log->log_list_clist), 1, number_of_log);

/*
 *  We need to force a load of the log list the first time 
 */

  on_radiobutton_name_toggled(GTK_TOGGLE_BUTTON(view_log->radiobutton_name),view_log);

  gtk_signal_connect (GTK_OBJECT (view_log->radiobutton_name), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_name_toggled),
                      view_log);

  gtk_signal_connect (GTK_OBJECT (view_log->radiobutton_date), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_date_toggled),
                      view_log);

  gtk_signal_connect (GTK_OBJECT (list_log_button), "clicked",
                      GTK_SIGNAL_FUNC (on_log_view_button_clicked),
                      view_log);

  gtk_signal_connect (GTK_OBJECT (refresh_list_button), "clicked",
                      GTK_SIGNAL_FUNC (on_log_refresh_button_clicked),
                      view_log);

  gtk_signal_connect (GTK_OBJECT (cancel_log_button), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_log_button_clicked),
                      view_log);

  gtk_signal_connect (GTK_OBJECT (delete_log_button), "clicked",
                      GTK_SIGNAL_FUNC (catch_log_delete),
                      view_log);

  gtk_signal_connect (GTK_OBJECT (view_log->log_list_clist), "select_row",
                      GTK_SIGNAL_FUNC (catch_double_click),
                      view_log);

  gtk_widget_grab_focus(cancel_log_button);
  return view_log->log_window;
}

static void catch_double_click (GtkWidget *widget, gint row, gint col, GdkEvent *event, gpointer data)
{
    if (event)
    {
	if (event->type == GDK_2BUTTON_PRESS)
	    on_log_view_button_clicked(GTK_CLIST(widget), data);
    }
    else
	return;


}


