/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"


void
on_radiobutton_name_toggled             (GtkToggleButton  *togglebutton,
                                        log_window_data   *user_data)
{
    if ( user_data->date == 1 )
    {
	user_data->date = 0;
	load_log_for_list(user_data, NAME);
    }
}

void
on_radiobutton_date_toggled             (GtkToggleButton  *togglebutton,
                                        log_window_data   *user_data)
{
    if ( user_data->date == 0 )
    {
	user_data->date = 1;
	load_log_for_list(user_data, DATE);
    }
}

void
on_cancel_log_button_clicked            (GtkButton       *button,
                                        log_window_data  *user_data)
{
    gtk_widget_destroy(user_data->log_window);
    g_free(user_data);
}

void catch_log_delete                   (GtkButton       *button,
                                        log_window_data  *user_data)
{
    GtkWidget   *dbox;

    if (GTK_CLIST(user_data->log_list_clist)->selection == NULL)
    {
	generic_error("\n  You must make a selection to delete \n", "G-Page Error");
	return;
    }

    dbox = confirm_log_delete(user_data);
    gtk_widget_show(dbox);
}

void
on_delete_log_button_clicked            (GtkButton       *button,
                                        log_window_data  *user_data)
{
    gint status;
    gchar   *name, *temp_name;

    gtk_clist_get_text( (GtkCList *)user_data->log_list_clist, GPOINTER_TO_INT(GTK_CLIST(user_data->log_list_clist)->selection->data), 0, &temp_name);
    name = g_malloc(strlen(temp_name) + 1);
    strcpy(name, temp_name);

    if ( user_data->date == 1 )
	status = delete_log_data(name, DATE);
    else
	status = delete_log_data(name, NAME);

    on_log_refresh_button_clicked(button, user_data);
}


void
on_log_view_button_clicked              (GtkCList       *list,
                                        log_window_data  *user_data)
{
    gchar  *name;

    if (GTK_CLIST(user_data->log_list_clist)->selection == NULL)
    {
	generic_error("\n  You must make a selection to view \n", "G-Page Error");
	return;
    }
    if ( user_data->date )
    {
	gtk_clist_get_text( (GtkCList *)user_data->log_list_clist, GPOINTER_TO_INT(GTK_CLIST(user_data->log_list_clist)->selection->data), 0, &name);
	show_log_window(name, DATE);
	return;
    }
    else
    {
	gtk_clist_get_text( (GtkCList *)user_data->log_list_clist, GPOINTER_TO_INT(GTK_CLIST(user_data->log_list_clist)->selection->data), 0, &name);
	show_log_window(name, NAME);
    }

}


void
on_log_refresh_button_clicked          (GtkButton       *button,
                                        log_window_data   *user_data)
{
    if ( user_data->date )
    {
	load_log_for_list(user_data, DATE);
    }
    else
    {
	load_log_for_list(user_data, NAME);
    }
}

