/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        


#include "constants.h"
#include "callbacks.h"


void copy_receiver_entry(GtkButton  *button, gpointer user_data)
{
    extern GtkWidget  *list_receiver_clist;
    FILE  *fp;

    gchar *database_entry;
    gchar *list_data[RECEIVER_FIELDS];
    gchar *uid;
    gchar *nuid = NULL;
    gint  field, id;
    gchar *user_id;
    gchar *buffer;
    gint  ret_value = 0;
    gchar *main_gui_data[1][3];
    gchar *r_data[1][5];
    gchar *service_name, *service_line;
    gint  i;

    if (GTK_CLIST(list_receiver_clist)->selection == NULL)
    {
	generic_error("\n  You must select a receiver to copy \n", "G-Page Error");
	return;
    }

    database_entry = g_malloc(MAX_LENGTH);
    uid = g_malloc(MAX_FIELD_LENGTH);

    gtk_clist_get_text( (GtkCList *)list_receiver_clist, GPOINTER_TO_INT(GTK_CLIST(list_receiver_clist)->selection->data), 4, &user_id);
    strcpy(uid, user_id);

    if ( ( fp = get_file_pointer("RECEIVER.dat", "r") ) == NULL)
	return;

    while ( ( buffer = read_file_by_line(fp)) != NULL )
    {
	if ( !match_in_string(buffer, uid, RECEIVER_FIELDS, 1, ',') )
	{
	    for (field = 0; field < RECEIVER_FIELDS; field++)
		list_data[field] = g_malloc(MAX_FIELD_LENGTH);
	    list_data[1] = g_realloc(list_data[1], MAX_FIELD_LENGTH + 5);
	    ret_value = get_fields_from_string(list_data, buffer, RECEIVER_FIELDS, ','); 
	    if (ret_value == 1)
	    {
		update_status_line("Error corrupt database: RECEIVER.dat");
		g_free(uid);
		g_free(database_entry);
		for (field = 0; field < RECEIVER_FIELDS; field++)
		    g_free(list_data[field]);
		g_free(buffer);
		return;
	    }
	    else
	    {
		id = get_id("RECEIVER");
		nuid = g_strdup_printf("%d", id);

		strcpy(database_entry, nuid);
		strcat(database_entry, ",");
		strcat(list_data[1], " copy");
		strcat(database_entry, list_data[1]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[2]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[3]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[4]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[5]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[6]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[7]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[8]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[9]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[10]);
		strcat(database_entry, ",0,0,0,0");
		fclose(fp);
		break;
	    }
	}
	g_free(buffer);
    }

    add_data(database_entry, "RECEIVER.dat");

    main_gui_data[0][0] = g_strdup(nuid);
    main_gui_data[0][1] = g_strdup(" ");
    main_gui_data[0][2] = g_strdup(list_data[1]);
    
    gtk_clist_append( (GtkCList *)receiver_clist, main_gui_data[0]);

    g_free(main_gui_data[0][0]);
    g_free(main_gui_data[0][1]);
    g_free(main_gui_data[0][2]);

    for ( i = 0; i < 5; i++)
	r_data[0][i] = g_malloc(MAX_FIELD_LENGTH);

    service_line = get_uid_line("SERVICE.dat", list_data[3], SERVICE_FIELDS, 0, MAX_LENGTH);
    service_name = get_field(service_line, SERVICE_FIELDS, 2);
    g_free(service_line);
    
    strcpy(r_data[0][0], list_data[1]);
    strcpy(r_data[0][1], list_data[2]);
    strcpy(r_data[0][2] ,list_data[4]);
    strcpy(r_data[0][3] ,service_name);
    strcpy(r_data[0][4] ,nuid);
	
    gtk_clist_unselect_all(GTK_CLIST(list_receiver_clist)); 
    gtk_clist_append( (GtkCList *)list_receiver_clist, r_data[0]);

    for ( i = 0; i < 5; i++)
	g_free(r_data[0][i]);

    for (field = 0; field < RECEIVER_FIELDS; field++)
	g_free(list_data[field]);
    g_free(database_entry);
    g_free(uid);
    g_free(nuid);
    return;
}


void
on_add_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
    list_receiver_call();
    
}


void
on_edit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    extern GtkWidget  *list_receiver_clist;

    receiver_text *receiver_data;
    FILE *fp;
    gchar *buffer;
    gchar *list_data[RECEIVER_FIELDS];
    gint ret_value = 0;
    gint field, index;
    gchar *user_id;
    gchar *uid;


    if (GTK_CLIST(list_receiver_clist)->selection == NULL)
    {
	generic_error("\n  You must select a receiver to edit \n", "G-Page Error");
	return;
    }

    receiver_data = g_malloc(sizeof(*receiver_data));
    
    uid = g_malloc(MAX_FIELD_LENGTH);
    gtk_clist_get_text( (GtkCList *)list_receiver_clist, GPOINTER_TO_INT(GTK_CLIST(list_receiver_clist)->selection->data), 4, &user_id);
    strcpy(uid, user_id);

    if ( ( fp = get_file_pointer("RECEIVER.dat", "r") ) == NULL)
	return;

    while ( ( buffer = read_file_by_line(fp)) != NULL )
    {
	if ( !match_in_string(buffer, uid, RECEIVER_FIELDS, 1, ',') )
	{
	    for (field = 0; field < RECEIVER_FIELDS; field++)
		list_data[field] = g_malloc(MAX_FIELD_LENGTH);
	    ret_value = get_fields_from_string(list_data, buffer, RECEIVER_FIELDS, ','); 
	    if (ret_value == 1)
	    {
		update_status_line("Error corrupt database: RECEIVER.dat");
		g_free(receiver_data);
		g_free(uid);
		for (field = 0; field < RECEIVER_FIELDS; field++)
		    g_free(list_data[field]);
		g_free(buffer);
		return;
	    }
	    else
	    {

		receiver_data->uid = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->uid, list_data[0]);

		receiver_data->receiver_name = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->receiver_name, list_data[1]);
		
		receiver_data->receiver_number = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->receiver_number, list_data[2]);

		receiver_data->sid = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->sid, list_data[3]);

		receiver_data->receiver_smtp = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->receiver_smtp, list_data[4]);

		receiver_data->autosplit = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->autosplit, list_data[5]);

		receiver_data->checkbutton_wctp = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->checkbutton_wctp, list_data[6]);

		receiver_data->checkbutton_snpp = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->checkbutton_snpp, list_data[7]);

		receiver_data->checkbutton_smtp = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->checkbutton_smtp, list_data[8]);

		receiver_data->radio_wctp_one_way = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->radio_wctp_one_way, list_data[9]);

		receiver_data->radio_snpp_one_way = g_malloc(MAX_FIELD_LENGTH);
		strcpy(receiver_data->radio_snpp_one_way, list_data[10]);

		fclose(fp);
		break;
	    }
	}
	g_free(buffer);
    }
    
    receiver_data->popup_flag = 0;
    edit_receiver(receiver_data);

    for (index = 0; index < RECEIVER_FIELDS; index++)
	g_free(list_data[index]);

}


void
on_okay_button_clicked                 (GtkWidget       *window,
                                        gpointer         user_data)
{
    
    gtk_widget_destroy(GTK_WIDGET(user_data));
}

void delete_receiver_popup(GtkWidget *w, gchar *id)
{

    gint    return_data = 0;
    
    return_data =  edit_item(id, "RECEIVER.dat", RECEIVER_FIELDS, 1, NULL, DELETE, ','); 
    recycle_id("RECEIVER", id);
    delete_receiver_from_groups(id);    
    delete_rec_by_id(id);	
}

void confirm_receiver_delete_popup(gchar *id)
{
    GtkWidget *confirm_box;

    confirm_box = generic_confirm_delete(NULL, "receiver", id);
    if ( confirm_box != NULL )
	gtk_widget_show(confirm_box);
}

void confirm_receiver_delete(void)
{
    extern GtkWidget  *list_receiver_clist;

    GtkWidget  *confirm_box;

    confirm_box = generic_confirm_delete(list_receiver_clist, "receiver", NULL);
    if ( confirm_box != NULL )
	gtk_widget_show(confirm_box);
}

void
on_delete_button_clicked                 (GtkWidget       *confirm_box,
                                        gpointer         user_data)
{
    extern GtkWidget  *list_receiver_clist;

    gint   return_data = 0;
    gchar  *receiver_id = "";
    gchar  *temp_id = "";
    gint   row_selected = 0;
    
    temp_id = g_malloc(MAX_FIELD_LENGTH);
    receiver_id = g_malloc(MAX_FIELD_LENGTH);

    row_selected = GPOINTER_TO_INT(GTK_CLIST(list_receiver_clist)->selection->data);
    gtk_clist_get_text(GTK_CLIST(list_receiver_clist), row_selected, 4, &receiver_id);
    strcpy(temp_id, receiver_id);
    return_data =  edit_item(receiver_id, "RECEIVER.dat", RECEIVER_FIELDS, 1, NULL, DELETE, ','); 
    if (!return_data)
    {
	return_data = recycle_id("RECEIVER", receiver_id);
	gtk_clist_remove( GTK_CLIST(list_receiver_clist), row_selected);

	delete_rec_by_id(temp_id);

    }
    gtk_widget_destroy(confirm_box);
    delete_receiver_from_groups(temp_id);
    g_free(temp_id);
}


void
on_list_cancel_button_clicked               (GtkWidget       *window,
					     gpointer         user_data)
{
    
    gtk_widget_destroy(GTK_WIDGET(user_data));

}

void  delete_receiver_from_groups(gchar *receiver_id)
{
    FILE       *fp, *fp_t;
    gchar      *line, temp_line[MAX_LENGTH_GROUP_DATA];
    gint       x;
    gint       group_num = 0;
    gchar      *gid, *gname;
    gchar      *t_line;
    uid_list   *temp_array;
    uid_list   *head;

    temp_array = get_uid_node();
    head = temp_array;

    gid = g_malloc(MAX_FIELD_LENGTH);
    gname = g_malloc(MAX_FIELD_LENGTH);

    if ( ( fp = get_file_pointer("GROUP.dat", "r")) == NULL)
    {
	g_free(gid);
	g_free(gname);
	return;
    }

    fp_t = get_temp_file();

    if ( fp_t == NULL )
    {
	g_free(gid);
	g_free(gname);
	return;
    }


    while ( ( line = read_big_file_by_line(fp, MAX_LENGTH)) != NULL )
    {
	get_name_id(gid, gname, line);

	memset(temp_line, '\0', sizeof(temp_line));
	strcpy(temp_line, gid);
	strcat(temp_line, ",");
	strcat(temp_line, gname);
	strcat(temp_line, ",");

	g_free(line);
	group_num = parse_group(gid, temp_array);
	temp_array = head;

/*
 *  If we only have one receiver in a group and that receiver is deleted we
 *  need to delete the group.
 */
	if ( group_num == 1 )
	{
	    if ( strcmp(receiver_id, temp_array->uid) )
	    {
		strcat(temp_line, temp_array->uid);
		strcat(temp_line, "\n");
		fputs(temp_line, fp_t);
	    }
	    else
	    {
		delete_rec_by_id(gid);
		recycle_id("GROUP", (gid + 1) ); /* Skip the G at the first position */
	    }
	}
	else
	{
	    for ( x = 0; x < group_num; x++ )
	    {
		if ( strcmp(receiver_id, temp_array->uid) )
		{
		    strcat(temp_line, temp_array->uid);
		    strcat(temp_line, ",");
		}
		temp_array = temp_array->next;
	    }
	    temp_line[strlen(temp_line)-1] = '\n';
	    fputs(temp_line, fp_t);
	} 
	while( head->next )
	{
	    temp_array = head->next;
	    g_free(head->uid);
	    g_free(head);
	    head = temp_array;
	}
	g_free(head);

	temp_array = get_uid_node();
	head = temp_array;
    }

    g_free(head->uid);
    g_free(head);

    fclose(fp);
    t_line = g_malloc(MAX_LENGTH);
    rewind(fp_t);
    if ( (fp = get_file_pointer("GROUP.dat", "w")) == NULL)
    {
	fclose(fp_t);
	g_free(t_line);
	return;
    }

    while (fgets(t_line, MAX_LENGTH, fp_t))
      fputs(t_line, fp);

    g_free(t_line);
    fclose(fp);
    fclose(fp_t);

    g_free(gname);
    g_free(gid);

}


void on_click_column(GtkWidget *w, gint col, gpointer data)
{
    extern GtkWidget *list_receiver_clist;


    gtk_clist_set_sort_column (GTK_CLIST(list_receiver_clist), col);
    gtk_clist_clear(GTK_CLIST(list_receiver_clist));
    gtk_clist_freeze(GTK_CLIST(list_receiver_clist));
    load_list_clist(GTK_CLIST(list_receiver_clist));
    gtk_clist_thaw(GTK_CLIST(list_receiver_clist));

}


