/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

void list_receivers(void)
{
    extern GtkWidget *list_receiver_clist;

    GtkWidget *list_receivers_dialog;
    list_receivers_dialog = create_list_receivers();
    load_list_clist(GTK_CLIST(list_receiver_clist));

    GTK_CLIST(list_receiver_clist)->focus_row = 0;
    gtk_clist_moveto(GTK_CLIST(list_receiver_clist), 0, 0, 0.0, 0.0);

    gtk_widget_show(list_receivers_dialog);
}

GtkWidget*
create_list_receivers (void)
{
  extern GtkWidget *list_receiver_clist;

  GtkWidget *list_receivers;
  GtkWidget *hbox10;
  GtkWidget *scrolledwindow7;
  GtkWidget *name_label;
  GtkWidget *number_label;
  GtkWidget *service_label;
  GtkWidget *smtp_label;
  GtkWidget *vbox11;
  GtkWidget *vbuttonbox2;
  GtkWidget *add_button;
  GtkWidget *edit_button;
  GtkWidget *delete_button;
  GtkWidget *copy_button;
  GtkWidget *hbuttonbox5;
  GtkWidget *okay_button;

  list_receivers = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (list_receivers), "list_receivers", list_receivers);
  gtk_window_set_title (GTK_WINDOW (list_receivers), "Receiver List");
  gtk_window_set_modal (GTK_WINDOW (list_receivers), TRUE);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_container_add (GTK_CONTAINER (list_receivers), hbox10);

  scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow7);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "scrolledwindow7", scrolledwindow7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow7);
  gtk_box_pack_start (GTK_BOX (hbox10), scrolledwindow7, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow7, 580, 300);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  list_receiver_clist = gtk_clist_new (5);
  gtk_clist_set_sort_column (GTK_CLIST(list_receiver_clist), 0);
  gtk_clist_set_auto_sort(GTK_CLIST(list_receiver_clist), TRUE);

  gtk_widget_ref (list_receiver_clist);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "list_receiver_clist", list_receiver_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_receiver_clist);
  gtk_clist_set_column_visibility (GTK_CLIST(list_receiver_clist), 4, FALSE);
  gtk_container_add (GTK_CONTAINER (scrolledwindow7), list_receiver_clist);
  gtk_clist_set_column_width (GTK_CLIST (list_receiver_clist), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST (list_receiver_clist), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (list_receiver_clist), 2, 165);
  gtk_clist_set_column_width (GTK_CLIST (list_receiver_clist), 3, 110);
  gtk_clist_set_column_width (GTK_CLIST (list_receiver_clist), 4, 20);
  gtk_clist_column_titles_show (GTK_CLIST (list_receiver_clist));


  name_label = gtk_label_new ("Name");
  gtk_widget_ref (name_label);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "name_label", name_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (name_label);
  gtk_clist_set_column_widget (GTK_CLIST (list_receiver_clist), 0, name_label);
  gtk_widget_set_usize (name_label, 80, 15);

  number_label = gtk_label_new ("Number");
  gtk_widget_ref (number_label);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "number_label", number_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (number_label);
  gtk_clist_set_column_widget (GTK_CLIST (list_receiver_clist), 1, number_label);

  smtp_label = gtk_label_new ("Email Adr");
  gtk_widget_ref (smtp_label);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "smtp_label", smtp_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (smtp_label);
  gtk_clist_set_column_widget (GTK_CLIST (list_receiver_clist), 2, smtp_label);

  service_label = gtk_label_new ("Service");
  gtk_widget_ref (service_label);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "service_label", service_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (service_label);
  gtk_clist_set_column_widget (GTK_CLIST (list_receiver_clist), 3, service_label);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_box_pack_start (GTK_BOX (hbox10), vbox11, TRUE, TRUE, 0);

  vbuttonbox2 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox2);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "vbuttonbox2", vbuttonbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox11), vbuttonbox2, TRUE, FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox2), GTK_BUTTONBOX_SPREAD);

  add_button = gtk_button_new_with_label ("Add");
  gtk_widget_ref (add_button);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "add_button", add_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox2), add_button);
  GTK_WIDGET_SET_FLAGS (add_button, GTK_CAN_DEFAULT);

  copy_button = gtk_button_new_with_label ("Copy");
  gtk_widget_ref (copy_button);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "copy_button", copy_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copy_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox2), copy_button);
  GTK_WIDGET_SET_FLAGS (copy_button, GTK_CAN_DEFAULT);

  edit_button = gtk_button_new_with_label ("Edit");
  gtk_widget_ref (edit_button);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "edit_button", edit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox2), edit_button);
  GTK_WIDGET_SET_FLAGS (edit_button, GTK_CAN_DEFAULT);

  delete_button = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (delete_button);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "delete_button", delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox2), delete_button);
  GTK_WIDGET_SET_FLAGS (delete_button, GTK_CAN_DEFAULT);

  hbuttonbox5 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox5);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "hbuttonbox5", hbuttonbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox5);
  gtk_box_pack_start (GTK_BOX (vbox11), hbuttonbox5, TRUE, TRUE, 0);
  gtk_widget_set_usize (hbuttonbox5, 100, -2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox5), GTK_BUTTONBOX_SPREAD);

  okay_button = gtk_button_new_with_label ("OK");
  gtk_widget_ref (okay_button);
  gtk_object_set_data_full (GTK_OBJECT (list_receivers), "okay_button", okay_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (okay_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox5), okay_button);
  GTK_WIDGET_SET_FLAGS (okay_button, GTK_CAN_DEFAULT);


  gtk_signal_connect (GTK_OBJECT (list_receiver_clist), "click_column",
                      GTK_SIGNAL_FUNC (on_click_column),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (add_button), "clicked",
                      GTK_SIGNAL_FUNC (on_add_button_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (edit_button), "clicked",
                      GTK_SIGNAL_FUNC (on_edit_button_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (okay_button), "clicked",
                      GTK_SIGNAL_FUNC (on_okay_button_clicked),
                      list_receivers);

  gtk_signal_connect (GTK_OBJECT (delete_button), "clicked",
                      GTK_SIGNAL_FUNC (confirm_receiver_delete),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (copy_button), "clicked",
                      GTK_SIGNAL_FUNC (copy_receiver_entry),
                      NULL);


  gtk_widget_grab_focus (okay_button);
  return list_receivers;
}



