/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"


void list_scheduled()
{

    GtkWidget  *sch_list;

    sch_list = create_scheduled_paging();

    if ( sch_list != NULL )
	gtk_widget_show(sch_list);
}


GtkWidget*
create_scheduled_paging (void)
{
  GtkWidget *scheduled_paging;
  GtkWidget *hbox2;
  GtkWidget *vbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *msg_list;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *frame2;
  GtkWidget *table1;
  GtkWidget *time_label;
  GtkWidget *sent_label;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *scrolledwindow3;
  GtkWidget *text1;
  GtkWidget *vbuttonbox1;
  GtkWidget *delete_schedule;
  GtkWidget *status_schedule;
  GtkWidget *view_button;
  GtkWidget *okay_schedule;

  gint      width = 600;
  gint      height = 320;

  sched_win_data   *sched_info;

  sched_info = g_malloc(sizeof(*sched_info));

  scheduled_paging = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (scheduled_paging), "scheduled_paging", scheduled_paging);
  gtk_window_set_title (GTK_WINDOW (scheduled_paging), "Manage Scheduled Messages");

  gtk_widget_set_usize (scheduled_paging, width, height);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (scheduled_paging), hbox2);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox1, TRUE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  msg_list = gtk_clist_new (7);
  gtk_widget_ref (msg_list);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "msg_list", msg_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_set_usize (msg_list, width, (height/2.5));
  gtk_widget_show (msg_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), msg_list);
  gtk_container_set_border_width (GTK_CONTAINER (msg_list), 1);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 0, 130);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 1, 150);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 2, 70);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 3, 130);

  gtk_clist_set_column_visibility (GTK_CLIST(msg_list), 4, FALSE);
  gtk_clist_set_column_visibility (GTK_CLIST(msg_list), 5, FALSE);
  gtk_clist_set_column_visibility (GTK_CLIST(msg_list), 6, FALSE);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 4, 1);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 5, 1);
  gtk_clist_set_column_width (GTK_CLIST (msg_list), 6, 1);
  gtk_clist_column_titles_show (GTK_CLIST (msg_list));

  label1 = gtk_label_new ("To:");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_clist_set_column_widget (GTK_CLIST (msg_list), 0, label1);

  label2 = gtk_label_new ("Time:");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (msg_list), 1, label2);

  label3 = gtk_label_new ("Recurring:");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (msg_list), 2, label3);

  label4 = gtk_label_new ("Msg Preview:");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_clist_set_column_widget (GTK_CLIST (msg_list), 3, label4);

  frame2 = gtk_frame_new ("Recurring Page Statistics ");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame2), table1);


  time_label = gtk_label_new (" ");
  gtk_widget_ref (time_label);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "time_label", time_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (time_label);
  gtk_table_attach (GTK_TABLE (table1), time_label, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (time_label), 0, 0.5);


  sent_label = gtk_label_new (" ");
  gtk_widget_ref (sent_label);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "sent_label", sent_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sent_label);
  gtk_table_attach (GTK_TABLE (table1), sent_label, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (sent_label), 0, 0.5);


  label7 = gtk_label_new ("Number of times sent: ");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table1), label7, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label7), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label7), 10, 4);

  label8 = gtk_label_new ("Next attempt to send: ");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table1), label8, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label8), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label8), 10, 4);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), text1);
  gtk_text_set_editable (GTK_TEXT (text1), FALSE);

  vbuttonbox1 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "vbuttonbox1", vbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox1);
  gtk_box_pack_start (GTK_BOX (hbox2), vbuttonbox1, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox1), GTK_BUTTONBOX_SPREAD);

  delete_schedule = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (delete_schedule);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "delete_schedule", delete_schedule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_schedule);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), delete_schedule);
  GTK_WIDGET_SET_FLAGS (delete_schedule, GTK_CAN_DEFAULT);

  status_schedule = gtk_button_new_with_label ("Status");
  gtk_widget_ref (status_schedule);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "status_schedule", status_schedule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_schedule);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), status_schedule);
  GTK_WIDGET_SET_FLAGS (status_schedule, GTK_CAN_DEFAULT);

  view_button = gtk_button_new_with_label ("View");
  gtk_widget_ref (view_button);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "view_button", view_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), view_button);
  GTK_WIDGET_SET_FLAGS (view_button, GTK_CAN_DEFAULT);

  okay_schedule = gtk_button_new_with_label ("OK");
  gtk_widget_ref (okay_schedule);
  gtk_object_set_data_full (GTK_OBJECT (scheduled_paging), "okay_schedule", okay_schedule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (okay_schedule);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), okay_schedule);
  GTK_WIDGET_SET_FLAGS (okay_schedule, GTK_CAN_DEFAULT);

  if ( load_scheduled_pages(msg_list) )
      return(NULL);

  sched_info->text_box    = text1;
  sched_info->clist       = msg_list;
  sched_info->count_label = sent_label;
  sched_info->time_label  = time_label;
  sched_info->main_win    = scheduled_paging;

  gtk_signal_connect (GTK_OBJECT (delete_schedule), "clicked",
                      GTK_SIGNAL_FUNC (on_delete_schedule_clicked),
                      sched_info);

  gtk_signal_connect (GTK_OBJECT (okay_schedule), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_schedule_clicked),
                      sched_info);
  
  gtk_signal_connect (GTK_OBJECT (status_schedule), "clicked",
                      GTK_SIGNAL_FUNC (on_status_schedule_clicked),
                      sched_info);

  gtk_signal_connect (GTK_OBJECT (view_button), "clicked",
                      GTK_SIGNAL_FUNC (on_view_button_clicked),
                      sched_info);

  gtk_widget_grab_focus(okay_schedule);
  return scheduled_paging;
}


