/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

void list_services(void)
{
    extern GtkWidget *list_service_clist;

    GtkWidget *list_services_dialog;

    list_services_dialog = create_list_service_dialog();
    load_list_service(GTK_CLIST(list_service_clist));
    gtk_widget_show(list_services_dialog);

}

GtkWidget*
create_list_service_dialog (void)
{
  extern GtkWidget *list_service_clist;

  GtkWidget *list_service_dialog;
  GtkWidget *hbox11;
  GtkWidget *scrolledwindow8;
  GtkWidget *label_service;
  GtkWidget *labeltap;
  GtkWidget *labelsnpp;
  GtkWidget *labelsmtp;
  GtkWidget *labelmaxmsg;
  GtkWidget *vbox12;
  GtkWidget *vbuttonbox3;
  GtkWidget *list_add_service;
  GtkWidget *list_edit_service;
  GtkWidget *list_delete_service;
  GtkWidget *copy_service;
  GtkWidget *hbuttonbox6;
  GtkWidget *list_ok_service;

  list_service_dialog = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (list_service_dialog), "list_service_dialog", list_service_dialog);
  gtk_window_set_title (GTK_WINDOW (list_service_dialog), "List Services");
  gtk_window_set_modal (GTK_WINDOW (list_service_dialog), TRUE);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (list_service_dialog), hbox11);

  scrolledwindow8 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow8);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "scrolledwindow8", scrolledwindow8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow8);
  gtk_box_pack_start (GTK_BOX (hbox11), scrolledwindow8, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow8, 550, 300);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow8), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  list_service_clist = gtk_clist_new (6);
  gtk_clist_set_sort_column (GTK_CLIST(list_service_clist), 0);
  gtk_clist_set_auto_sort(GTK_CLIST(list_service_clist), TRUE);

  gtk_widget_ref (list_service_clist);
  gtk_clist_set_column_visibility (GTK_CLIST(list_service_clist), 5, FALSE);
  gtk_clist_set_column_visibility (GTK_CLIST(list_service_clist), 4, FALSE);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "list_service_clist", list_service_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_service_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow8), list_service_clist);
  gtk_clist_set_column_width (GTK_CLIST (list_service_clist), 0, 170);
  gtk_clist_set_column_width (GTK_CLIST (list_service_clist), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (list_service_clist), 2, 160);
  gtk_clist_set_column_width (GTK_CLIST (list_service_clist), 3, 50);
  gtk_clist_set_column_width (GTK_CLIST (list_service_clist), 4, 10);
  gtk_clist_set_column_justification (GTK_CLIST (list_service_clist), 3, GTK_JUSTIFY_CENTER);
  gtk_clist_set_column_width (GTK_CLIST (list_service_clist), 5, 10);
  gtk_clist_column_titles_show (GTK_CLIST (list_service_clist));

  label_service = gtk_label_new ("Service");
  gtk_widget_ref (label_service);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "label_service", label_service,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_service);
  gtk_clist_set_column_widget (GTK_CLIST (list_service_clist), 0, label_service);

  labeltap = gtk_label_new ("Wctp Url");
  gtk_widget_ref (labeltap);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "labeltap", labeltap,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labeltap);
  gtk_clist_set_column_widget (GTK_CLIST (list_service_clist), 1, labeltap);

  labelsnpp = gtk_label_new ("Snpp Address");
  gtk_widget_ref (labelsnpp);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "labelsnpp", labelsnpp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labelsnpp);
  gtk_clist_set_column_widget (GTK_CLIST (list_service_clist), 2, labelsnpp);

  labelsmtp = gtk_label_new ("Max Msg");
  gtk_widget_ref (labelsmtp);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "labelsmtp", labelsmtp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labelsmtp);
  gtk_clist_set_column_widget (GTK_CLIST (list_service_clist), 3, labelsmtp);

  labelmaxmsg = gtk_label_new ("empty");
  gtk_widget_ref (labelmaxmsg);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "labelmaxmsg", labelmaxmsg,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (labelmaxmsg);
  gtk_clist_set_column_widget (GTK_CLIST (list_service_clist), 4, labelmaxmsg);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (hbox11), vbox12, TRUE, TRUE, 0);

  vbuttonbox3 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox3);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "vbuttonbox3", vbuttonbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox3);
  gtk_box_pack_start (GTK_BOX (vbox12), vbuttonbox3, TRUE, FALSE, 0);
  gtk_widget_set_usize (vbuttonbox3, 60, 136);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox3), GTK_BUTTONBOX_SPREAD);

  list_add_service = gtk_button_new_with_label ("Add");
  gtk_widget_ref (list_add_service);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "list_add_service", list_add_service,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_add_service);
  gtk_container_add (GTK_CONTAINER (vbuttonbox3), list_add_service);
  GTK_WIDGET_SET_FLAGS (list_add_service, GTK_CAN_DEFAULT);

  copy_service = gtk_button_new_with_label ("Copy");
  gtk_widget_ref (copy_service);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "copy_service", copy_service,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copy_service);
  gtk_container_add (GTK_CONTAINER (vbuttonbox3), copy_service);
  GTK_WIDGET_SET_FLAGS (copy_service, GTK_CAN_DEFAULT);

  list_edit_service = gtk_button_new_with_label ("Edit");
  gtk_widget_ref (list_edit_service);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "list_edit_service", list_edit_service,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_edit_service);
  gtk_container_add (GTK_CONTAINER (vbuttonbox3), list_edit_service);
  GTK_WIDGET_SET_FLAGS (list_edit_service, GTK_CAN_DEFAULT);

  list_delete_service = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (list_delete_service);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "list_delete_service", list_delete_service,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_delete_service);
  gtk_container_add (GTK_CONTAINER (vbuttonbox3), list_delete_service);
  GTK_WIDGET_SET_FLAGS (list_delete_service, GTK_CAN_DEFAULT);

  hbuttonbox6 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox6);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "hbuttonbox6", hbuttonbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox6);
  gtk_box_pack_start (GTK_BOX (vbox12), hbuttonbox6, TRUE, TRUE, 0);
  //gtk_box_pack_start (GTK_BOX (vbox12), hbuttonbox6, FALSE, TRUE, 0);
  gtk_widget_set_usize (hbuttonbox6, 100, -2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox6), GTK_BUTTONBOX_SPREAD);

  list_ok_service = gtk_button_new_with_label ("OK");
  gtk_widget_ref (list_ok_service);
  gtk_object_set_data_full (GTK_OBJECT (list_service_dialog), "list_ok_service", list_ok_service,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_ok_service);
  gtk_container_add (GTK_CONTAINER (hbuttonbox6), list_ok_service);
  GTK_WIDGET_SET_FLAGS (list_ok_service, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (list_service_clist), "click_column",
                      GTK_SIGNAL_FUNC (on_click_column_service),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (list_add_service), "clicked",
                      GTK_SIGNAL_FUNC (on_list_add_service_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (list_edit_service), "clicked",
                      GTK_SIGNAL_FUNC (on_list_edit_service_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (list_delete_service), "clicked",
                      GTK_SIGNAL_FUNC (on_list_delete_confirm),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (list_ok_service), "clicked",
                      GTK_SIGNAL_FUNC (on_list_ok_service_clicked),
                      list_service_dialog);

  gtk_signal_connect (GTK_OBJECT (copy_service), "clicked",
                      GTK_SIGNAL_FUNC (duplicate_service_entry),
                      list_service_dialog);

  gtk_widget_grab_focus (list_ok_service);
  return list_service_dialog;
}

