/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        


#include "constants.h"
#include "callbacks.h"

void duplicate_service_entry(GtkButton  *button, gpointer user_data)
{
    extern GtkWidget *list_service_clist;

    FILE  *fp;
    gchar *buffer;
    gchar *list_data[SERVICE_FIELDS];
    gchar *service_id;
    gchar *sid = NULL;
    gchar *database_entry;
    gchar *slist_data[1][6];
    gint  ret_value = 0;
    gint  field;
    gint  id, i;


    if (GTK_CLIST(list_service_clist)->selection == NULL)
    {
	generic_error("\n  You must select a service to copy  \n", "G-Page Error");
	return;
    }

    gtk_clist_get_text(GTK_CLIST(list_service_clist), GPOINTER_TO_INT(GTK_CLIST(list_service_clist)->selection->data), 5, &service_id);

    database_entry = g_malloc(MAX_LENGTH);
    
    if ( ( fp = get_file_pointer("SERVICE.dat", "r") ) == NULL)
	return;

    while ( ( buffer = read_file_by_line(fp)) != NULL )
    {
	if ( !match_in_string(buffer, service_id, SERVICE_FIELDS, 1, ',') )
	{
	    for (field = 0; field < SERVICE_FIELDS; field++)
		list_data[field] = g_malloc(MAX_FIELD_LENGTH);
	    list_data[SERVICE_NAME] = g_realloc(list_data[SERVICE_NAME], MAX_FIELD_LENGTH + 5);

	    ret_value = get_fields_from_string(list_data, buffer, SERVICE_FIELDS, ','); 
	    if (ret_value == 1)
	    {
		update_status_line("Error corrupt database: SERVICE.dat");
		g_free(buffer);
		g_free(database_entry);
		for (field = 0; field < SERVICE_FIELDS; field++)
		    g_free(list_data[field]);
		return;
		g_free(buffer);
	    }
	    else
	    {
		id = get_id("TERMINAL");
		sid = g_strdup_printf("%d", id);

		strcpy(database_entry, sid);
		strcat(database_entry, ",");
		strcat(list_data[SERVICE_NAME], " copy");
		strcat(database_entry, list_data[SERVICE_NAME]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_WCTP_URL]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_MAX_MSG]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_TAP]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_SNPP]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_SMTP]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_SNPP_URL]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_SNPP_PORT]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_SNPP_PASS]);
		strcat(database_entry, ",");
		strcat(database_entry, list_data[SERVICE_PASS_YES_NO]);
		strcat(database_entry, ",0,0,0,0"); /* These are empty fields */

		add_data(database_entry, "SERVICE.dat");
		fclose(fp);
		break;
	    }
	}
	g_free(buffer);
    }

    for ( i = 0; i < 6; i++)
	slist_data[0][i] = g_malloc(MAX_FIELD_LENGTH);

    slist_data[0][0] = g_realloc(slist_data[0][0], MAX_FIELD_LENGTH + 5);    
    strcpy(slist_data[0][0], list_data[SERVICE_NAME]);
    strcpy(slist_data[0][1], list_data[SERVICE_WCTP_URL]);
    strcpy(slist_data[0][2], list_data[SERVICE_SNPP_URL]);;
    strcpy(slist_data[0][3], list_data[SERVICE_MAX_MSG]);
    strcpy(slist_data[0][4], list_data[SERVICE_MAX_MSG]); 
    strcpy(slist_data[0][5], sid);
    
    gtk_clist_append( (GtkCList *)list_service_clist, slist_data[0]);

    for ( i = 0; i < 6; i++)
	g_free(slist_data[0][i]);

    for (field = 0; field < SERVICE_FIELDS; field++)
	g_free(list_data[field]);

    g_free(database_entry);
    g_free(sid);

    return;
}

void
on_list_add_service_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
    add_service_list();
}


void
on_list_edit_service_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
    extern GtkWidget *list_service_clist;

    service_text *service_data;
    FILE *fp;
    gchar *buffer;
    gchar *list_data[SERVICE_FIELDS];
    gint ret_value = 0;
    gint field, index;
    gchar *service_id;

    if (GTK_CLIST(list_service_clist)->selection == NULL)
    {
	generic_error("\n  You must select a service to edit \n", "G-Page Error");
	return;
    }

    gtk_clist_get_text(GTK_CLIST(list_service_clist), GPOINTER_TO_INT(GTK_CLIST(list_service_clist)->selection->data), 5, &service_id);

    service_data = g_malloc(sizeof(*service_data));

    if ( ( fp = get_file_pointer("SERVICE.dat", "r") ) == NULL)
	return;

    while ( ( buffer = read_file_by_line(fp)) != NULL )
    {
	if ( !match_in_string(buffer, service_id, SERVICE_FIELDS, 1, ',') )
	{
	    for (field = 0; field < SERVICE_FIELDS; field++)
		list_data[field] = g_malloc(MAX_FIELD_LENGTH);

	    ret_value = get_fields_from_string(list_data, buffer, SERVICE_FIELDS, ','); 
	    if (ret_value == 1)
	    {
		update_status_line("Error corrupt database: SERVICE.dat");
		g_free(service_data);
		for (field = 0; field < SERVICE_FIELDS; field++)
		    g_free(list_data[field]);
		g_free(buffer);
		return;
	    }
	    else
	    {
		service_data->service_id = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->service_id, list_data[SERVICE_ID]);

		service_data->service_name = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->service_name, list_data[SERVICE_NAME]);
		
		service_data->service_number = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->service_number, list_data[SERVICE_WCTP_URL]);

		service_data->service_wctp = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->service_wctp, list_data[SERVICE_WCTP_URL]);

		service_data->max_msg = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->max_msg, list_data[SERVICE_MAX_MSG]);

		service_data->tap_checkbutton = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->tap_checkbutton, list_data[SERVICE_TAP]);

		service_data->snpp_checkbutton = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->snpp_checkbutton, list_data[SERVICE_SNPP]);

		service_data->smtp_checkbutton = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->smtp_checkbutton, list_data[SERVICE_SMTP]);

		service_data->snpp_url = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->snpp_url, list_data[SERVICE_SNPP_URL]);

		service_data->snpp_port = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->snpp_port, list_data[SERVICE_SNPP_PORT]);

		service_data->snpp_password = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->snpp_password, list_data[SERVICE_SNPP_PASS]);

		service_data->password_checkbutton_yes = g_malloc(MAX_FIELD_LENGTH);
		strcpy(service_data->password_checkbutton_yes, list_data[SERVICE_PASS_YES_NO]);
		
		fclose(fp);
		break;
	    }
	}
	g_free(buffer);
    }

    for (index = 0; index < SERVICE_FIELDS; index++)
	g_free(list_data[index]);


    edit_service(service_data);

}

void on_list_delete_confirm  (GtkButton    *button, gpointer data)
{
    GtkWidget  *confirm_box;

    confirm_box = create_ok_delete();
    if (confirm_box != NULL)	/* If the user selected the cancel button we destroy confirm box
				   thus making it NULL */
	gtk_widget_show(confirm_box);
    return;

}

void
on_list_delete_service_clicked         (GtkWidget       *dialog_window,
                                        gpointer         user_data)
{
    extern GtkWidget *list_service_clist;

    gint return_data;
    extern GtkWidget *receiver_clist;
    gchar *list_service_id;
    gchar *temp_id = "";
    gint  row_selected = -1;
    gint  deleted_some = 0;

    temp_id = g_malloc(MAX_FIELD_LENGTH);

    row_selected = GPOINTER_TO_INT(GTK_CLIST(list_service_clist)->selection->data);
    gtk_clist_get_text(GTK_CLIST(list_service_clist), row_selected, 5, &list_service_id);

    strcpy(temp_id, list_service_id);

    return_data =  edit_item(list_service_id, "SERVICE.dat", SERVICE_FIELDS, 1, NULL, DELETE, ','); 
    if (!return_data)
    {
	return_data = recycle_id("TERMINAL", temp_id);
	gtk_clist_remove((GtkCList *)list_service_clist, row_selected);
	
	deleted_some = delete_receivers_with_service_id(temp_id);
	if ( deleted_some )
	{
	    gtk_clist_freeze(GTK_CLIST(receiver_clist));
	    gtk_clist_clear(GTK_CLIST(receiver_clist));
	    load_receiver_list("RECEIVER.dat", GTK_CLIST(receiver_clist));
	    load_receiver_list("GROUP.dat", GTK_CLIST(receiver_clist));
	    load_main_list_with_pixmaps();
	    gtk_clist_thaw(GTK_CLIST(receiver_clist));

	}
    }
    gtk_widget_destroy(dialog_window);
    g_free(temp_id);
}


void
on_list_ok_service_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{

    gtk_widget_destroy(GTK_WIDGET(user_data));

}


void
on_list_cancel_service_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{

    gtk_widget_destroy(GTK_WIDGET(user_data));

}

void service_list_select_row             (GtkCList        *list_service_clist,
					gint             row,
					gint             column,
					GdkEvent        *event,
					gpointer         user_data)
{
return;
}

void service_list_unselect_row             (GtkCList        *list_service_clist,
					gint             row,
					gint             column,
					GdkEvent        *event,
					gpointer         user_data)
{
    return;
}

void on_click_column_service(GtkWidget *w, gint col, gpointer data)
{
    extern GtkWidget *list_service_clist;


    gtk_clist_set_sort_column (GTK_CLIST(list_service_clist), col);
    gtk_clist_clear(GTK_CLIST(list_service_clist));
    gtk_clist_freeze(GTK_CLIST(list_service_clist));
    load_list_service(GTK_CLIST(list_service_clist));
    gtk_clist_thaw(GTK_CLIST(list_service_clist));

}




