/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"


void pre_defined_msg(void)
{

    GtkWidget   *pre_def_window;

    pre_def_window = create_pre_defined();
    gtk_widget_show(pre_def_window);
}


GtkWidget*
create_pre_defined (void)
{
  GtkWidget    *pre_defined;
  GtkWidget    *vbox30;
  GtkWidget    *hbuttonbox15;
  GtkWidget    *add_pre;
  GtkWidget    *update_pre;
  GtkWidget    *delete_pre;
  GtkWidget    *cancel_pre;
  GtkWidget    *ok_pref;
  GtkWidget    *scrolledwindow14;
  GtkWidget    *pre_def_clist;
  GtkWidget    *def_label;
  GtkWidget    *scrolledwindow15;
  GtkWidget    *pre_defined_text_box;
  GtkWidget    *instruction_label;
  stored_msg   *pre_def_msg_data;

  pre_def_msg_data = g_malloc(sizeof(*pre_def_msg_data));
  
  pre_defined = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (pre_defined), "pre_defined",pre_defined);
  gtk_window_set_title (GTK_WINDOW (pre_defined), "Pre Defined Messages");
  gtk_window_set_modal (GTK_WINDOW (pre_defined), TRUE);

  vbox30 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox30);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "vbox30", vbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox30);
  gtk_container_add (GTK_CONTAINER (pre_defined), vbox30);
  gtk_widget_set_usize (vbox30, 550, 300);

/*
 *   Here is the button box and buttons
 */

  hbuttonbox15 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox15);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "hbuttonbox15", hbuttonbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox15);
  gtk_box_pack_start (GTK_BOX (vbox30), hbuttonbox15, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox15), GTK_BUTTONBOX_START);

  add_pre = gtk_button_new_with_label ("Add");
  gtk_widget_ref (add_pre);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "add_pre", add_pre,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_pre);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), add_pre);
  GTK_WIDGET_SET_FLAGS (add_pre, GTK_CAN_DEFAULT);

  update_pre = gtk_button_new_with_label ("Edit");
  gtk_widget_ref (update_pre);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "update_pre",update_pre,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (update_pre);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), update_pre);
  GTK_WIDGET_SET_FLAGS (update_pre, GTK_CAN_DEFAULT);

  delete_pre = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (delete_pre);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "delete_pre", delete_pre,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_pre);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), delete_pre);
  GTK_WIDGET_SET_FLAGS (delete_pre, GTK_CAN_DEFAULT);

  ok_pref = gtk_button_new_with_label ("Load");
  gtk_widget_ref (ok_pref);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "ok_pref", ok_pref,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ok_pref);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), ok_pref);
  GTK_WIDGET_SET_FLAGS (ok_pref, GTK_CAN_DEFAULT);

  cancel_pre = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancel_pre);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "cancel_pre", cancel_pre,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_pre);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), cancel_pre);
  GTK_WIDGET_SET_FLAGS (cancel_pre, GTK_CAN_DEFAULT);

/*
 *   Here is the message list
 */

  scrolledwindow14 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow14);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "scrolledwindow14", scrolledwindow14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow14);
  gtk_box_pack_start (GTK_BOX (vbox30), scrolledwindow14, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow14), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  pre_def_clist = gtk_clist_new (2);
  gtk_widget_ref (pre_def_clist);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "pre_def_clist", pre_def_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pre_def_clist);
  gtk_clist_set_column_visibility (GTK_CLIST(pre_def_clist), 0, FALSE); 
  gtk_container_add (GTK_CONTAINER (scrolledwindow14), pre_def_clist);
  gtk_clist_set_column_width (GTK_CLIST (pre_def_clist), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (pre_def_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (pre_def_clist));

/*
 *   Load the message list here
 */

  load_pre_def_list(pre_def_clist, "MSG.dat");

/*
 *   Here is the instruction label - this shows up directly above the text box
 */

  instruction_label = gtk_label_new ("Enter new message or edit existing message:");
  gtk_widget_ref (instruction_label);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "instruction_label", instruction_label,
			    (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (instruction_label);
  gtk_box_pack_start (GTK_BOX (vbox30), instruction_label, FALSE, FALSE, 2);

  def_label = gtk_label_new ("Message List:");
  gtk_widget_ref (def_label);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "def_label", def_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (def_label);
  gtk_clist_set_column_widget (GTK_CLIST (pre_def_clist), 1, def_label);
  gtk_label_set_justify (GTK_LABEL (def_label), GTK_JUSTIFY_LEFT);

  scrolledwindow15 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow15);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "scrolledwindow15", scrolledwindow15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow15);
  gtk_box_pack_start (GTK_BOX (vbox30), scrolledwindow15, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow15), 2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow15), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

/*
 *   Here is the text box
 */

  pre_defined_text_box = gtk_text_new (NULL, NULL);
  gtk_widget_ref (pre_defined_text_box);
  gtk_object_set_data_full (GTK_OBJECT (pre_defined), "pre_defined_text_box", pre_defined_text_box,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pre_defined_text_box);
  gtk_container_add (GTK_CONTAINER (scrolledwindow15), pre_defined_text_box);
  gtk_text_set_editable (GTK_TEXT (pre_defined_text_box), TRUE);

  pre_def_msg_data->main_window = pre_defined;
  pre_def_msg_data->msg_list =   pre_def_clist;
  pre_def_msg_data->msg_text_box =   pre_defined_text_box;

  gtk_signal_connect (GTK_OBJECT (add_pre), "clicked",
                      GTK_SIGNAL_FUNC (on_add_pre_clicked),
                      pre_def_msg_data);
  gtk_signal_connect (GTK_OBJECT (update_pre), "clicked",
                      GTK_SIGNAL_FUNC (on_update_pre_clicked),
                      pre_def_msg_data);
  gtk_signal_connect (GTK_OBJECT (delete_pre), "clicked",
                      GTK_SIGNAL_FUNC (on_delete_pre_clicked),
                      pre_def_msg_data);
  gtk_signal_connect (GTK_OBJECT (ok_pref), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_pref_clicked),
                      pre_def_msg_data);
  gtk_signal_connect (GTK_OBJECT (cancel_pre), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_pre_clicked),
                      pre_def_msg_data);

  gtk_widget_grab_focus (pre_defined_text_box);
  return pre_defined;
}

void load_pre_def_list(GtkWidget *list, gchar *file_name)
{
    FILE    *fp;

    gchar   *list_data[2];
    gchar   *line;

 
    if ( ( fp = get_file_pointer(file_name, "r")) == NULL)
    {
	generic_error(" Error opening dat file ", "G-Page Error");
	return;
    }

    while ( (line = (read_file_by_line(fp))) != NULL)
    {
	line[strlen(line) - 1] = '\0';
    
	list_data[0] = g_strdup(" ");
	list_data[1] = g_strdup(line);

	gtk_clist_append(GTK_CLIST(list), list_data);
	
	g_free(list_data[0]);
	g_free(list_data[1]);
	g_free(line);

    }

    fclose(fp);
}

