
/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"
/* #include "back_pix.xpm" */

static void load_pref_tree(GtkWidget *my_tree);

void preferences(GtkWidget *w, gpointer *data)
{
    GtkWidget *pref;
    pref_data *user_pref;
    extern GtkWidget  *qp_hbox;

    user_pref = g_malloc(sizeof(*user_pref));
    user_pref = get_pref_mem(user_pref);
    load_prefs(user_pref);

    pref = create_preferences(user_pref, (gpointer *)qp_hbox);
    gtk_widget_show(pref);
}

/*     new pref window   */
GtkWidget *create_preferences (pref_data *user_data, gpointer *interface_widget)
{
  GtkWidget *label_status_help;
  GtkWidget *hbox_status;
  GtkWidget *preferences;
  GtkWidget *vbox_tree;
  GtkWidget *hbox3;
  GtkWidget *scrolledwindow1;
  GtkWidget *ctree1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label_help;
  GtkWidget *vbox_pref_data;
  //GtkWidget *back_pix;
  GtkWidget *vbox_db;
  GtkWidget *vbox_logs;
  GtkWidget *hbuttonbox1;
  GtkWidget *pref_save_button;
  GtkWidget *pref_apply_button;
  GtkWidget *pref_cancel_button;
  GtkWidget *hbox_db_port;
  GtkWidget *vbox_network_stuff;
  GtkWidget *label_database_help;
  GtkWidget *frame_connect;
  GtkWidget *vbox_connect;
  GtkWidget *hbox_connect;

  GtkWidget *frame25;
  GtkWidget *frame26;
  GtkWidget *frame27;
  GtkWidget *frame_msg_entry;
  GtkWidget *hbox30;
  GtkWidget *hbox31;
  GtkWidget *label64;
  GtkWidget *vbox_sig;
  GtkWidget *frame28;
  GtkWidget *hbox32;

  GtkWidget *frame_network;
  GtkWidget *frame_time;
  GtkWidget *frame_signature;
  GtkWidget *hbox_time;
  GtkWidget *hbox35;
  GtkWidget *hbox_msg_entry;
  GtkWidget *vbox_msg_entry_help;
  GtkWidget *vbox_msg_entry_bottom;
  GtkWidget *label65;
  GtkWidget *frame3;
  GtkWidget *hbox3p;
  GtkWidget *frame4;
  GtkWidget *hbox4;
  GtkWidget *table2;
  GtkWidget *label14;
  GtkWidget *label15;
  GtkWidget *label16;
  GtkWidget *vbox_protocol;
  GtkWidget *vbox_local;
  GtkWidget *hbox_label;
  GtkWidget *hbox_button;
  GtkWidget *change_dir_button;
  GtkWidget *hbox_update_interval;
  GtkWidget *label_update;
  GtkWidget *frame_update;
  GtkWidget *frame_db_buttons;
  GtkObject *spin_num_days_adj;
  GtkObject *spin_num_days_adj_logs;
  GtkObject *spin_script_delay;
  GtkObject *spin_default_polling;
  GtkObject *spin_retries;
  GtkObject *spin_num_log_delete_poll;
  GtkWidget *refresh_button;
  GtkWidget *convert_button;
  GtkWidget *hbox_db_address;
  GtkWidget *db_address_label;
  GtkWidget *database_port_label;
  GtkWidget *hbuttonbox_db;
  GtkWidget *frame_delete_poll;
  GtkWidget *hbox_delete_poll;
  GtkWidget *rollover_frame;
  GtkWidget *hbox_rollover;

  pref_widgets   *pref;
  GtkWidget      *frame24;
  GtkWidget      *frame29;
  GtkWidget      *hbox33;
  GtkWidget      *hbox_where;
  GtkWidget      *vbox_auto;
  GtkWidget      *auto_frame;
  GtkWidget      *hbox_auto;
  GtkWidget      *script_delay_label;
  GtkWidget      *default_frame;
  GtkWidget      *hbox_default;
  GtkWidget      *script_default_label;
  GtkWidget      *frame_retry;
  GtkWidget      *hbox_retry;
  GtkWidget      *script_retry_label;
  GtkWidget      *vbox_adv;
  GtkWidget      *speed_frame;
  GtkWidget      *hbox_speed;
  GtkWidget      *frame_status;
  GtkWidget      *vbox_status_data;
  GtkWidget      *hbox_show_status;
  GtkWidget      *adv_frame;
  GtkWidget      *hbox_adv;
  GtkWidget      *frame_qpage;
  GtkWidget      *vbox_qpage_data;
  GtkWidget      *hbox_qpage_address;
  GtkWidget      *qpage_address_label;
  GtkWidget      *hbox_qpage_port;
  GtkWidget      *qpage_port_label;
  GtkWidget      *vbox_msg_entry;  
  GtkWidget      *label_help_adv;
  GtkWidget      *vbox_adv_sending;
  GtkWidget      *vbox_adv_quick_page;
  GtkWidget      *send_method_help_label;
  GtkWidget      *qpage_help_label;
  GtkWidget      *label_logging_help;
  GtkWidget      *label_signature_help;
  GtkWidget      *label_protocols_help;
  GtkWidget      *label_precedence_help;
  GtkWidget      *label_delay_help;
  GtkWidget      *label_wait_help;
  GtkWidget      *label_locate_help;
  GtkWidget      *vbox_network_settings;
  GtkWidget      *label_delete_logs_poll;

  GSList         *local_network_group = NULL;
  GSList         *auto_delete_group = NULL;
  GSList         *yes_no_group = NULL;
  GSList         *time_stamp_group = NULL;
  GSList         *before_after_group = NULL;
  GSList         *cc_group_group = NULL;
  GSList         *prec_group_group = NULL;
  GSList         *snpp_group_group = NULL;
  GSList         *smtp_group_group = NULL;
  GSList         *wctp_group__group = NULL;
  GSList         *asynch_group = NULL;
  GSList         *status_yes_group = NULL;
  GSList         *pref_yes_no_group = NULL;
  GSList         *msg_entry_group = NULL;
  GSList         *rollover_group = NULL;
  GSList         *status_connect_group = NULL;
  GSList         *error_file_group = NULL;
  GtkWidget      *hbox_buttons;

  //GdkPixmap         *pixmap;  
  //GdkBitmap         *mask;
  GdkColormap       *colormap;
  dynamic_box_data  *vbox_data;

  pref = g_malloc(sizeof(*pref));
  user_data->prefs = pref;
  user_data->prefs->interface_widget = GTK_WIDGET(interface_widget);

  vbox_data = g_malloc(sizeof(*vbox_data));

  preferences = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (preferences), "preferences", preferences);
  gtk_window_set_title (GTK_WINDOW (preferences), "g-page Preferences");
  gtk_window_set_default_size (GTK_WINDOW (preferences), 500, 470);
  gtk_window_set_policy (GTK_WINDOW (preferences), TRUE, TRUE, FALSE);

  user_data->main = preferences;

  vbox_tree = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_tree);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_tree", vbox_tree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_tree);
  gtk_container_add (GTK_CONTAINER (preferences), vbox_tree);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox_tree), hbox3, TRUE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox3), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize (scrolledwindow1, 150, 400);

  ctree1 = gtk_ctree_new (2, 0);
  gtk_clist_set_column_visibility (GTK_CLIST(ctree1), 1, FALSE);
  gtk_widget_ref (ctree1);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "ctree1", ctree1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ctree1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), ctree1);
  gtk_clist_set_column_width (GTK_CLIST (ctree1), 0, 130);
  gtk_clist_set_column_width (GTK_CLIST (ctree1), 1, 130);
  gtk_clist_column_titles_show (GTK_CLIST (ctree1));
  
  gtk_ctree_set_line_style( GTK_CTREE(ctree1), GTK_CTREE_LINES_NONE);
  gtk_ctree_set_expander_style( GTK_CTREE(ctree1), GTK_CTREE_EXPANDER_TRIANGLE);

  load_pref_tree(ctree1);
  
  label1 = gtk_label_new (" Select Option: ");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_clist_set_column_widget (GTK_CLIST (ctree1), 0, label1);

  label2 = gtk_label_new ("Select an Option");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (ctree1), 1, label2);

  vbox_pref_data = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_pref_data);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_pref_data", vbox_pref_data,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_pref_data);
  gtk_box_pack_start (GTK_BOX (hbox3), vbox_pref_data, TRUE, TRUE, 0);

  colormap = gtk_widget_get_colormap(GTK_WIDGET(preferences));
  gtk_widget_realize ( preferences );
  /*
  pixmap = gdk_pixmap_create_from_xpm_d ( preferences->window, &mask,
					  &preferences->style->white, back_pix_xpm );

  back_pix = gtk_pixmap_new (pixmap, mask);
  gtk_widget_ref (back_pix);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "back_pix", back_pix,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (back_pix);
  gtk_box_pack_start (GTK_BOX (vbox_pref_data), back_pix, FALSE, TRUE, 0);
  gtk_misc_set_alignment (GTK_MISC (back_pix), 1.82539e-07, 7.45058e-09);
  */
/*** Here is the start of the dynamic vbox's ***/


/***** Here is the logging stuff *****/

  vbox_logs = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_logs);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_logs", vbox_logs,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_logs);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_logs);

  
  label_logging_help = gtk_label_new ("\ng-page can automatically delete logged pages. Select the number of days you wish to keep for your reference and g-page will delete any page older than that.\n\n");
  gtk_misc_set_alignment(GTK_MISC(label_logging_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_logging_help), TRUE);
  gtk_widget_ref (label_logging_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_logging_help", label_logging_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_logging_help);
  gtk_box_pack_start (GTK_BOX (vbox_logs), label_logging_help, FALSE, FALSE, 0);


  frame26 = gtk_frame_new (" Auto Delete Logs: ");
  gtk_widget_ref (frame26);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame26", frame26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame26), 2);
  gtk_widget_show (frame26);
  gtk_box_pack_start (GTK_BOX (vbox_logs), frame26, TRUE, TRUE, 0);

  hbox30 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox30);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox30", hbox30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox30);
  gtk_container_add (GTK_CONTAINER (frame26), hbox30);

  pref->radio_auto_yes = gtk_radio_button_new_with_label (auto_delete_group, " Yes");
  auto_delete_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_auto_yes));
  gtk_widget_ref (pref->radio_auto_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_auto_yes", pref->radio_auto_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_auto_yes);
  gtk_box_pack_start (GTK_BOX (hbox30), pref->radio_auto_yes, FALSE, FALSE, 2);

  pref->radio_auto_no = gtk_radio_button_new_with_label (auto_delete_group, " No");
  auto_delete_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_auto_no));
  gtk_widget_ref (pref->radio_auto_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_auto_no", pref->radio_auto_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_auto_no);
  gtk_box_pack_start (GTK_BOX (hbox30), pref->radio_auto_no, FALSE, FALSE, 2);


/*
 *     Set the suto delete yes/no radio button here
 */


  if ( !strcmp(user_data->log_delete, "no") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_auto_no), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_auto_yes), TRUE);

  frame27 = gtk_frame_new (" Delete Logs After: ");
  gtk_widget_ref (frame27);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame27", frame27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame27), 2);
  gtk_widget_show (frame27);
  gtk_box_pack_start (GTK_BOX (vbox_logs), frame27, TRUE, TRUE, 0);

  hbox31 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox31);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox31", hbox31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox31);
  gtk_container_add (GTK_CONTAINER (frame27), hbox31);


/*
 *      Set the number of days we wait before deleting logs here
 */


  spin_num_days_adj_logs = gtk_adjustment_new (atoi(user_data->days_before_delete), 1, 365, 1, 10, 10);

  pref->spin_num_days = gtk_spin_button_new (GTK_ADJUSTMENT (spin_num_days_adj_logs), 1, 0);
  gtk_widget_ref (pref->spin_num_days);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->spin_num_days", pref->spin_num_days,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->spin_num_days);
  gtk_box_pack_start (GTK_BOX (hbox31), pref->spin_num_days, FALSE, TRUE, 3);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pref->spin_num_days), TRUE);

  label64 = gtk_label_new (" Days");
  gtk_widget_ref (label64);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label64", label64,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label64);
  gtk_box_pack_start (GTK_BOX (hbox31), label64, FALSE, FALSE, 0);


/***  here is the log delete delay stuff ******/


  frame_delete_poll = gtk_frame_new (" Polling interval: ");
  gtk_widget_ref (frame_delete_poll);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_delete_poll", frame_delete_poll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_delete_poll), 2);
  gtk_widget_show (frame_delete_poll);
  gtk_box_pack_start (GTK_BOX (vbox_logs), frame_delete_poll, TRUE, TRUE, 0);

  hbox_delete_poll = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_delete_poll);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_delete_poll", hbox_delete_poll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_delete_poll);
  gtk_container_add (GTK_CONTAINER (frame_delete_poll), hbox_delete_poll);


/*
 *      Set the polling delay for log delete here
 */

  
  spin_num_log_delete_poll = gtk_adjustment_new (atoi(user_data->log_delete_poll), 0, 23, 1, 10, 10);

  pref->log_delete_poll = gtk_spin_button_new (GTK_ADJUSTMENT (spin_num_log_delete_poll), 1, 0);
  gtk_widget_ref (pref->log_delete_poll);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->log_delete_poll", pref->log_delete_poll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->log_delete_poll);
  gtk_box_pack_start (GTK_BOX (hbox_delete_poll), pref->log_delete_poll, FALSE, TRUE, 3);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pref->log_delete_poll), TRUE);

  label_delete_logs_poll = gtk_label_new (" Hours");
  gtk_widget_ref (label_delete_logs_poll);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_delete_logs_poll", label_delete_logs_poll,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_delete_logs_poll);
  gtk_box_pack_start (GTK_BOX (hbox_delete_poll), label_delete_logs_poll, FALSE, FALSE, 0);



/***** end log delete delay stuff  ******/
/***** End of the logging stuff  *****/

/****** Here is the signature stuff *****/

  vbox_sig = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_sig);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_sig", vbox_sig,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (vbox_sig);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_sig);


  label_signature_help = gtk_label_new ("\ng-page can send a user definable message signature with each page you send out. You can also send a timestamp at the end of each page.\n\n");
  gtk_misc_set_alignment(GTK_MISC(label_signature_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_signature_help), TRUE);
  gtk_widget_ref (label_signature_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_signature_help", label_signature_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_signature_help);
  gtk_box_pack_start (GTK_BOX (vbox_sig), label_signature_help, FALSE, FALSE, 0);


  frame28 = gtk_frame_new (" Auto Signature ");
  gtk_widget_ref (frame28);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame28", frame28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame28), 2);
  gtk_widget_show (frame28);
  gtk_box_pack_start (GTK_BOX (vbox_sig), frame28, TRUE, TRUE, 0);

  hbox32 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox32);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox32", hbox32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox32);
  gtk_container_add (GTK_CONTAINER (frame28), hbox32);
  
  pref->radio_sig_yes = gtk_radio_button_new_with_label (yes_no_group, " Yes");
  yes_no_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_sig_yes));
  gtk_widget_ref (pref->radio_sig_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_sig_yes", pref->radio_sig_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_sig_yes);
  gtk_box_pack_start (GTK_BOX (hbox32), pref->radio_sig_yes, FALSE, FALSE, 2);

  pref->radio_sig_no = gtk_radio_button_new_with_label (yes_no_group, " No");
  yes_no_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_sig_no));
  gtk_widget_ref (pref->radio_sig_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_sig_no", pref->radio_sig_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_sig_no);
  gtk_box_pack_start (GTK_BOX (hbox32), pref->radio_sig_no, FALSE, FALSE, 2);


/*
 *     Set the message signature yes/no radio button here
 */


  if ( !strcmp(user_data->signature_yes_no, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_sig_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_sig_no), TRUE);

  frame_time = gtk_frame_new (" Insert Time Stamp ");
  gtk_widget_ref (frame_time);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_time", frame_time,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_time), 2);
  gtk_widget_show (frame_time);
  gtk_box_pack_start (GTK_BOX (vbox_sig), frame_time, TRUE, TRUE, 0);

  hbox_time = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_time);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_time", hbox_time,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_time);
  gtk_container_add (GTK_CONTAINER (frame_time), hbox_time);

  pref->time_stamp_yes = gtk_radio_button_new_with_label (time_stamp_group, " Yes ");
  time_stamp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->time_stamp_yes));
  gtk_widget_ref (pref->time_stamp_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->time_stamp_yes", pref->time_stamp_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->time_stamp_yes);
  gtk_box_pack_start (GTK_BOX (hbox_time), pref->time_stamp_yes, FALSE, FALSE, 2);

  pref->time_stamp_no = gtk_radio_button_new_with_label (time_stamp_group, " No ");
  time_stamp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->time_stamp_no));
  gtk_widget_ref (pref->time_stamp_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->time_stamp_no", pref->time_stamp_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->time_stamp_no);
  gtk_box_pack_start (GTK_BOX (hbox_time), pref->time_stamp_no, FALSE, FALSE, 2);


/*
 *     Set message signature placement before/after radio button here
 */

  if ( !strcmp(user_data->time_stamp, "no") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->time_stamp_no), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->time_stamp_yes), TRUE);


  frame29 = gtk_frame_new (" Signature Placement ");
  gtk_widget_ref (frame29);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame29", frame29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame29), 2);
  gtk_widget_show (frame29);
  gtk_box_pack_start (GTK_BOX (vbox_sig), frame29, TRUE, TRUE, 0);

  hbox33 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox33);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox33", hbox33,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox33);
  gtk_container_add (GTK_CONTAINER (frame29), hbox33);

  pref->radio_sig_before = gtk_radio_button_new_with_label (before_after_group, "Before Msg");
  before_after_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_sig_before));
  gtk_widget_ref (pref->radio_sig_before);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_sig_before", pref->radio_sig_before,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_sig_before);
  gtk_box_pack_start (GTK_BOX (hbox33), pref->radio_sig_before, FALSE, FALSE, 2);

  pref->radio_sig_after = gtk_radio_button_new_with_label (before_after_group, "After Msg");
  before_after_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_sig_after));
  gtk_widget_ref (pref->radio_sig_after);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_sig_after", pref->radio_sig_after,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_sig_after);
  gtk_box_pack_start (GTK_BOX (hbox33), pref->radio_sig_after, FALSE, FALSE, 2);


/*
 *     Set message signature placement before/after radio button here
 */


  if ( !strcmp(user_data->signature_before, "before") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_sig_before), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_sig_after), TRUE);

  frame_signature = gtk_frame_new (" Message Signature: ");
  gtk_widget_ref (frame_signature);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_signature", frame_signature,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_signature), 2);
  gtk_widget_show(frame_signature);
  gtk_box_pack_start (GTK_BOX (vbox_sig), frame_signature, TRUE, TRUE, 0);


  hbox35 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox35);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox35", hbox35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox35);
  gtk_container_add (GTK_CONTAINER (frame_signature), hbox35);

  label65 = gtk_label_new (" Signature ");
  gtk_widget_ref (label65);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label65", label65,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label65);
  gtk_box_pack_start (GTK_BOX (hbox35), label65, FALSE, FALSE, 0);

  pref->signature = gtk_entry_new_with_max_length (20);

/*
 *   Load the signature here 
 */

  gtk_entry_set_text( GTK_ENTRY(pref->signature), user_data->signature); 
  gtk_widget_ref (pref->signature);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->signature", pref->signature,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->signature);
  gtk_box_pack_start (GTK_BOX (hbox35), pref->signature, TRUE, TRUE, 3);

/*** end of the signature stuff ****/

/**** Here is the protocol stuff  ****/

  vbox_protocol = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_protocol);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_protocol", vbox_protocol,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (vbox_protocol);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_protocol);


  label_protocols_help = gtk_label_new ("g-page can send a carbon copy of each page to the receivers email address. NOTE: This only works if SMTP is not defined as a protocol for that receiver.\n\n");
  gtk_misc_set_alignment(GTK_MISC(label_protocols_help),0.1,0);
  gtk_label_set_justify(GTK_LABEL(label_protocols_help), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap(GTK_LABEL(label_protocols_help), TRUE);
  gtk_widget_ref (label_protocols_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_protocols_help", label_protocols_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_protocols_help);
  gtk_box_pack_start (GTK_BOX (vbox_protocol), label_protocols_help, FALSE, FALSE, 1);

  frame3 = gtk_frame_new ("CC all pages to email:");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox_protocol), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 4);

  hbox3p = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3p);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox3p", hbox3p,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3p);
  gtk_container_add (GTK_CONTAINER (frame3), hbox3p);


  pref->cc_email_yes = gtk_radio_button_new_with_label (cc_group_group, " Yes");
  cc_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->cc_email_yes));
  gtk_widget_ref (pref->cc_email_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->cc_email_yes", pref->cc_email_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->cc_email_yes);
  gtk_box_pack_start (GTK_BOX (hbox3p), pref->cc_email_yes, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pref->cc_email_yes), 5);

  pref->cc_email_no = gtk_radio_button_new_with_label (cc_group_group, " No");
  cc_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->cc_email_no));
  gtk_widget_ref (pref->cc_email_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->cc_email_no", pref->cc_email_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->cc_email_no);
  gtk_box_pack_start (GTK_BOX (hbox3p), pref->cc_email_no, FALSE, FALSE, 0);

/*
 *    Set the CC email radio buttons here
 */

  if ( !strcmp(user_data->cc_email, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->cc_email_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->cc_email_no), TRUE);


  label_precedence_help = gtk_label_new ("\nYou can define the order in which g-page will attempt to send messages, based upon the protocols a receiver is setup for.\n\n");
  gtk_misc_set_alignment(GTK_MISC(label_precedence_help),0.1,0);
  gtk_label_set_justify(GTK_LABEL(label_precedence_help), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap(GTK_LABEL(label_precedence_help), TRUE);
  gtk_widget_ref (label_precedence_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_precedence_help", label_precedence_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_precedence_help);
  gtk_box_pack_start (GTK_BOX (vbox_protocol), label_precedence_help, FALSE, FALSE, 0);


  frame4 = gtk_frame_new ("Set protocol precedence");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (vbox_protocol), frame4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 4);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (frame4), hbox4);


  pref->set_protocols_yes = gtk_radio_button_new_with_label (prec_group_group, " Yes");
  prec_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->set_protocols_yes));
  gtk_widget_ref (pref->set_protocols_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->set_protocols_yes", pref->set_protocols_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->set_protocols_yes);
  gtk_box_pack_start (GTK_BOX (hbox4), pref->set_protocols_yes, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pref->set_protocols_yes), 5);


  pref->set_protocols_no = gtk_radio_button_new_with_label (prec_group_group, " No");
  prec_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->set_protocols_no));
  gtk_widget_ref (pref->set_protocols_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->set_protocols_no", pref->set_protocols_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->set_protocols_no);
  gtk_box_pack_start (GTK_BOX (hbox4), pref->set_protocols_no, FALSE, FALSE, 0);

/*
 *   Set the Set Protocol Precedence yes/no radio buttons here
 */

  if ( !strcmp(user_data->set_protocols, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->set_protocols_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->set_protocols_no), TRUE);

  table2 = gtk_table_new (3, 4, TRUE);
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_box_pack_start (GTK_BOX (vbox_protocol), table2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 5);

  label14 = gtk_label_new ("WCTP");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_table_attach (GTK_TABLE (table2), label14, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label14), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label14), 4, 0);

  label15 = gtk_label_new ("SNPP");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_table_attach (GTK_TABLE (table2), label15, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label15), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label15), 4, 0);

  label16 = gtk_label_new ("SMTP");
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_table_attach (GTK_TABLE (table2), label16, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label16), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label16), 4, 0);

  pref->wctp_one = gtk_radio_button_new_with_label (wctp_group__group, "1st");
  wctp_group__group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->wctp_one));
  gtk_widget_ref (pref->wctp_one);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->wctp_one", pref->wctp_one,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->wctp_one);
  gtk_table_attach (GTK_TABLE (table2), pref->wctp_one, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pref->wctp_two = gtk_radio_button_new_with_label (wctp_group__group, "2nd");
  wctp_group__group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->wctp_two));
  gtk_widget_ref (pref->wctp_two);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->wctp_two", pref->wctp_two,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->wctp_two);
  gtk_table_attach (GTK_TABLE (table2), pref->wctp_two, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pref->wctp_three = gtk_radio_button_new_with_label (wctp_group__group, "3rd");
  wctp_group__group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->wctp_three));
  gtk_widget_ref (pref->wctp_three);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->wctp_three", pref->wctp_three,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->wctp_three);
  gtk_table_attach (GTK_TABLE (table2), pref->wctp_three, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  pref->snpp_one = gtk_radio_button_new_with_label (snpp_group_group, "1st");
  snpp_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->snpp_one));
  gtk_widget_ref (pref->snpp_one);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->snpp_one", pref->snpp_one,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->snpp_one);
  gtk_table_attach (GTK_TABLE (table2), pref->snpp_one, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pref->snpp_two = gtk_radio_button_new_with_label (snpp_group_group, "2nd");
  snpp_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->snpp_two));
  gtk_widget_ref (pref->snpp_two);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->snpp_two", pref->snpp_two,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->snpp_two);
  gtk_table_attach (GTK_TABLE (table2), pref->snpp_two, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pref->snpp_three = gtk_radio_button_new_with_label (snpp_group_group, "3rd");
  snpp_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->snpp_three));
  gtk_widget_ref (pref->snpp_three);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->snpp_three", pref->snpp_three,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->snpp_three);
  gtk_table_attach (GTK_TABLE (table2), pref->snpp_three, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  pref->smtp_one = gtk_radio_button_new_with_label (smtp_group_group, "1st");
  smtp_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->smtp_one));
  gtk_widget_ref (pref->smtp_one);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->smtp_one", pref->smtp_one,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->smtp_one);
  gtk_table_attach (GTK_TABLE (table2), pref->smtp_one, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pref->smtp_two = gtk_radio_button_new_with_label (smtp_group_group, "2nd");
  smtp_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->smtp_two));
  gtk_widget_ref (pref->smtp_two);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->smtp_two", pref->smtp_two,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->smtp_two);
  gtk_table_attach (GTK_TABLE (table2), pref->smtp_two, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  pref->smtp_three = gtk_radio_button_new_with_label (smtp_group_group, "3rd");
  smtp_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->smtp_three));
  gtk_widget_ref (pref->smtp_three);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->smtp_three", pref->smtp_three,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->smtp_three);
  gtk_table_attach (GTK_TABLE (table2), pref->smtp_three, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  if ( user_data->order_of_protocols[0] == '1' ) 
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->wctp_one), TRUE);
  else  if ( user_data->order_of_protocols[1] == '1' ) 
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->wctp_two), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->wctp_three), TRUE);


  if ( user_data->order_of_protocols[0] == '2' ) 
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->snpp_one), TRUE);
  else  if ( user_data->order_of_protocols[1] == '2' ) 
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->snpp_two), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->snpp_three), TRUE);


  if ( user_data->order_of_protocols[0] == '3' ) 
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->smtp_one), TRUE);
  else  if ( user_data->order_of_protocols[1] == '3' ) 
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->smtp_two), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->smtp_three), TRUE);

  if (GTK_TOGGLE_BUTTON (pref->set_protocols_yes)->active)
      gtk_widget_show (table2);

/*** End of the protocol stuff ****/

/***** Here is the auto page stuff ***/

  vbox_auto = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_auto);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_auto", vbox_auto,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (vbox_auto);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_auto);

  label_delay_help = gtk_label_new ("\nDefine the number of seconds g-page waits after executing a script before it searches for the data created by that script.\n");
  gtk_misc_set_alignment(GTK_MISC(label_delay_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_delay_help), TRUE);
  gtk_widget_ref (label_delay_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_delay_help", label_delay_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_delay_help);
  gtk_box_pack_start (GTK_BOX (vbox_auto), label_delay_help, FALSE, FALSE, 0);


  //auto_frame = gtk_frame_new (" Set script delay (seconds)");
  auto_frame = gtk_frame_new ("");

  //gtk_frame_set_shadow_type (GTK_FRAME (auto_frame), GTK_SHADOW_IN);
  gtk_widget_ref (auto_frame);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "auto_frame", auto_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (auto_frame), 2);
  gtk_widget_show (auto_frame);
  gtk_box_pack_start (GTK_BOX (vbox_auto), auto_frame, TRUE, TRUE, 2);
  
  hbox_auto = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_auto);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_auto", hbox_auto,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_auto);
  gtk_container_add (GTK_CONTAINER (auto_frame), hbox_auto);


  script_delay_label = gtk_label_new (" Script delay               ");
  gtk_widget_ref (script_delay_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "script_delay_label", script_delay_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_delay_label);
  gtk_box_pack_start (GTK_BOX (hbox_auto), script_delay_label, FALSE, FALSE, 0);

/**** Start new spin button ****/
/*
 *   Load the delay here
 */

  spin_script_delay = gtk_adjustment_new (atoi(user_data->script_delay), 1, 999, 1, 10, 10);

  pref->script_delay = gtk_spin_button_new (GTK_ADJUSTMENT (spin_script_delay), 1, 0);
  gtk_widget_ref (pref->script_delay);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->script_delay", pref->script_delay,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->script_delay);
  gtk_box_pack_start (GTK_BOX (hbox_auto), pref->script_delay, FALSE, FALSE, 3);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pref->script_delay), TRUE);

  label_wait_help = gtk_label_new ("\nDefine the number of seconds g-page will wait between attempts to find a file.\n");
  gtk_misc_set_alignment(GTK_MISC(label_wait_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_wait_help), TRUE);
  gtk_widget_ref (label_wait_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_wait_help", label_wait_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_wait_help);
  gtk_box_pack_start (GTK_BOX (vbox_auto), label_wait_help, FALSE, FALSE, 0);




  //default_frame = gtk_frame_new (" Default polling interval (seconds)");
  default_frame = gtk_frame_new ("");
  gtk_widget_ref (default_frame);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "default_frame", default_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (default_frame), 2);
  gtk_widget_show (default_frame);
  gtk_box_pack_start (GTK_BOX (vbox_auto), default_frame, TRUE, TRUE, 2);
  
  hbox_default = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_default);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_default", hbox_default,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_default);
  gtk_container_add (GTK_CONTAINER (default_frame), hbox_default);


  script_default_label = gtk_label_new (" File polling interval:    ");
  gtk_widget_ref (script_default_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "script_default_label", script_default_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_default_label);
  gtk_box_pack_start (GTK_BOX (hbox_default), script_default_label, FALSE, FALSE, 0);

/*
 *  Load the default polling interval here
 */

  spin_default_polling = gtk_adjustment_new (atoi(user_data->default_polling), 1, 999, 1, 10, 10);

  pref->default_polling = gtk_spin_button_new (GTK_ADJUSTMENT (spin_default_polling), 1, 0);
  gtk_widget_ref (pref->default_polling);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->default_polling", pref->default_polling,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->default_polling);
  gtk_box_pack_start (GTK_BOX (hbox_default), pref->default_polling, FALSE, FALSE, 3);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pref->default_polling), TRUE);


  label_locate_help = gtk_label_new ("\nDefine the number of attempts g-page will make to find a file.\n");
  gtk_misc_set_alignment(GTK_MISC(label_locate_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_locate_help), TRUE);
  gtk_widget_ref (label_locate_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_locate_help", label_locate_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_locate_help);
  gtk_box_pack_start (GTK_BOX (vbox_auto), label_locate_help, FALSE, FALSE, 0);

  //frame_retry = gtk_frame_new (" File locate attempts ");
  frame_retry = gtk_frame_new ("");
  gtk_widget_ref (frame_retry);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_retry", frame_retry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_retry), 2);
  gtk_widget_show (frame_retry);
  gtk_box_pack_start (GTK_BOX (vbox_auto), frame_retry, TRUE, TRUE, 2);
  
  hbox_retry = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_retry);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_retry", hbox_retry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_retry);
  gtk_container_add (GTK_CONTAINER (frame_retry), hbox_retry);


  script_retry_label = gtk_label_new (" File locate attempts     ");
  gtk_widget_ref (script_retry_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "script_retry_label", script_retry_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_retry_label);
  gtk_box_pack_start (GTK_BOX (hbox_retry), script_retry_label, FALSE, FALSE, 0);

/* 
 *  Load the file locate retries here
 */

  spin_retries = gtk_adjustment_new (atoi(user_data->retries), 1, 999, 1, 10, 10);

  pref->retries = gtk_spin_button_new (GTK_ADJUSTMENT (spin_retries), 1, 0);
  gtk_widget_ref (pref->retries);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->retries", pref->retries,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->retries);
  gtk_box_pack_start (GTK_BOX (hbox_retry), pref->retries, FALSE, FALSE, 3);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pref->retries), TRUE);



/*
 *   Begin new section of code 
 */


  label_status_help = gtk_label_new ("\nCreate error files when g-page is unable to parse a file\n");
  gtk_misc_set_alignment(GTK_MISC(label_status_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_status_help), TRUE);
  gtk_widget_ref (label_status_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_status_help", label_status_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_status_help);
  gtk_box_pack_start (GTK_BOX (vbox_auto), label_status_help, FALSE, FALSE, 0);

  //frame_retry = gtk_frame_new (" File locate attempts ");
  frame_status = gtk_frame_new ("");
  gtk_widget_ref (frame_status);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_status", frame_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_status), 2);
  gtk_widget_show (frame_status);
  gtk_box_pack_start (GTK_BOX (vbox_auto), frame_status, TRUE, TRUE, 2);
  
  hbox_status = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_status);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_status", hbox_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_status);
  gtk_container_add (GTK_CONTAINER (frame_status), hbox_status);




/* 
 *  Load the file locate retries here
 */

  pref->create_error_status_yes = gtk_radio_button_new_with_label (error_file_group, " Yes");
  error_file_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->create_error_status_yes));
  gtk_widget_ref (pref->create_error_status_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->create_error_status_yes", pref->create_error_status_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->create_error_status_yes);
  gtk_box_pack_start (GTK_BOX (hbox_status), pref->create_error_status_yes, FALSE, FALSE, 2);

  pref->create_error_status_no = gtk_radio_button_new_with_label (error_file_group, " No");
  error_file_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->create_error_status_no));
  gtk_widget_ref (pref->create_error_status_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->create_error_status_no", pref->create_error_status_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->create_error_status_no);
  gtk_box_pack_start (GTK_BOX (hbox_status), pref->create_error_status_no, FALSE, FALSE, 2);

/*
 * Load the error status file data here
 */
  if ( !strcmp(user_data->create_error_status_file, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->create_error_status_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->create_error_status_no), TRUE);


/*
 * End new section of code
 */

/****** End of the auto page stuff ***/

/******************************************/
/***** Here is the message entry box options  ********/

  vbox_msg_entry = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_msg_entry);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_msg_entry", vbox_msg_entry,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_msg_entry);

  frame_msg_entry = gtk_frame_new (" Message Entry Options ");
  gtk_widget_ref (frame_msg_entry);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_msg_entry", frame_msg_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_msg_entry), 2);
  gtk_widget_show (frame_msg_entry);
  gtk_box_pack_start (GTK_BOX (vbox_msg_entry), frame_msg_entry, TRUE, TRUE, 0);

/***** Help label ****/
  vbox_msg_entry_help = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_msg_entry_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_msg_entry_help", vbox_msg_entry_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_msg_entry_help);
  gtk_container_add (GTK_CONTAINER (frame_msg_entry), vbox_msg_entry_help);

  label_help = gtk_label_new ("\n\nThese settings allow you to define how g-page 
will handle the text you have typed into the message entry box after a page has been attempted\n\n
Select the Always option to always clear the message entry box. \n
Select On Success to have the message cleared only after a page has been sent successfully. \n
Select Never to always leave the text in the box\n\n");
  gtk_misc_set_alignment(GTK_MISC(label_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_help), TRUE);
  gtk_widget_ref (label_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_help", label_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_help);
  gtk_box_pack_start (GTK_BOX (vbox_msg_entry_help), label_help, FALSE, FALSE, 0);
/***** End help label  ******/

  vbox_msg_entry_bottom = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_msg_entry_bottom);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_msg_entry_bottom", vbox_msg_entry_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_msg_entry_bottom);
  gtk_box_pack_start (GTK_BOX (vbox_msg_entry_help), vbox_msg_entry_bottom, FALSE, FALSE, 2);


  hbox_msg_entry = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_msg_entry);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_msg_entry", hbox_msg_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_msg_entry);
  gtk_box_pack_start (GTK_BOX (vbox_msg_entry_bottom), hbox_msg_entry, FALSE, FALSE, 2);
  //gtk_container_add (GTK_CONTAINER (frame_msg_entry), hbox_msg_entry);

  
  pref->msg_entry_options_always = gtk_radio_button_new_with_label (msg_entry_group, " Always");
  msg_entry_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->msg_entry_options_always));
  gtk_widget_ref (pref->msg_entry_options_always);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->msg_entry_options_always", pref->msg_entry_options_always,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->msg_entry_options_always);
  gtk_box_pack_start (GTK_BOX (hbox_msg_entry), pref->msg_entry_options_always, FALSE, FALSE, 2);

  pref->msg_entry_options_success = gtk_radio_button_new_with_label (msg_entry_group, " On Success");
  msg_entry_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->msg_entry_options_success));
  gtk_widget_ref (pref->msg_entry_options_success);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->msg_entry_options_success", pref->msg_entry_options_success,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->msg_entry_options_success);
  gtk_box_pack_start (GTK_BOX (hbox_msg_entry), pref->msg_entry_options_success, FALSE, FALSE, 2);

  pref->msg_entry_options_never = gtk_radio_button_new_with_label (msg_entry_group, " Never");
  msg_entry_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->msg_entry_options_never));
  gtk_widget_ref (pref->msg_entry_options_never);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->msg_entry_options_never", pref->msg_entry_options_never,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->msg_entry_options_never);
  gtk_box_pack_start (GTK_BOX (hbox_msg_entry), pref->msg_entry_options_never, FALSE, FALSE, 2);

/*
 *     Set the message signature yes/no radio button here
 */


  if ( !strcmp(user_data->msg_entry_options, "always") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->msg_entry_options_always), TRUE);
  else if ( !strcmp(user_data->msg_entry_options, "success") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->msg_entry_options_success), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->msg_entry_options_never), TRUE);

/***** Here is the end of the message entry box stuff ******/
/***************************************************/


/*
 *    Here is the database options stuff
 */


  vbox_db = gtk_vbox_new (FALSE, 0);

  gtk_widget_ref (vbox_db);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_db", vbox_db,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (vbox_db);
  gtk_box_pack_start (GTK_BOX (vbox_pref_data), vbox_db, TRUE, TRUE, 0);

  label_database_help = gtk_label_new ("\ng-page can read from a local database or connect with a network database server and use those files.\n\n");
  gtk_misc_set_alignment(GTK_MISC(label_database_help),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_database_help), TRUE);
  gtk_widget_ref (label_database_help);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_database_help", label_database_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_database_help);
  gtk_box_pack_start (GTK_BOX (vbox_db), label_database_help, FALSE, FALSE, 0);


  frame24 = gtk_frame_new (" Select Database Location ");
  gtk_widget_ref (frame24);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame24", frame24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame24), 4);

  gtk_widget_show (frame24);
  gtk_box_pack_start (GTK_BOX (vbox_db), frame24, TRUE, TRUE, 2);

  hbox_where = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_where);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_where", hbox_where,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_where);
  gtk_container_add (GTK_CONTAINER (frame24), hbox_where);

  pref->radio_local = gtk_radio_button_new_with_label (local_network_group, " Local");
  local_network_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_local));
  gtk_widget_ref (pref->radio_local);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_local", pref->radio_local,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_local);
  gtk_box_pack_start (GTK_BOX (hbox_where), pref->radio_local, FALSE, FALSE, 2);

  pref->radio_network = gtk_radio_button_new_with_label (local_network_group, " Network");
  local_network_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->radio_network));
  gtk_widget_ref (pref->radio_network);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->radio_network", pref->radio_network,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->radio_network);
  gtk_box_pack_start (GTK_BOX (hbox_where), pref->radio_network, FALSE, FALSE, 2);


  if ( !strcmp(user_data->database_location, "local") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_local), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->radio_network), TRUE);

  vbox_network_settings = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_network_settings);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_network_settings", vbox_network_settings,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_box_pack_start (GTK_BOX (vbox_pref_data), vbox_network_settings, TRUE, TRUE, 0);


  frame25 = gtk_frame_new (" Local Directory ");
  gtk_widget_ref (frame25);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame25", frame25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame25), 4);
  gtk_widget_show (frame25);
  gtk_box_pack_start (GTK_BOX (vbox_db), frame25, TRUE, TRUE, 2);
  

  vbox_local = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_local);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_local", vbox_local,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_local);
  gtk_container_add (GTK_CONTAINER (frame25), vbox_local);

  hbox_label = gtk_hbox_new (FALSE, 1);
  gtk_widget_ref (hbox_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_label", hbox_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_label);
  gtk_container_add (GTK_CONTAINER (vbox_local), hbox_label);

  pref->dir_label = gtk_label_new (user_data->current_dir);
  gtk_widget_ref (pref->dir_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->dir_label", pref->dir_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->dir_label);
  gtk_box_pack_start (GTK_BOX (hbox_label), pref->dir_label, FALSE, FALSE, 5);

  hbox_button = gtk_hbox_new (FALSE, 2);
  gtk_widget_ref (hbox_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_button", hbox_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_button);
  gtk_box_pack_start (GTK_BOX (vbox_local), hbox_button, FALSE, FALSE, 5);

  change_dir_button = gtk_button_new_with_label (" Change ");
  gtk_widget_ref (change_dir_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "change_dir_button", change_dir_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (change_dir_button);
  gtk_box_pack_start (GTK_BOX (hbox_button), change_dir_button, FALSE, FALSE, 5);


  frame_network = gtk_frame_new (" Database Refresh Settings ");
  gtk_widget_ref (frame_network);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_network", frame_network,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_network), 4);
  gtk_widget_show (frame_network);

  gtk_box_pack_start (GTK_BOX (vbox_network_settings), frame_network, TRUE, TRUE, 2);

  hbox_update_interval = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_update_interval);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_update_interval", hbox_update_interval,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_update_interval);
  gtk_container_add (GTK_CONTAINER (frame_network), hbox_update_interval);


  label_update = gtk_label_new ("Update Interval (Min)");
  gtk_widget_ref (label_update);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_update", label_update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_update);
  gtk_box_pack_start (GTK_BOX (hbox_update_interval), label_update, FALSE, FALSE, 3);

  spin_num_days_adj = gtk_adjustment_new (atoi(user_data->update_interval), 0, 999, 1, 10, 10);


  pref->update_interval = gtk_spin_button_new (GTK_ADJUSTMENT (spin_num_days_adj), 1, 0);
  gtk_widget_ref (pref->update_interval);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->update_interval", pref->update_interval,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->update_interval);
  gtk_box_pack_start (GTK_BOX (hbox_update_interval), pref->update_interval, FALSE, FALSE, 3);

  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (pref->update_interval), TRUE);


  frame_update = gtk_frame_new (" Network Address ");
  gtk_widget_ref (frame_update);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_update", frame_update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_update), 4);
  gtk_widget_show (frame_update);

  gtk_box_pack_start (GTK_BOX (vbox_network_settings), frame_update, TRUE, TRUE, 2);

  vbox_network_stuff = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox_network_stuff);
  gtk_container_add (GTK_CONTAINER (frame_update), vbox_network_stuff);

  hbox_db_address = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_db_address);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_db_address", hbox_db_address,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_db_address);
  gtk_box_pack_start (GTK_BOX (vbox_network_stuff), hbox_db_address, TRUE, TRUE, 2);
  //gtk_container_add (GTK_CONTAINER (frame_update), hbox_db_address);

  db_address_label = gtk_label_new ("Database Address ");
  gtk_widget_ref (db_address_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "db_address_label", db_address_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (db_address_label);
  gtk_box_pack_start (GTK_BOX (hbox_db_address), db_address_label, FALSE, FALSE, 2);


  pref->database_adr = gtk_entry_new_with_max_length (128);
  gtk_widget_set_usize (pref->database_adr, 150, 20);

  gtk_entry_set_text( GTK_ENTRY(pref->database_adr), user_data->database_adr); 
  gtk_widget_ref (pref->database_adr);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->database_adr", pref->database_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->database_adr);
  gtk_box_pack_start (GTK_BOX (hbox_db_address), pref->database_adr, FALSE, FALSE, 1);

/******/
  hbox_db_port = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_db_port);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_db_port", hbox_db_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_db_port);
  gtk_box_pack_start (GTK_BOX (vbox_network_stuff), hbox_db_port, TRUE, TRUE, 2);

/*******/
  
  database_port_label = gtk_label_new ("          Port            ");
  gtk_widget_ref (database_port_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "database_port_label", database_port_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (database_port_label);
  gtk_box_pack_start (GTK_BOX (hbox_db_port), database_port_label, FALSE, FALSE, 1);

  pref->db_port = gtk_entry_new_with_max_length (5);
  gtk_widget_set_usize (pref->db_port, 40, 20);



  gtk_entry_set_text( GTK_ENTRY(pref->db_port), user_data->db_port); 

  gtk_widget_ref (pref->db_port);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->db_port", pref->db_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->db_port);
  gtk_box_pack_start (GTK_BOX (hbox_db_port), pref->db_port, FALSE, FALSE, 1);


  frame_db_buttons  = gtk_frame_new (" Refresh or Convert Network Database");
  gtk_widget_ref (frame_db_buttons);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_db_buttons", frame_db_buttons,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_db_buttons), 4);
  gtk_widget_show (frame_db_buttons);

  gtk_box_pack_start (GTK_BOX (vbox_network_settings), frame_db_buttons, TRUE, TRUE, 2);


  hbox_buttons = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_buttons);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_buttons", hbox_buttons,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_buttons);
  gtk_container_add (GTK_CONTAINER (frame_db_buttons), hbox_buttons);

  hbuttonbox_db = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox_db);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbuttonbox_db", hbuttonbox_db,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox_db);
  gtk_box_pack_start (GTK_BOX (hbox_buttons), hbuttonbox_db, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox_db), 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox_db), GTK_BUTTONBOX_START);


  refresh_button = gtk_button_new_with_label ("  Refresh  ");
  gtk_widget_ref (refresh_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "refresh_button", refresh_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (refresh_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox_db), refresh_button);
  gtk_container_set_border_width (GTK_CONTAINER (refresh_button), 1);
  GTK_WIDGET_SET_FLAGS (refresh_button, GTK_CAN_DEFAULT);

  convert_button = gtk_button_new_with_label (" Convert ");
  gtk_widget_ref (convert_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "convert_button", convert_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (convert_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox_db), convert_button);
  gtk_container_set_border_width (GTK_CONTAINER (convert_button), 1);
  GTK_WIDGET_SET_FLAGS (convert_button, GTK_CAN_DEFAULT);



/***** Here is the advanced box  *****/

  vbox_adv = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_adv);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_adv", vbox_adv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_adv);


  label_help_adv = gtk_label_new ("\ng-page has several advanced sending options to choose from:\n\n
Select Sending Options to switch between serial or asynchronous communications\n
Select Qpage Options to configure sending pages directly to a Quick Page server, or any local snpp server.\n");
  gtk_misc_set_alignment(GTK_MISC(label_help_adv),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(label_help_adv), TRUE);
  gtk_widget_ref (label_help_adv);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "label_help_adv", label_help_adv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_help_adv);
  gtk_box_pack_start (GTK_BOX (vbox_adv), label_help_adv, FALSE, FALSE, 0);




  vbox_adv_sending = gtk_vbox_new(FALSE, 0);
  gtk_widget_ref (vbox_adv_sending);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_adv_sending", vbox_adv_sending,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_adv_sending);

/*
 *   Set the asynchronous or serial page mode here
 */

  send_method_help_label = gtk_label_new ("\nSetting asynchronous mode allows the g-page server to create multiple simultaneous Internet connections for dispatcing messages. Serial mode will dispatch pages one at a time\n\nYou can disable the status-line updates by selecting No for view page status. This is helpful because the status updates might arrive in random order while in asynchronous mode\n\n");
  gtk_misc_set_alignment(GTK_MISC(send_method_help_label),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(send_method_help_label), TRUE);
  gtk_widget_ref (send_method_help_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "send_method_help_label", send_method_help_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (send_method_help_label);
  gtk_box_pack_start (GTK_BOX (vbox_adv_sending), send_method_help_label, FALSE, FALSE, 0);

  speed_frame = gtk_frame_new (" Set page mode ");
  gtk_widget_ref (speed_frame);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "speed_frame", speed_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (speed_frame), 2);
  gtk_widget_show (speed_frame);
  gtk_box_pack_start (GTK_BOX (vbox_adv_sending), speed_frame, TRUE, TRUE, 0);

  
  hbox_speed = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_speed);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_speed", hbox_speed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_speed);
  gtk_container_add (GTK_CONTAINER (speed_frame), hbox_speed);
  
  pref->asynch_mode = gtk_radio_button_new_with_label (asynch_group, " Asynchronous");
  asynch_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->asynch_mode));
  gtk_widget_ref (pref->asynch_mode);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->asynch_mode", pref->asynch_mode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->asynch_mode);
  gtk_box_pack_start (GTK_BOX (hbox_speed), pref->asynch_mode, FALSE, FALSE, 2);

  pref->serial_mode = gtk_radio_button_new_with_label (asynch_group, " Serial");
  asynch_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->serial_mode));
  gtk_widget_ref (pref->serial_mode);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->serial_mode", pref->serial_mode,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->serial_mode);
  gtk_box_pack_start (GTK_BOX (hbox_speed), pref->serial_mode, FALSE, FALSE, 2);

/*
 *     Set the advanced options yes/no radio button here
 */

  if ( !strcmp(user_data->serial_mode, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->serial_mode), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->asynch_mode), TRUE);

/*
 *   Set the page status here
 */

  frame_status = gtk_frame_new (" View page status: ");
  gtk_widget_ref (frame_status);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_status", frame_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_status), 2);
  gtk_widget_show(frame_status);
  //gtk_box_pack_start (GTK_BOX (vbox_adv_sending), frame_status, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_adv_sending), frame_status, TRUE, TRUE, 0);


  vbox_status_data = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_status_data);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_status_data", vbox_status_data,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_status_data);
  gtk_container_add (GTK_CONTAINER (frame_status), vbox_status_data);

  hbox_show_status = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_show_status);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_show_status", hbox_show_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_show_status);
  gtk_container_add (GTK_CONTAINER (vbox_status_data), hbox_show_status);

  pref->status_yes = gtk_radio_button_new_with_label (status_yes_group, " Yes");
  status_yes_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->status_yes));
  gtk_widget_ref (pref->status_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->status_yes", pref->status_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->status_yes);
  gtk_box_pack_start (GTK_BOX (hbox_show_status), pref->status_yes, FALSE, FALSE, 2);

  pref->status_no = gtk_radio_button_new_with_label (status_yes_group, " No");
  status_yes_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->status_no));
  gtk_widget_ref (pref->status_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->status_no", pref->status_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->status_no);
  gtk_box_pack_start (GTK_BOX (hbox_show_status), pref->status_no, FALSE, FALSE, 2);


/*
 *     Set the show status radio buttons yes/no radio button here
 */

  if ( !strcmp(user_data->show_status, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->status_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->status_no), TRUE);


/**************************** NEW NEW NEW ***************************/


  frame_connect = gtk_frame_new (" Dial Internet on no connect: ");
  gtk_widget_ref (frame_connect);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_connect", frame_connect,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_connect), 2);
  gtk_widget_show(frame_connect);
  gtk_box_pack_start (GTK_BOX (vbox_adv_sending), frame_connect, TRUE, TRUE, 0);

  vbox_connect = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_connect);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_connect", vbox_connect,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_connect);
  gtk_container_add (GTK_CONTAINER (frame_connect), vbox_connect);

  hbox_connect = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_connect);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_connect", hbox_connect,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_connect);
  gtk_container_add (GTK_CONTAINER (vbox_connect), hbox_connect);

  pref->connect_yes = gtk_radio_button_new_with_label (status_connect_group, " Yes");
  status_connect_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->connect_yes));
  gtk_widget_ref (pref->connect_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->connect_yes", pref->connect_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->connect_yes);
  gtk_box_pack_start (GTK_BOX (hbox_connect), pref->connect_yes, FALSE, FALSE, 2);

  pref->connect_no = gtk_radio_button_new_with_label (status_connect_group, " No");
  status_connect_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->connect_no));
  gtk_widget_ref (pref->connect_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->connect_no", pref->connect_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->connect_no);
  gtk_box_pack_start (GTK_BOX (hbox_connect), pref->connect_no, FALSE, FALSE, 2);


/*
 *     Set the dial internet radio buttons yes/no radio button here
 */

  if ( !strcmp(user_data->connect_yes, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->connect_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->connect_no), TRUE);


/**************************END END END *******************************/

  vbox_adv_quick_page = gtk_vbox_new(FALSE, 0);
  gtk_widget_ref (vbox_adv_quick_page);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_adv_quick_page", vbox_adv_quick_page,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbox_pref_data), vbox_adv_quick_page);



  qpage_help_label = gtk_label_new ("\ng-page can override your wireless service settings and send directly to a snpp server for dispatching pages via the TAP protocol or it can rollover to the snpp server if it cannot find a live Internet connection. g-page will then dispatch pages via snpp to the server settings you define below.\n\n");
  gtk_misc_set_alignment(GTK_MISC(qpage_help_label),0.1,0);
  gtk_label_set_line_wrap(GTK_LABEL(qpage_help_label), TRUE);
  gtk_widget_ref (qpage_help_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "qpage_help_label", qpage_help_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (qpage_help_label);
  gtk_box_pack_start (GTK_BOX (vbox_adv_quick_page), qpage_help_label, FALSE, FALSE, 0);

/*****  NEW QPAGE ROLLOVER OPTION *******/

  rollover_frame = gtk_frame_new (" Rollover to local server on no connect: ");
  gtk_widget_ref (rollover_frame);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "rollover_frame", rollover_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (rollover_frame), 2);
  gtk_widget_show (rollover_frame);
  gtk_box_pack_start (GTK_BOX (vbox_adv_quick_page), rollover_frame, TRUE, TRUE, 0);

  hbox_rollover = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_rollover);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_rollover  ", hbox_rollover  ,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_rollover);
  gtk_container_add (GTK_CONTAINER (rollover_frame), hbox_rollover  );

  pref->rollover_yes = gtk_radio_button_new_with_label (rollover_group, " Yes");
  rollover_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->rollover_yes));
  gtk_widget_ref (pref->rollover_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->rollover_yes", pref->rollover_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->rollover_yes);
  gtk_box_pack_start (GTK_BOX (hbox_rollover), pref->rollover_yes, FALSE, FALSE, 2);

  pref->rollover_no = gtk_radio_button_new_with_label (rollover_group, " No");
  rollover_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->rollover_no));
  gtk_widget_ref (pref->rollover_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->rollover_no", pref->rollover_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->rollover_no);
  gtk_box_pack_start (GTK_BOX (hbox_rollover), pref->rollover_no, FALSE, FALSE, 2);

/*
 *     Set the advanced options yes/no radio button here
 */

  if ( !strcmp(user_data->rollover, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->rollover_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->rollover_no), TRUE);

/***** END NEW QPAGE ROLLOVER OPTION *******/

/*   Number two - this is the good one   */

  adv_frame = gtk_frame_new (" View Qpage options: ");
  gtk_widget_ref (adv_frame);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "adv_frame", adv_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (adv_frame), 2);
  gtk_widget_show (adv_frame);
  gtk_box_pack_start (GTK_BOX (vbox_adv_quick_page), adv_frame, TRUE, TRUE, 0);
  
  hbox_adv = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_adv);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_adv", hbox_adv,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_adv);
  gtk_container_add (GTK_CONTAINER (adv_frame), hbox_adv);
  
  pref->show_options_yes = gtk_radio_button_new_with_label (pref_yes_no_group, " Yes");
  pref_yes_no_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->show_options_yes));
  gtk_widget_ref (pref->show_options_yes);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->show_options_yes", pref->show_options_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->show_options_yes);
  gtk_box_pack_start (GTK_BOX (hbox_adv), pref->show_options_yes, FALSE, FALSE, 2);

  pref->show_options_no = gtk_radio_button_new_with_label (pref_yes_no_group, " No");
  pref_yes_no_group = gtk_radio_button_group (GTK_RADIO_BUTTON (pref->show_options_no));
  gtk_widget_ref (pref->show_options_no);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->show_options_no", pref->show_options_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->show_options_no);
  gtk_box_pack_start (GTK_BOX (hbox_adv), pref->show_options_no, FALSE, FALSE, 2);

/*
 *     Set the advanced options yes/no radio button here
 */


  if ( !strcmp(user_data->show_options, "yes") )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->show_options_yes), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (pref->show_options_no), TRUE);


  frame_qpage = gtk_frame_new (" QPage snpp data: ");
  gtk_widget_ref (frame_qpage);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "frame_qpage", frame_qpage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_set_border_width (GTK_CONTAINER (frame_qpage), 2);
  gtk_widget_show(frame_qpage);
  gtk_box_pack_start (GTK_BOX (vbox_adv_quick_page), frame_qpage, TRUE, TRUE, 0);


  vbox_qpage_data = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_qpage_data);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "vbox_qpage_data", vbox_qpage_data,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_qpage_data);
  gtk_container_add (GTK_CONTAINER (frame_qpage), vbox_qpage_data);

  hbox_qpage_address = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_qpage_address);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_qpage_address", hbox_qpage_address,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_qpage_address);
  gtk_container_add (GTK_CONTAINER (vbox_qpage_data), hbox_qpage_address);

  qpage_address_label = gtk_label_new (" Server Address ");
  gtk_widget_ref (qpage_address_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "qpage_address_label", qpage_address_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (qpage_address_label);
  gtk_box_pack_start (GTK_BOX (hbox_qpage_address), qpage_address_label, FALSE, FALSE, 0);


  pref->qpage_adr = gtk_entry_new_with_max_length (128);

/*
 *   Load the data here 
 */

  gtk_entry_set_text( GTK_ENTRY(pref->qpage_adr), user_data->qpage_adr); 
  gtk_widget_ref (pref->qpage_adr);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->qpage_adr", pref->qpage_adr,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->qpage_adr);
  gtk_box_pack_start (GTK_BOX (hbox_qpage_address), pref->qpage_adr, TRUE, TRUE, 3);



  hbox_qpage_port = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_qpage_port);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbox_qpage_port", hbox_qpage_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_qpage_port);
  gtk_container_add (GTK_CONTAINER (vbox_qpage_data), hbox_qpage_port);

  qpage_port_label = gtk_label_new ("   Port Number   ");
  gtk_widget_ref (qpage_port_label);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "qpage_port_label", qpage_port_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (qpage_port_label);
  gtk_box_pack_start (GTK_BOX (hbox_qpage_port), qpage_port_label, FALSE, FALSE, 0);

  pref->qpage_port = gtk_entry_new_with_max_length (20);

/*
 *   Load the port here 
 */
  gtk_entry_set_text( GTK_ENTRY(pref->qpage_port), user_data->qpage_port); 

  gtk_widget_ref (pref->qpage_port);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref->qpage_port", pref->qpage_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref->qpage_port);
  gtk_box_pack_start (GTK_BOX (hbox_qpage_port), pref->qpage_port, TRUE, TRUE, 3);

/**** End of the advanced box  ******/

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox_tree), hbuttonbox1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox1), 3);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);

  pref_save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (pref_save_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref_save_button", pref_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref_save_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), pref_save_button);
  gtk_container_set_border_width (GTK_CONTAINER (pref_save_button), 1);
  GTK_WIDGET_SET_FLAGS (pref_save_button, GTK_CAN_DEFAULT);

  pref_apply_button = gtk_button_new_with_label ("Apply");
  gtk_widget_ref (pref_apply_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref_apply_button", pref_apply_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref_apply_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), pref_apply_button);
  gtk_container_set_border_width (GTK_CONTAINER (pref_apply_button), 1);
  GTK_WIDGET_SET_FLAGS (pref_apply_button, GTK_CAN_DEFAULT);

  pref_cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (pref_cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (preferences), "pref_cancel_button", pref_cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pref_cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), pref_cancel_button);
  gtk_container_set_border_width (GTK_CONTAINER (pref_cancel_button), 1);
  GTK_WIDGET_SET_FLAGS (pref_cancel_button, GTK_CAN_DEFAULT);

  vbox_data->main_db_box = vbox_db;
  vbox_data->auto_delete_logs_box = vbox_logs;
  vbox_data->signature_box = vbox_sig;
  vbox_data->protocols_box = vbox_protocol;
  vbox_data->auto_page_box = vbox_auto;
  vbox_data->msg_entry_box = vbox_msg_entry;
  vbox_data->advanced_box = vbox_adv;
  vbox_data->advanced_box_sending = vbox_adv_sending;
  vbox_data->advanced_box_qpage = vbox_adv_quick_page;
  vbox_data->vbox_network_settings = vbox_network_settings;


  vbox_data->active_box = vbox_logs;

  vbox_data->data = g_strdup("Hello World");


  gtk_signal_connect (GTK_OBJECT (pref_apply_button), "clicked",
                      GTK_SIGNAL_FUNC (on_pref_save_button_clicked),
                      user_data);

  gtk_signal_connect (GTK_OBJECT (pref_apply_button), "clicked",
                      GTK_SIGNAL_FUNC (on_pref_apply_button_clicked),
                      user_data);

  gtk_signal_connect (GTK_OBJECT (pref_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_pref_save_button_clicked),
                      user_data);

  gtk_signal_connect (GTK_OBJECT (pref_save_button), "clicked",
		      GTK_SIGNAL_FUNC (on_pref_cancel_button_clicked),
		      user_data);

  gtk_signal_connect (GTK_OBJECT (pref_cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (on_pref_cancel_button_clicked),
		      user_data);

  gtk_signal_connect (GTK_OBJECT (refresh_button), "clicked",
                      GTK_SIGNAL_FUNC (get_network_database),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (convert_button), "clicked",
                      GTK_SIGNAL_FUNC (convert_database),
                      user_data);

  gtk_signal_connect (GTK_OBJECT (convert_button), "clicked",
                      GTK_SIGNAL_FUNC (reset_interface),
                      user_data);

  gtk_signal_connect (GTK_OBJECT (pref->set_protocols_yes), "toggled",
                      GTK_SIGNAL_FUNC (on_set_precedence_toggled),
                      table2);

  gtk_signal_connect (GTK_OBJECT (pref->set_protocols_no), "toggled",
                      GTK_SIGNAL_FUNC (on_set_no_precedence_toggled),
                      table2);
  
  gtk_signal_connect (GTK_OBJECT (pref->show_options_yes), "toggled",
                      GTK_SIGNAL_FUNC (on_show_options_toggled),
                      interface_widget);

  gtk_signal_connect (GTK_OBJECT (pref->show_options_no), "toggled",
                      GTK_SIGNAL_FUNC (on_hide_options_toggled),
                      interface_widget);

  gtk_signal_connect (GTK_OBJECT (change_dir_button), "clicked",
                      GTK_SIGNAL_FUNC (on_change_dir_clicked),
                      pref);

  gtk_signal_connect (GTK_OBJECT (ctree1), "tree_select_row",
                      GTK_SIGNAL_FUNC (selection_made),
                      vbox_data);

  gtk_widget_grab_focus(pref_cancel_button);

  return preferences;
}
/* End new pref window   */

static void load_pref_tree(GtkWidget *my_tree)
{
    GtkCTreeNode *node[30];
    gint   i, node_index;
    gchar  data_list [][2][30] = {
	{ "20", "Logging"},
	{ "30", "Signature"},
	{ "40", "Protocols"},
	{ "50", "Auto Page"},
	{ "60", "Msg Entry Box"},
	{ "10", "Database Options"},
	{ "11", "Network Database"},
	{ "70", "Advanced"},
	{ "71", "Sending Options"},
	{ "72", "Qpage Options"},
	{ "NULL", "NULL"},
    };

    i = 0;
    
    node_index = 0;
    while ( strcmp(data_list[i][0], "NULL") )
    {
	node[node_index] = make_node(my_tree, NULL, NULL, data_list[i][0], data_list[i][1]);
	while ( strcmp(data_list[i + 1][0], "NULL") && (  (atoi(data_list[i + 1][0]) % 10) ) )
	{
	    i++;
	    make_node(my_tree, node[node_index], NULL, data_list[i][0], data_list[i][1]);
	}
	node_index++;
	i++;
    }
}
