/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

void show_reply_window ()
{
    GtkWidget *reply_window;

    reply_window = create_two_way_reply();
    gtk_widget_show(reply_window);

}


GtkWidget *create_two_way_reply (void)
{
  GtkWidget *two_way_reply;
  GtkWidget *hbox4;
  GtkWidget *vbox6;
  GtkWidget *reply_frame;
  GtkWidget *scrolledwindow6;
  GtkWidget *scrolledwindow_reply;
  GtkWidget *clist3;
  GtkWidget *label17;
  GtkWidget *label18;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *label21;
  GtkWidget *hbox5;
  GtkWidget *hbox6;
  GtkWidget *reply_status_label;
  GtkWidget *reply_message;
  GtkWidget *saved_reply_frame;
  GtkWidget *scrolledwindow7;
  GtkWidget *clist4;
  GtkWidget *label22;
  GtkWidget *label23;
  GtkWidget *label24;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *vbuttonbox1;
  GtkWidget *reply_status_button;
  GtkWidget *reply_delete_button;
  GtkWidget *reply_okay_button;
  GtkWidget *reply_refresh_button;
  GtkWidget *scrolledwindow2;
  GtkWidget *text1;
  GtkWidget *text_reply;
  GtkWidget *msg_frame;
  reply_info  *reply_data;
  update_text *text_info;
  window_info *window_data;

  reply_data = g_malloc(sizeof(*reply_data));
  text_info = g_malloc(sizeof(*text_info));
  window_data = g_malloc(sizeof(*window_data));
  
  two_way_reply = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  window_data->reply_data = reply_data;
  window_data->text_info = text_info;
  window_data->main_win = two_way_reply;

  gtk_object_set_data (GTK_OBJECT (two_way_reply), "two_way_reply", two_way_reply);
  gtk_window_set_title (GTK_WINDOW (two_way_reply), "Manage 2 Way Replies");
  gtk_widget_set_usize (two_way_reply, 560, 500);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_container_add (GTK_CONTAINER (two_way_reply), hbox4);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox4), vbox6, TRUE, TRUE, 0);

  reply_frame = gtk_frame_new (" Outstanding Messages: ");
  gtk_widget_ref (reply_frame);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_frame", reply_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_frame);
  gtk_box_pack_start (GTK_BOX (vbox6), reply_frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (reply_frame), 3);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow6);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "scrolledwindow6", scrolledwindow6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow6);
  gtk_container_add (GTK_CONTAINER (reply_frame), scrolledwindow6);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist3 = gtk_clist_new (7);
  //gtk_clist_set_column_visibility (GTK_CLIST(clist3), 0, FALSE); 
  gtk_clist_set_column_visibility (GTK_CLIST(clist3), 3, FALSE); 
  gtk_clist_set_column_visibility (GTK_CLIST(clist3), 5, FALSE); 
  gtk_clist_set_column_visibility (GTK_CLIST(clist3), 6, FALSE); 

  gtk_widget_ref (clist3);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "clist3", clist3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist3);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), clist3);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 2, 40);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 4, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 5, 1);
  gtk_clist_set_column_width (GTK_CLIST (clist3), 6, 1);
  gtk_clist_column_titles_show (GTK_CLIST (clist3));

  label17 = gtk_label_new ("Date");
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 0, label17);

  label18 = gtk_label_new ("Name");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 1, label18);

  label19 = gtk_label_new ("Status");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 2, label19);

  label20 = gtk_label_new ("label20");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 3, label20);

  label21 = gtk_label_new ("Msg Preview");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_clist_set_column_widget (GTK_CLIST (clist3), 4, label21);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox5, FALSE, TRUE, 7);

  reply_status_label = gtk_label_new ("  Status:  ");
  gtk_widget_ref (reply_status_label);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_status_label", reply_status_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_status_label);
  gtk_box_pack_start (GTK_BOX (hbox5), reply_status_label, FALSE, FALSE, 0);

  reply_message = gtk_label_new ("");
  gtk_widget_ref (reply_message);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_message", reply_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_message);
  gtk_box_pack_start (GTK_BOX (hbox5), reply_message, FALSE, FALSE, 0);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox6, TRUE, TRUE, 0);

  saved_reply_frame = gtk_frame_new (" Saved Replies:");
  gtk_widget_ref (saved_reply_frame);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "saved_reply_frame", saved_reply_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (saved_reply_frame);
  gtk_container_add (GTK_CONTAINER (hbox6), saved_reply_frame);
  gtk_container_set_border_width (GTK_CONTAINER (saved_reply_frame), 1);

  scrolledwindow7 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow7);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "scrolledwindow7", scrolledwindow7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow7);
  gtk_container_add (GTK_CONTAINER (saved_reply_frame), scrolledwindow7);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow7), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist4 = gtk_clist_new (7);
  //gtk_clist_set_column_visibility (GTK_CLIST(clist4), 0, FALSE); 
  gtk_clist_set_column_visibility (GTK_CLIST(clist4), 4, FALSE); 
  gtk_clist_set_column_visibility (GTK_CLIST(clist4), 5, FALSE); 
  gtk_clist_set_column_visibility (GTK_CLIST(clist4), 6, FALSE); 
  gtk_widget_ref (clist4);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "clist4", clist4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist4);
  gtk_container_add (GTK_CONTAINER (scrolledwindow7), clist4);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 1, 100);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 2, 120);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 3, 120);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 4, 10);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 5, 1);
  gtk_clist_set_column_width (GTK_CLIST (clist4), 6, 1);
  gtk_clist_column_titles_show (GTK_CLIST (clist4));

  label22 = gtk_label_new ("Date");
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 0, label22);

  label23 = gtk_label_new ("Name");
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 1, label23);

  label24 = gtk_label_new ("Msg Preview");
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 2, label24);

  label25 = gtk_label_new ("Reply Preview");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 3, label25);

  label26 = gtk_label_new ("");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_clist_set_column_widget (GTK_CLIST (clist4), 4, label26);

/*******************************************************/
  msg_frame = gtk_frame_new ("Full message:");
  gtk_widget_ref (msg_frame);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "msg_frame", msg_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (msg_frame);
  gtk_box_pack_start (GTK_BOX (vbox6), msg_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (msg_frame), 1);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (msg_frame), scrolledwindow2);
  gtk_widget_set_usize (scrolledwindow2, 580, 40);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), text1);


  reply_frame = gtk_frame_new ("Full reply:");
  gtk_widget_ref (reply_frame);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_frame", reply_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_frame);
  gtk_box_pack_start (GTK_BOX (vbox6), reply_frame, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (reply_frame), 1);


  scrolledwindow_reply = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow_reply);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "scrolledwindow_reply", scrolledwindow_reply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow_reply);
  gtk_container_add (GTK_CONTAINER (reply_frame), scrolledwindow_reply);
  gtk_widget_set_usize (scrolledwindow_reply, 580, 40);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_reply), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);


  text_reply = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text_reply);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "text_reply", text_reply,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_reply);
  gtk_container_add (GTK_CONTAINER (scrolledwindow_reply), text_reply);

/*******************************************************/


  vbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (vbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "vbuttonbox1", vbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbuttonbox1);
  //gtk_box_pack_start (GTK_BOX (hbox4), vbuttonbox1, FALSE, TRUE, 5);
  gtk_box_pack_start (GTK_BOX (vbox6), vbuttonbox1, FALSE, TRUE, 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox1), GTK_BUTTONBOX_SPREAD);

  reply_status_button = gtk_button_new_with_label ("Status");
  gtk_widget_ref (reply_status_button);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_status_button", reply_status_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_status_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), reply_status_button);
  gtk_container_set_border_width (GTK_CONTAINER (reply_status_button), 1);
  GTK_WIDGET_SET_FLAGS (reply_status_button, GTK_CAN_DEFAULT);

  reply_delete_button = gtk_button_new_with_label ("Delete");
  gtk_widget_ref (reply_delete_button);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_delete_button", reply_delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_delete_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), reply_delete_button);
  gtk_container_set_border_width (GTK_CONTAINER (reply_delete_button), 1);
  GTK_WIDGET_SET_FLAGS (reply_delete_button, GTK_CAN_DEFAULT);

  reply_refresh_button = gtk_button_new_with_label ("Refresh");
  gtk_widget_ref (reply_refresh_button);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_refresh_button", reply_refresh_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_refresh_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), reply_refresh_button);
  GTK_WIDGET_SET_FLAGS (reply_refresh_button, GTK_CAN_DEFAULT);

  reply_okay_button = gtk_button_new_with_label ("OK");
  gtk_widget_ref (reply_okay_button);
  gtk_object_set_data_full (GTK_OBJECT (two_way_reply), "reply_okay_button", reply_okay_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_okay_button);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), reply_okay_button);
  gtk_container_set_border_width (GTK_CONTAINER (reply_okay_button), 1);
  GTK_WIDGET_SET_FLAGS (reply_okay_button, GTK_CAN_DEFAULT);


  load_pending_clist(clist3);
  load_old_clist(clist4);

  reply_data->pending_clist = clist3;
  reply_data->old_clist = clist4;
  reply_data->status_label = reply_message;
  reply_data->reply_box = text_reply;

  text_info->new_list = clist3;
  text_info->old_list = clist4;
  text_info->text_box = text1;
  text_info->reply_box = text_reply;

  gtk_signal_connect (GTK_OBJECT (reply_status_button), "clicked",
                      GTK_SIGNAL_FUNC (on_reply_status_button_clicked),
                      reply_data);

  gtk_signal_connect (GTK_OBJECT (reply_refresh_button), "clicked",
                      GTK_SIGNAL_FUNC (on_reply_refresh_button_clicked),
                      reply_data);

  gtk_signal_connect (GTK_OBJECT (reply_delete_button), "clicked",
                      GTK_SIGNAL_FUNC (on_reply_delete_button_clicked),
                      reply_data);

  gtk_signal_connect (GTK_OBJECT (reply_okay_button), "clicked",
                      GTK_SIGNAL_FUNC (on_reply_okay_button_clicked),
                      window_data);

  gtk_signal_connect (GTK_OBJECT (clist3), "select_row",
		      GTK_SIGNAL_FUNC (on_click_column_reply),
		      text_info);

  gtk_signal_connect (GTK_OBJECT (clist4), "select_row",
		      GTK_SIGNAL_FUNC (on_click_column_reply),
		      text_info);

  gtk_widget_grab_focus(reply_okay_button);
  return two_way_reply;
}

