/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"
#include <dirent.h>

static void load_auto_page_profiles(GtkWidget *script_page_combo);
static void delete_profile(GtkWidget *w, GtkWidget *combo_box);

void show_script_page()
{
    GtkWidget   *script_main_window;

    script_main_window = create_script_page(CREATE, NULL);
    gtk_widget_show(script_main_window);

}

void edit_script_page(int id)
{
    GtkWidget    *script_main_window;
    script_text  *script_stuff;

    script_stuff = get_script_memory();

    script_main_window = create_script_page(EDIT, script_stuff);
    gtk_widget_show(script_main_window);

    free_script_memory(script_stuff);
}


GtkWidget *create_script_page (int flag, script_text *data)
{
  GtkObject *interval_spin_adj;
  GtkObject *hour_spin_adj;
  GtkWidget *vbox19;
  GtkWidget *notebook3;
  GtkWidget *vbox24;
  GtkWidget *vbox25;
  GtkWidget *vbox_combo;

  GtkWidget *set_time_label;
  GtkWidget *auto_okay_button;
  GtkWidget *auto_save_run_button;

  GtkWidget *label49;
  GtkWidget *vbox21;
  GtkWidget *hseparator19;
  GtkWidget *hbox56;
  GtkWidget *label63;
  GtkWidget *new_hbox;
  GtkWidget *script_page_combo;

  GtkWidget *label64;
  GtkObject *minute_spin_adj;

  GtkObject *one_start_adj;
  GtkObject *one_end_adj;
  GtkObject *two_start_adj;
  GtkObject *two_end_adj;
  GtkObject *three_start_adj;
  GtkObject *three_end_adj;
  GtkObject *four_start_adj;
  GtkObject *four_end_adj;
  GtkObject *fields_spin_adj;
  GSList *auto_ampm_group = NULL;
  GtkWidget *hseparator20;
  GtkWidget *hbox57;
  GtkWidget *hbox58;
  GSList *auto_recur_group = NULL;
  GtkWidget *hbox59;
  GtkWidget *hbox601;
  GtkWidget *label65;
  GtkWidget *hseparator21;
  GtkWidget *vbox22;
  GtkWidget *frame13;
  GtkWidget *hbox60;
  GtkWidget *frame14;
  GtkWidget *frame15;
  GtkWidget *hbox61;
  GSList *hbox61_group = NULL;
  GSList *hbox_user_group = NULL;
  GtkWidget *label51;
  GtkWidget *vbox23;
  GtkWidget *frame16;
  GtkWidget *hbox62;
  GSList *parse_group_group = NULL;
  GtkWidget *hbox63;
  GtkWidget *label66;
  GtkWidget *hbox64;
  GtkWidget *frame17;
  GtkWidget *hbox65;
  GtkWidget *label67;
  GtkWidget *label68;
  GtkWidget *frame18;
  GtkWidget *hbox66;
  GtkWidget *label69;
  GtkWidget *label70;
  GtkWidget *hbox67;
  GtkWidget *frame19;
  GtkWidget *hbox68;
  GtkWidget *label71;
  GtkWidget *label72;
  GtkWidget *frame20;
  GtkWidget *hbox69;
  GtkWidget *label73;
  GtkWidget *label74;
  GtkWidget *label52;
  GtkWidget *hbuttonbox3;
  GtkWidget *delete_profile_button;
  GtkWidget *delete_script_button;
  GtkWidget *reload_script_button;
  GtkWidget *view_script_button;
  gint      script_running;
  GtkWidget *scrolledwindow4;
  //GtkWidget *clist1;
  GtkWidget *label111;
  GtkWidget *label112;
  GtkWidget *label113;
  GtkWidget *frame_user;
  GtkWidget *hbox_user;
  GtkWidget *hbuttonbox_combo;
  GtkWidget *frame_combo;

  script_data *script_widgets;

  int           hour = 0;
  int           am = 0;
  time_t        time_val;
  struct  tm    *t_struct;
  reload_data   *reload;
  manual_widgets *manual_data;

  time_val = time(&time_val);
  t_struct = localtime(&time_val);

  reload = g_malloc(sizeof(*reload));

  script_widgets = g_malloc(sizeof(*script_widgets));
  script_widgets->profile_name = g_malloc(MAX_LENGTH);
  strcpy(script_widgets->profile_name, "");

  script_running = get_status_script_page();

  script_widgets->script_page = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  //gtk_widget_set_usize(script_widgets->script_page, 375, 550);
  gtk_object_set_data (GTK_OBJECT (script_widgets->script_page), "script_widgets->script_page", script_widgets->script_page);
  gtk_window_set_title (GTK_WINDOW (script_widgets->script_page), "Auto g-page");

  vbox19 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox19);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox19", vbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox19);
  gtk_container_add (GTK_CONTAINER (script_widgets->script_page), vbox19);

  notebook3 = gtk_notebook_new ();
  gtk_widget_ref (notebook3);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "notebook3", notebook3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook3);
  gtk_box_pack_start (GTK_BOX (vbox19), notebook3, TRUE, TRUE, 0);

/******** HERE IS THE SCRIPT LIST STUFF    *****************/

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox24);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox24", vbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (notebook3), vbox24);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox25);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox25", vbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox25);
  gtk_box_pack_start (GTK_BOX (vbox24), vbox25, TRUE, TRUE, 0);
/*       NEW LIST BOX    */

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox25), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  script_widgets->data_clist = gtk_clist_new (3);
  gtk_widget_set_usize(script_widgets->data_clist, 300, 230);
  gtk_clist_set_column_visibility (GTK_CLIST(script_widgets->data_clist), 2, FALSE);
  gtk_widget_ref (script_widgets->data_clist);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->data_clist", script_widgets->data_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->data_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), script_widgets->data_clist);
  gtk_clist_set_column_width (GTK_CLIST (script_widgets->data_clist), 0, 100);
  gtk_clist_set_column_width (GTK_CLIST (script_widgets->data_clist), 1, 200);
  gtk_clist_set_column_width (GTK_CLIST (script_widgets->data_clist), 2, 10);
  gtk_clist_column_titles_show (GTK_CLIST (script_widgets->data_clist));

  label111 = gtk_label_new ("Fields");
  gtk_widget_ref (label111);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label111", label111,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label111);
  gtk_clist_set_column_widget (GTK_CLIST (script_widgets->data_clist), 0, label111);

  label112 = gtk_label_new ("Data:");
  gtk_widget_ref (label112);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label112", label112,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label112);
  gtk_clist_set_column_widget (GTK_CLIST (script_widgets->data_clist), 1, label112);

  label113 = gtk_label_new ("label113");
  gtk_widget_ref (label113);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label113", label113,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label113);
  gtk_clist_set_column_widget (GTK_CLIST (script_widgets->data_clist), 2, label113);

/*       END NEW LIST BOX    */

  load_script_list(script_widgets->data_clist);


  frame_combo = gtk_frame_new ("Saved Profile Options:");
  gtk_widget_ref (frame_combo);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame_combo", frame_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_combo);
  gtk_box_pack_start (GTK_BOX (vbox24), frame_combo, TRUE, TRUE, 1);
  gtk_container_set_border_width (GTK_CONTAINER (frame_combo), 3);



  vbox_combo = gtk_vbox_new (FALSE, 3);
  gtk_widget_ref (vbox_combo);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox_combo", vbox_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_combo);
  //gtk_container_add (GTK_CONTAINER (vbox24), vbox_combo);
  gtk_container_add (GTK_CONTAINER (frame_combo), vbox_combo);


  new_hbox = gtk_hbox_new (FALSE, 3);
  gtk_widget_ref (new_hbox);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "new_hbox", new_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_hbox);

/*   New Button box code starts here   */

  hbuttonbox_combo = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox_combo);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbuttonbox_combo", hbuttonbox_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox_combo);
  gtk_box_pack_start (GTK_BOX (new_hbox), hbuttonbox_combo, TRUE, TRUE, 2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox_combo), GTK_BUTTONBOX_EDGE);


/*  New button box code ends here   */
  
  delete_profile_button = gtk_button_new_with_label ("Delete profile");
  gtk_widget_ref (delete_profile_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "delete_profile_button", delete_profile_button,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_show(delete_profile_button);
  GTK_WIDGET_SET_FLAGS (delete_profile_button, GTK_CAN_DEFAULT);

  script_page_combo = gtk_combo_new();
  gtk_container_set_border_width (GTK_CONTAINER (script_page_combo), 3);
  load_auto_page_profiles(script_page_combo);

/*
 *  Here is where we add the profile combo box to the reload structure
 */

  reload->combo_box = script_page_combo; /* MEMORY LEAK: The strings in this GList are never freed */

  gtk_widget_show(script_page_combo);

  reload_script_button = gtk_button_new_with_label ("Reload profile");
  gtk_widget_ref (reload_script_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "reload_script_button", reload_script_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  if ( !script_running )
  {
      gtk_widget_show (reload_script_button);
  }


  GTK_WIDGET_SET_FLAGS (reload_script_button, GTK_CAN_DEFAULT);

  delete_script_button = gtk_button_new_with_label ("Deactivate Profile");
  gtk_widget_ref (delete_script_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "delete_script_button", delete_script_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  if ( script_running )
      gtk_widget_show (delete_script_button);

  GTK_WIDGET_SET_FLAGS (delete_script_button, GTK_CAN_DEFAULT);

  view_script_button = gtk_button_new_with_label ("View Profile");
  gtk_widget_ref (view_script_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "view_script_button", view_script_button,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_show (view_script_button);

  GTK_WIDGET_SET_FLAGS (view_script_button, GTK_CAN_DEFAULT);


  gtk_box_pack_start( GTK_BOX (vbox_combo), script_page_combo, FALSE, FALSE, 5);

  gtk_container_add (GTK_CONTAINER (hbuttonbox_combo), reload_script_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox_combo), delete_script_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox_combo), delete_profile_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox_combo), view_script_button);

  gtk_box_pack_start( GTK_BOX (vbox_combo), new_hbox, TRUE, TRUE, 5);



/******* START THE SCRIPT DEFINE STUFF HERE     ********/


  label49 = gtk_label_new (" Active Profile: ");
  gtk_widget_ref (label49);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label49", label49,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label49);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 0), label49);


  vbox22 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox22);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox22", vbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox22);
  gtk_container_add (GTK_CONTAINER (notebook3), vbox22);

  frame13 = gtk_frame_new (" Full path of script:");
  gtk_widget_ref (frame13);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame13", frame13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame13);
  gtk_box_pack_start (GTK_BOX (vbox22), frame13, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame13), 1);

  hbox60 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox60);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox60", hbox60,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox60);
  gtk_container_add (GTK_CONTAINER (frame13), hbox60);

  script_widgets->script_entry = gtk_entry_new_with_max_length (1000);
  gtk_widget_ref (script_widgets->script_entry);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->script_entry", script_widgets->script_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->script_entry);
  gtk_box_pack_start (GTK_BOX (hbox60), script_widgets->script_entry, TRUE, TRUE, 2);

  script_widgets->browse_script_button = gtk_button_new_with_label (" Browse ");
  gtk_widget_ref (script_widgets->browse_script_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->browse_script_button", script_widgets->browse_script_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->browse_script_button);
  gtk_box_pack_start (GTK_BOX (hbox60), script_widgets->browse_script_button, FALSE, FALSE, 2);
  gtk_container_set_border_width (GTK_CONTAINER (script_widgets->browse_script_button), 2);


  frame14 = gtk_frame_new (" Full path of target file:  ");
  gtk_widget_ref (frame14);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame14", frame14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame14);
  gtk_box_pack_start (GTK_BOX (vbox22), frame14, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame14), 1);


  hbox601 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox601);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox601", hbox601,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox601);
  gtk_container_add (GTK_CONTAINER (frame14), hbox601);


  script_widgets->target_entry = gtk_entry_new_with_max_length (1000);
  gtk_widget_ref (script_widgets->target_entry);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->target_entry", script_widgets->target_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->target_entry);
  gtk_box_pack_start (GTK_BOX (hbox601), script_widgets->target_entry, TRUE, TRUE, 2);

  script_widgets->browse_script_button1 = gtk_button_new_with_label (" Browse ");
  gtk_widget_ref (script_widgets->browse_script_button1);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->browse_script_button1", script_widgets->browse_script_button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->browse_script_button1);
  gtk_box_pack_start (GTK_BOX (hbox601), script_widgets->browse_script_button1, FALSE, FALSE, 2);
  gtk_container_set_border_width (GTK_CONTAINER (script_widgets->browse_script_button), 2);


  frame15 = gtk_frame_new (" Do this to target file after sending page: ");
  gtk_widget_ref (frame15);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame15", frame15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame15);
  gtk_box_pack_start (GTK_BOX (vbox22), frame15, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame15), 1);

  hbox61 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox61);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox61", hbox61,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox61);
  gtk_container_add (GTK_CONTAINER (frame15), hbox61);

  script_widgets->rename_radio = gtk_radio_button_new_with_label (hbox61_group, " Rename ");
  hbox61_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->rename_radio));
  gtk_widget_ref (script_widgets->rename_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->rename_radio", script_widgets->rename_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->rename_radio);
  gtk_box_pack_start (GTK_BOX (hbox61), script_widgets->rename_radio, FALSE, FALSE, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (script_widgets->rename_radio), TRUE);

  script_widgets->delete_radio = gtk_radio_button_new_with_label (hbox61_group, " Delete");
  hbox61_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->delete_radio));
  gtk_widget_ref (script_widgets->delete_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->delete_radio", script_widgets->delete_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->delete_radio);
  gtk_box_pack_start (GTK_BOX (hbox61), script_widgets->delete_radio, FALSE, FALSE, 0);

  script_widgets->ignore_radio = gtk_radio_button_new_with_label (hbox61_group, " Ignore ");
  hbox61_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->ignore_radio));
  gtk_widget_ref (script_widgets->ignore_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->ignore_radio", script_widgets->ignore_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->ignore_radio);
  gtk_box_pack_start (GTK_BOX (hbox61), script_widgets->ignore_radio, FALSE, FALSE, 0);

  frame_user = gtk_frame_new (" Page recipient options: ");
  gtk_widget_ref (frame_user);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame_user", frame_user,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_user);
  gtk_box_pack_start (GTK_BOX (vbox22), frame_user, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_user), 1);

  hbox_user = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_user);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox_user", hbox_user,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_user);
  gtk_container_add (GTK_CONTAINER (frame_user), hbox_user);

  script_widgets->select_user_radio = gtk_radio_button_new_with_label (hbox_user_group, " Select user from main list ");
  hbox_user_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->select_user_radio));
  gtk_widget_ref (script_widgets->select_user_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->select_user_radio), "script_widgets->select_user_radio", script_widgets->select_user_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->select_user_radio);
  gtk_box_pack_start (GTK_BOX (hbox_user), script_widgets->select_user_radio, FALSE, FALSE, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (script_widgets->select_user_radio), TRUE);

  script_widgets->manual_user_radio = gtk_radio_button_new_with_label (hbox_user_group, " Send user in file");
  hbox_user_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->manual_user_radio));
  gtk_widget_ref (script_widgets->manual_user_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->manual_user_radio), "script_widgets->manual_user_radio", script_widgets->manual_user_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->manual_user_radio);
  gtk_box_pack_start (GTK_BOX (hbox_user), script_widgets->manual_user_radio, FALSE, FALSE, 0);



  label51 = gtk_label_new (" File Options ");
  gtk_widget_ref (label51);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label51", label51,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label51);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 1), label51);


  vbox21 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox21);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox21", vbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox21);
  gtk_container_add (GTK_CONTAINER (notebook3), vbox21);

  script_widgets->auto_calender = gtk_calendar_new ();
  gtk_widget_ref (script_widgets->auto_calender);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->auto_calender", script_widgets->auto_calender,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->auto_calender);
  gtk_box_pack_start (GTK_BOX (vbox21), script_widgets->auto_calender, TRUE, TRUE, 0);
  gtk_calendar_display_options (GTK_CALENDAR (script_widgets->auto_calender),
                                GTK_CALENDAR_SHOW_HEADING
                                | GTK_CALENDAR_SHOW_DAY_NAMES);
  gtk_calendar_select_day( GTK_CALENDAR(script_widgets->auto_calender), (t_struct->tm_mday));

  hseparator19 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator19);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hseparator19", hseparator19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator19);
  gtk_box_pack_start (GTK_BOX (vbox21), hseparator19, TRUE, TRUE, 0);

  hbox56 = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox56);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox56", hbox56,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox56);
  gtk_box_pack_start (GTK_BOX (vbox21), hbox56, TRUE, TRUE, 0);

  if ( t_struct->tm_hour <= 11 )
  {
      am = 1;
      hour = t_struct->tm_hour;
  }
  else
  {
      am = 0;
      hour = t_struct->tm_hour -12;
  }

  if ( hour == 0 )
      hour = 12;

  label63 = gtk_label_new ("Hour");
  gtk_widget_ref (label63);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label63", label63,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label63);
  gtk_box_pack_start (GTK_BOX (hbox56), label63, FALSE, FALSE, 0);

  hour_spin_adj = gtk_adjustment_new (hour, 1, 12, 1, 10, 10);
  script_widgets->hour_spin = gtk_spin_button_new (GTK_ADJUSTMENT (hour_spin_adj), 1, 0);
  gtk_widget_ref (script_widgets->hour_spin);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->hour_spin", script_widgets->hour_spin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->hour_spin);
  gtk_box_pack_start (GTK_BOX (hbox56), script_widgets->hour_spin, TRUE, FALSE, 0);

  label64 = gtk_label_new ("Minute");
  gtk_widget_ref (label64);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label64", label64,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label64);
  gtk_box_pack_start (GTK_BOX (hbox56), label64, TRUE, FALSE, 0);

  minute_spin_adj = gtk_adjustment_new (t_struct->tm_min, 0, 59, 1, 10, 10);
  script_widgets->minute_spin = gtk_spin_button_new (GTK_ADJUSTMENT (minute_spin_adj), 1, 0);
  gtk_widget_ref (script_widgets->minute_spin);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->minute_spin", script_widgets->minute_spin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->minute_spin);
  gtk_box_pack_start (GTK_BOX (hbox56), script_widgets->minute_spin, FALSE, FALSE, 0);

  script_widgets->am_radio = gtk_radio_button_new_with_label (auto_ampm_group, "AM");
  auto_ampm_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->am_radio));
  gtk_widget_ref (script_widgets->am_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->am_radio", script_widgets->am_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->am_radio);
  gtk_box_pack_start (GTK_BOX (hbox56), script_widgets->am_radio, FALSE, FALSE, 0);

  script_widgets->pm_radio = gtk_radio_button_new_with_label (auto_ampm_group, "PM");
  auto_ampm_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->pm_radio));
  gtk_widget_ref (script_widgets->pm_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->pm_radio", script_widgets->pm_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->pm_radio);
  gtk_box_pack_start (GTK_BOX (hbox56), script_widgets->pm_radio, FALSE, FALSE, 0);

  if ( am )
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (script_widgets->am_radio), TRUE);
  else
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (script_widgets->pm_radio), TRUE);

  hseparator20 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator20);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hseparator20", hseparator20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator20);
  gtk_box_pack_start (GTK_BOX (vbox21), hseparator20, TRUE, TRUE, 0);

  hbox57 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox57);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox57", hbox57,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox57);
  gtk_box_pack_start (GTK_BOX (vbox21), hbox57, TRUE, TRUE, 0);

  hbox58 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox58);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox58", hbox58,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox58);
  gtk_box_pack_start (GTK_BOX (hbox57), hbox58, FALSE, TRUE, 0);

  script_widgets->once_radio = gtk_radio_button_new_with_label (auto_recur_group, "Once");
  auto_recur_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->once_radio));
  gtk_widget_ref (script_widgets->once_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->once_radio", script_widgets->once_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->once_radio);
  gtk_box_pack_start (GTK_BOX (hbox58), script_widgets->once_radio, FALSE, FALSE, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (script_widgets->once_radio), TRUE);

  script_widgets->hourly_radio = gtk_radio_button_new_with_label (auto_recur_group, "Hourly");
  auto_recur_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->hourly_radio));
  gtk_widget_ref (script_widgets->hourly_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->hourly_radio", script_widgets->hourly_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->hourly_radio);
  gtk_box_pack_start (GTK_BOX (hbox58), script_widgets->hourly_radio, FALSE, FALSE, 0);

  script_widgets->daily_radio = gtk_radio_button_new_with_label (auto_recur_group, "Daily");
  auto_recur_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->daily_radio));
  gtk_widget_ref (script_widgets->daily_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->daily_radio", script_widgets->daily_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->daily_radio);
  gtk_box_pack_start (GTK_BOX (hbox58), script_widgets->daily_radio, FALSE, FALSE, 0);

  script_widgets->manual_radio = gtk_radio_button_new_with_label (auto_recur_group, "Manual");
  auto_recur_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->manual_radio));
  gtk_widget_ref (script_widgets->manual_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->manual_radio", script_widgets->manual_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->manual_radio);
  gtk_box_pack_start (GTK_BOX (hbox57), script_widgets->manual_radio, FALSE, FALSE, 0);

  hbox59 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox59);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox59", hbox59,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox59);
  gtk_box_pack_start (GTK_BOX (hbox57), hbox59, TRUE, TRUE, 0);

  interval_spin_adj = gtk_adjustment_new (0, 0, 1440, 1, 10, 10);
  script_widgets->interval_spin = gtk_spin_button_new (GTK_ADJUSTMENT (interval_spin_adj), 1, 2);
  gtk_widget_ref (script_widgets->interval_spin);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->interval_spin", script_widgets->interval_spin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox59), script_widgets->interval_spin, TRUE, TRUE, 2);

  label65 = gtk_label_new ("Minutes");
  gtk_widget_ref (label65);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label65", label65,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox59), label65, FALSE, FALSE, 2);

  manual_data = g_malloc(sizeof(*manual_data));
  manual_data->label = label65;
  manual_data->spinbox = script_widgets->interval_spin;

  hseparator21 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator21);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hseparator21", hseparator21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator21);
  gtk_box_pack_start (GTK_BOX (vbox21), hseparator21, TRUE, TRUE, 0);

  set_time_label = gtk_label_new (" Set Time ");
  gtk_widget_ref (set_time_label);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "set_time_label", set_time_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set_time_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 2), set_time_label);


/******** PARSE OPTIONS CODE******************/
  vbox23 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox23);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "vbox23", vbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox23);
  gtk_container_add (GTK_CONTAINER (notebook3), vbox23);

  frame16 = gtk_frame_new (" Parse Options: ");
  gtk_widget_ref (frame16);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame16", frame16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame16);
  gtk_box_pack_start (GTK_BOX (vbox23), frame16, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame16), 1);

  hbox62 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox62);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox62", hbox62,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox62);
  gtk_container_add (GTK_CONTAINER (frame16), hbox62);

  script_widgets->send_all_radio = gtk_radio_button_new_with_label (parse_group_group, " Send Entire File");
  parse_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->send_all_radio));
  gtk_widget_ref (script_widgets->send_all_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->send_all_radio", script_widgets->send_all_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->send_all_radio);
  gtk_box_pack_start (GTK_BOX (hbox62), script_widgets->send_all_radio, FALSE, FALSE, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (script_widgets->send_all_radio), TRUE);

  script_widgets->define_fields_radio = gtk_radio_button_new_with_label (parse_group_group, "Define Fields");
  parse_group_group = gtk_radio_button_group (GTK_RADIO_BUTTON (script_widgets->define_fields_radio));
  gtk_widget_ref (script_widgets->define_fields_radio);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->define_fields_radio", script_widgets->define_fields_radio,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->define_fields_radio);
  gtk_box_pack_start (GTK_BOX (hbox62), script_widgets->define_fields_radio, FALSE, FALSE, 0);

  hbox63 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox63);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox63", hbox63,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox63);
  gtk_box_pack_start (GTK_BOX (hbox62), hbox63, TRUE, TRUE, 0);

  fields_spin_adj = gtk_adjustment_new (1, 1, 4, 1, 10, 10);
  script_widgets->fields_spin = gtk_spin_button_new (GTK_ADJUSTMENT (fields_spin_adj), 1, 0);
  gtk_widget_ref (script_widgets->fields_spin);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->fields_spin", script_widgets->fields_spin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->fields_spin);
  gtk_box_pack_start (GTK_BOX (hbox63), script_widgets->fields_spin, TRUE, TRUE, 2);

  label66 = gtk_label_new ("No. of Fields ");
  gtk_widget_ref (label66);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label66", label66,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label66);
  gtk_box_pack_start (GTK_BOX (hbox63), label66, FALSE, FALSE, 0);

  hbox64 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox64);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox64", hbox64,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox64);
  gtk_box_pack_start (GTK_BOX (vbox23), hbox64, TRUE, TRUE, 0);

  frame17 = gtk_frame_new ("Field 1");
  gtk_widget_ref (frame17);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame17", frame17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame17);
  gtk_box_pack_start (GTK_BOX (hbox64), frame17, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame17), 2);

  hbox65 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox65);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox65", hbox65,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox65);
  gtk_container_add (GTK_CONTAINER (frame17), hbox65);

  one_start_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->one_start = gtk_spin_button_new (GTK_ADJUSTMENT (one_start_adj), 1, 0);
  gtk_widget_ref (script_widgets->one_start);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->one_start", script_widgets->one_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->one_start);
  gtk_box_pack_start (GTK_BOX (hbox65), script_widgets->one_start, TRUE, TRUE, 2);

  label67 = gtk_label_new ("Begin ");
  gtk_widget_ref (label67);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label67", label67,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label67);
  gtk_box_pack_start (GTK_BOX (hbox65), label67, FALSE, FALSE, 0);

  one_end_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->one_end = gtk_spin_button_new (GTK_ADJUSTMENT (one_end_adj), 1, 0);
  gtk_widget_ref (script_widgets->one_end);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->one_end", script_widgets->one_end,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->one_end);
  gtk_box_pack_start (GTK_BOX (hbox65), script_widgets->one_end, TRUE, TRUE, 1);

  label68 = gtk_label_new ("End ");
  gtk_widget_ref (label68);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label68", label68,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label68);
  gtk_box_pack_start (GTK_BOX (hbox65), label68, FALSE, FALSE, 0);

  frame18 = gtk_frame_new ("Field 2");
  gtk_widget_ref (frame18);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame18", frame18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame18);
  gtk_box_pack_start (GTK_BOX (hbox64), frame18, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame18), 2);

  hbox66 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox66);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox66", hbox66,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox66);
  gtk_container_add (GTK_CONTAINER (frame18), hbox66);

  two_start_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->two_start = gtk_spin_button_new (GTK_ADJUSTMENT (two_start_adj), 1, 0);
  gtk_widget_ref (script_widgets->two_start);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->two_start", script_widgets->two_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->two_start);
  gtk_box_pack_start (GTK_BOX (hbox66), script_widgets->two_start, TRUE, TRUE, 2);

  label69 = gtk_label_new ("Begin ");
  gtk_widget_ref (label69);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label69", label69,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label69);
  gtk_box_pack_start (GTK_BOX (hbox66), label69, FALSE, FALSE, 0);

  two_end_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->two_end = gtk_spin_button_new (GTK_ADJUSTMENT (two_end_adj), 1, 0);
  gtk_widget_ref (script_widgets->two_end);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->two_end", script_widgets->two_end,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->two_end);
  gtk_box_pack_start (GTK_BOX (hbox66), script_widgets->two_end, TRUE, TRUE, 0);

  label70 = gtk_label_new ("End ");
  gtk_widget_ref (label70);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label70", label70,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label70);
  gtk_box_pack_start (GTK_BOX (hbox66), label70, FALSE, FALSE, 0);

  hbox67 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox67);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox67", hbox67,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox67);
  gtk_box_pack_start (GTK_BOX (vbox23), hbox67, TRUE, TRUE, 0);

  frame19 = gtk_frame_new ("Field 3");
  gtk_widget_ref (frame19);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame19", frame19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame19);
  gtk_box_pack_start (GTK_BOX (hbox67), frame19, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame19), 2);

  hbox68 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox68);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox68", hbox68,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox68);
  gtk_container_add (GTK_CONTAINER (frame19), hbox68);

  three_start_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->three_start = gtk_spin_button_new (GTK_ADJUSTMENT (three_start_adj), 1, 0);
  gtk_widget_ref (script_widgets->three_start);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->three_start", script_widgets->three_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->three_start);
  gtk_box_pack_start (GTK_BOX (hbox68), script_widgets->three_start, TRUE, TRUE, 2);

  label71 = gtk_label_new ("Begin ");
  gtk_widget_ref (label71);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label71", label71,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label71);
  gtk_box_pack_start (GTK_BOX (hbox68), label71, FALSE, FALSE, 0);

  three_end_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->three_end = gtk_spin_button_new (GTK_ADJUSTMENT (three_end_adj), 1, 0);
  gtk_widget_ref (script_widgets->three_end);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->three_end", script_widgets->three_end,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->three_end);
  gtk_box_pack_start (GTK_BOX (hbox68), script_widgets->three_end, TRUE, TRUE, 0);

  label72 = gtk_label_new ("End ");
  gtk_widget_ref (label72);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label72", label72,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label72);
  gtk_box_pack_start (GTK_BOX (hbox68), label72, FALSE, FALSE, 0);

  frame20 = gtk_frame_new ("Field 4");
  gtk_widget_ref (frame20);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "frame20", frame20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame20);
  gtk_box_pack_start (GTK_BOX (hbox67), frame20, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame20), 2);

  hbox69 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox69);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbox69", hbox69,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox69);
  gtk_container_add (GTK_CONTAINER (frame20), hbox69);

  four_start_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->four_start = gtk_spin_button_new (GTK_ADJUSTMENT (four_start_adj), 1, 0);
  gtk_widget_ref (script_widgets->four_start);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->four_start", script_widgets->four_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->four_start);
  gtk_box_pack_start (GTK_BOX (hbox69), script_widgets->four_start, TRUE, TRUE, 2);

  label73 = gtk_label_new ("Begin ");
  gtk_widget_ref (label73);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label73", label73,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label73);
  gtk_box_pack_start (GTK_BOX (hbox69), label73, FALSE, FALSE, 0);

  four_end_adj = gtk_adjustment_new (0, 0, 999, 1, 10, 10);
  script_widgets->four_end = gtk_spin_button_new (GTK_ADJUSTMENT (four_end_adj), 1, 0);
  gtk_widget_ref (script_widgets->four_end);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->four_end", script_widgets->four_end,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->four_end);
  gtk_box_pack_start (GTK_BOX (hbox69), script_widgets->four_end, TRUE, TRUE, 0);

  label74 = gtk_label_new ("End ");
  gtk_widget_ref (label74);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label74", label74,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label74);
  gtk_box_pack_start (GTK_BOX (hbox69), label74, FALSE, FALSE, 0);

  label52 = gtk_label_new (" Parse Options ");
  gtk_widget_ref (label52);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label52", label52,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label52);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 3), label52);
/*
  empty_notebook_page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (empty_notebook_page);
  gtk_container_add (GTK_CONTAINER (notebook3), empty_notebook_page);

  label53 = gtk_label_new ("  ");
  gtk_widget_ref (label53);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "label53", label53,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label53);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook3), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook3), 4), label53);
*/
/***** END OF NEW CODE  ******/
  hbuttonbox3 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox3);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "hbuttonbox3", hbuttonbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox3);
  gtk_box_pack_start (GTK_BOX (vbox19), hbuttonbox3, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox3), GTK_BUTTONBOX_EDGE);

  script_widgets->auto_save_button = gtk_button_new_with_label ("Run");
  gtk_widget_ref (script_widgets->auto_save_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->auto_save_button", script_widgets->auto_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->auto_save_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), script_widgets->auto_save_button);
  GTK_WIDGET_SET_FLAGS (script_widgets->auto_save_button, GTK_CAN_DEFAULT);

  auto_save_run_button = gtk_button_new_with_label ("Save/Run");
  gtk_widget_ref (auto_save_run_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "auto_save_run_button", auto_save_run_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (auto_save_run_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), auto_save_run_button);
  GTK_WIDGET_SET_FLAGS (auto_save_run_button, GTK_CAN_DEFAULT);

  auto_okay_button = gtk_button_new_with_label ("OK");
  gtk_widget_ref (auto_okay_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "auto_okay_button", auto_okay_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (auto_okay_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), auto_okay_button);
  GTK_WIDGET_SET_FLAGS (auto_okay_button, GTK_CAN_DEFAULT);

  script_widgets->auto_cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (script_widgets->auto_cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (script_widgets->script_page), "script_widgets->auto_cancel_button", script_widgets->auto_cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (script_widgets->auto_cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), script_widgets->auto_cancel_button);
  GTK_WIDGET_SET_FLAGS (script_widgets->auto_cancel_button, GTK_CAN_DEFAULT);

  reload->list = script_widgets->data_clist;
  reload->reload_button = reload_script_button;
  reload->deactivate_button = delete_script_button;

  gtk_signal_connect (GTK_OBJECT (script_widgets->browse_script_button), "clicked",
                      GTK_SIGNAL_FUNC (on_browse_script_button_clicked),
                      script_widgets);

  gtk_signal_connect (GTK_OBJECT (script_widgets->browse_script_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_browse_target_button_clicked),
                      script_widgets);

  gtk_signal_connect (GTK_OBJECT (script_widgets->auto_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_auto_save_button_clicked),
                      script_widgets);

  gtk_signal_connect (GTK_OBJECT (script_widgets->auto_save_button), "clicked",
                      GTK_SIGNAL_FUNC (start_script_page),
                      script_widgets);

  gtk_signal_connect (GTK_OBJECT (delete_profile_button), "clicked",
		      GTK_SIGNAL_FUNC (delete_profile),
		      script_page_combo);

  gtk_signal_connect (GTK_OBJECT (auto_save_run_button), "clicked",
		      GTK_SIGNAL_FUNC (on_auto_save_button_clicked),
		      script_widgets);

  gtk_signal_connect (GTK_OBJECT (auto_save_run_button), "clicked",
		      GTK_SIGNAL_FUNC (show_profile_save_dialog),
		      script_widgets);
/*
  gtk_signal_connect (GTK_OBJECT (auto_save_run_button), "clicked",
                      GTK_SIGNAL_FUNC (start_script_page),
                      script_widgets);
*/
  gtk_signal_connect (GTK_OBJECT (script_widgets->auto_cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_auto_cancel_button_clicked),
                      script_widgets);

  gtk_signal_connect (GTK_OBJECT (auto_okay_button), "clicked",
                      GTK_SIGNAL_FUNC (on_auto_cancel_button_clicked),
                      script_widgets);

  gtk_signal_connect (GTK_OBJECT (reload_script_button), "clicked",
                      GTK_SIGNAL_FUNC (reload_previous_script),
                      reload);

  gtk_signal_connect (GTK_OBJECT (script_widgets->manual_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_show_minutes_toggled),
                      manual_data);

  gtk_signal_connect (GTK_OBJECT (script_widgets->once_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_hide_minutes_toggled),
                      manual_data);

  gtk_signal_connect (GTK_OBJECT (script_widgets->hourly_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_hide_minutes_toggled),
                      manual_data);

  gtk_signal_connect (GTK_OBJECT (script_widgets->daily_radio), "toggled",
                      GTK_SIGNAL_FUNC (on_hide_minutes_toggled),
                      manual_data);

  gtk_signal_connect (GTK_OBJECT (delete_script_button), "clicked",
                      GTK_SIGNAL_FUNC (deactivate_script),
                      reload);

  gtk_signal_connect (GTK_OBJECT (view_script_button), "clicked",
                      GTK_SIGNAL_FUNC (view_script),
                      reload);

  return script_widgets->script_page;
}

void load_script_list(gpointer clist1)
{
    extern script_text *active_script_data;    

    FILE  *fp;
    gchar *list_data[3];    
    gint  script_running;
    gint  x;
    gint  i;
    gchar *receiver_list_data[RECEIVER_FIELDS];
    gchar *receiver_line;
    gchar *line, *t_uid, *t_name;
    gchar *resource_field;

    script_running = get_status_script_page();
    list_data[2] = g_strdup(" ");

    list_data[0] = g_strdup("Date ");
    if ( script_running )
	list_data[1] =  g_strdup_printf("%s/%s/%s", active_script_data->month, active_script_data->date, active_script_data->year);
    else
	list_data[1] =  g_strdup("none");

    gtk_clist_append( (GtkCList *)clist1, list_data);

    for (x = 0; x < 2; x++)
	g_free(list_data[x]);



      list_data[0] = g_strdup("Time ");
      if ( script_running )
	  list_data[1] =  g_strdup_printf("%s:%s %s", active_script_data->hour_spin, active_script_data->minute_spin, active_script_data->am_pm_radio);
      else
	  list_data[1] =  g_strdup("none");
      
      gtk_clist_append( (GtkCList *)clist1, list_data);
      
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);



      list_data[0] = g_strdup("Frequency:");
      if ( script_running )
      {
	  if ( (resource_field = get_resource_data("CONFIG.dat", "polling_interval", MAX_FIELD_LENGTH)) )
	  {
	      if ( !strcmp(active_script_data->manual_time, "-1") )
		  list_data[1] =  g_strdup("Once");
	      else if ( !strcmp(active_script_data->manual_time, "60") )
		  list_data[1] =  g_strdup("Hourly");
	      else if ( !strcmp(active_script_data->manual_time, "1440") )
		  list_data[1] =  g_strdup("Daily");
	      else if ( !strcmp(active_script_data->manual_time, "0") )
		  list_data[1] =  g_strdup_printf("%s second intervals", resource_field);
	      else
		  list_data[1] =  g_strdup_printf("Every %s minutes", active_script_data->manual_time);

	      g_free(resource_field);
	  }
	  else
	  {
	      update_status_line("Error: corrupt file: CONFIG.dat"); 
	      list_data[1] =  g_strdup("Once");
	  }
      }
      else
	  list_data[1] =  g_strdup("none");
            
      gtk_clist_append( (GtkCList *)clist1, list_data);
    
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);



      list_data[0] = g_strdup("Script to execute:");
      if ( script_running )
      {
	  if ( !strcmp(active_script_data->script_entry, "null") )
	     list_data[1] =  g_strdup("No script has been defined");
	  else
	      list_data[1] =  g_strdup(active_script_data->script_entry);
      }
      else
	  list_data[1] =  g_strdup("none");

      gtk_clist_append( (GtkCList *)clist1, list_data);
    
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);



      list_data[0] = g_strdup("File to send:");
      if ( script_running )
	  list_data[1] = g_strdup(active_script_data->target_entry);
      else
	  list_data[1] = g_strdup("none");
      
      gtk_clist_append( (GtkCList *)clist1, list_data);
    
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);




      list_data[0] = g_strdup("File options:");
      if ( script_running )
	  list_data[1] = g_strdup(active_script_data->rename_delete_ignore);
      else
	  list_data[1] = g_strdup("none");
      
      gtk_clist_append( (GtkCList *)clist1, list_data);
    
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);




      list_data[0] = g_strdup("Parse options");
      if ( script_running )
      {
	  if ( !strcmp(active_script_data->all_or_parse, "send_all") )	  
	      list_data[1] =  g_strdup("Send entire file");
	  else
	    list_data[1] = g_strdup(active_script_data->all_or_parse);  
      }
      else
	  list_data[1] = g_strdup("none");

      gtk_clist_append( (GtkCList *)clist1, list_data);
    
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);




      list_data[0] = g_strdup("Field 1:");
      if ( script_running )
	  list_data[1] = g_strdup_printf("%s - %s", active_script_data->one_start, active_script_data->one_end);
      else
	  list_data[1] = g_strdup("none ");
      
      gtk_clist_append( (GtkCList *)clist1, list_data);
      
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);





      list_data[0] = g_strdup("Field 2:");
      if ( script_running )
	  list_data[1] = g_strdup_printf("%s - %s", active_script_data->two_start, active_script_data->two_end);
      else
	  list_data[1] = g_strdup("none ");

      gtk_clist_append( (GtkCList *)clist1, list_data);
      
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);




      list_data[0] = g_strdup("Field 3:");
      if ( script_running )
	  list_data[1] = g_strdup_printf("%s - %s", active_script_data->three_start, active_script_data->three_end);
      else
	  list_data[1] = g_strdup("none");

      gtk_clist_append( (GtkCList *)clist1, list_data);
      
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);




      list_data[0] = g_strdup("Field 4:");
      if ( script_running )
	  list_data[1] = g_strdup_printf("%s - %s", active_script_data->four_start, active_script_data->four_end);
      else
	  list_data[1] = g_strdup("none");
      
      gtk_clist_append( (GtkCList *)clist1, list_data);
      
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);



      list_data[0] = g_strdup("Send to:");
      if ( script_running )
      {
	  if ( !strcmp(active_script_data->manual_user, "manual") )
	      list_data[1] = g_strdup("Manual");
	  else
	  {
	      if ( active_script_data->send_to[0] == 'G' )
	      {
		  if ( (fp = get_file_pointer("GROUP.dat", "r")) == NULL)
		      return;
		  t_uid = g_malloc(MAX_FIELD_LENGTH);
		  t_name = g_malloc(MAX_FIELD_LENGTH);
		  while ( ( line = read_file_by_line(fp)) != NULL)
		  {
		      get_name_id(t_uid, t_name, line);
		      if ( !strcmp(active_script_data->send_to, t_uid) )
		      {
			  list_data[1] = g_strdup(t_name);
			  g_free(line);
			  break;
		      }
		      g_free(line);
		  }
		  g_free(t_uid);
		  g_free(t_name);
		  fclose(fp);
	      }
	      else
	      {
		  receiver_line = get_uid_line("RECEIVER.dat", active_script_data->send_to, RECEIVER_FIELDS, 0, MAX_LENGTH);     
		  for(i = 0; i < RECEIVER_FIELDS; i++)
		      receiver_list_data[i] = g_malloc(MAX_LENGTH);
		  get_fields_from_string(receiver_list_data, receiver_line, RECEIVER_FIELDS, ',');      
		  list_data[1] =  g_strdup(receiver_list_data[REC_NAME]);
		  for(i = 0; i < RECEIVER_FIELDS; i++)
		      g_free(receiver_list_data[i]);
		  g_free(receiver_line);
	      }
	  }
      }
      else
	  list_data[1] = g_strdup("None");

      gtk_clist_append( (GtkCList *)clist1, list_data);
      
      for (x = 0; x < 2; x++)
	  g_free(list_data[x]);

      g_free(list_data[2]);
}


static void load_auto_page_profiles(GtkWidget *script_page_combo)
{
    GList          *list = NULL;
    GList          *temp_list = NULL;
    struct dirent  *dirp;
    DIR            *dp;
    gchar          *path;
    gchar          *temp;
    
    temp_list = list;
    path = g_strdup_printf("%s/.gpage/profiles", getenv("HOME"));
    
    if ( (dp = opendir(path)) == NULL )
    {
	perror("Error opening profiles directory");
	return;
    }
    else
    {
	while ( (dirp = readdir(dp)) != NULL )
	{
	    if (!strcmp(dirp->d_name, ".") || !strcmp(dirp->d_name, "..") )
		continue;

	    temp = g_strdup(dirp->d_name);
	    list = g_list_append(list, (gpointer)temp);
	}
    }

    g_free(path);
    closedir(dp);
    gtk_combo_set_popdown_strings(GTK_COMBO(script_page_combo), list);

    while(temp_list)
    {
	g_free(temp_list->data);
	temp_list = g_list_next(temp_list);
    }
    return;
}

static void delete_profile(GtkWidget *w, GtkWidget *combo_box)
{
    GtkWidget  *confirm_delete_dialog;

    confirm_delete_dialog = profile_confirm_delete(combo_box);
    gtk_widget_show(confirm_delete_dialog);
}

void unlink_profile(GtkWidget *w, GtkWidget *combo_box)
{
    gchar   *string;
    gchar   *path, *full_path;

    string = g_strdup( gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_box)->entry)) );
    path = g_strdup_printf("%s/.gpage/profiles", getenv("HOME"));

    full_path = g_strdup_printf("%s/%s",path,string);

    if ( unlink(full_path) == -1 )
	perror("Error deleting profile: ");

    g_free(string);
    g_free(path);
    g_free(full_path);

    load_auto_page_profiles(combo_box);

}
