/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"

typedef struct {
    gchar *name;
    gchar *message;
    gint  error;
} manual_page_data;

typedef struct auto_object {    
    gint       reg_number;
    gint       select_receiver_method;
    gint       file_exists;
    gint       create_error_file;
    GSList     *list_of_files;
    GSList     *list_of_raw_data;
    gchar      *message;
    gchar      *name;
    gchar      *file_cleanup_method;
} active_data;

enum {
    HAVE_SCRIPT,
    NO_SCRIPT,
    GO,
    WAIT
};

enum {
    MANUAL,
    FROM_LIST,
};

static gchar *new_get_id_from_group_name(gchar *name);
static void new_process_target_file(gchar *file_name, active_data *data_object);
static gchar *new_parse_buffer(gchar  *buffer);
static void new_handle_page(active_data *page_data);
static void new_free_the_memory(gchar *four, gchar *five, manual_page_data *data);
static gint new_send_now(gint interval);
static void new_get_list_of_targets(gchar  *filename, active_data *data);
static void new_delete_target_files(GSList *targets);
static void new_rename_target_files(GSList *targets);
static void new_read_and_load_data_from_file(GSList *targets, active_data *data);
static void new_my_sleep(gint length);
static gint new_get_delay();
static gint new_get_interval(gchar *manual_time_string);
static gint new_get_retries();
static gint new_get_mode(gchar *user_defined_script);
static void new_handle_file_cleanup(gchar *action, GSList *targets);
manual_page_data *new_parse_data_for_manual_page(gchar *raw_data);
static gchar *new_get_id_from_receiver_name(gchar *name);
static gchar *new_get_id_from_group_name(gchar *name);








/*
 *   If we found a file(s) we call this function. Here we simply
 *   open the file(s) we found and read the data, storing it into
 *   linked list of strings containing the data. We return the linked list
 */











