/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"
#include "red_button.xpm"
#include "green_button.xpm"
#include "icon_plus.xpm"
#include "icon_delete.xpm"
#include "icon_close.xpm"
#include "icon_edit.xpm"
#include "icon_activate.xpm"
#include "icon_deactivate.xpm"

void sendCallback (GtkWidget *w, GdkDragContext *context, GtkSelectionData *selection, guint info, guint time);
void receiveCallback (GtkWidget *w, GdkDragContext *context, gint x, gint y, GtkSelectionData *selection, guint info, guint time);
void dndDragBeginCallback(GtkWidget *w, GdkDragContext *context, gpointer user_data);

void show_response_window()
{
    GtkWidget  *window;

    window = create_response_windows();
    gtk_widget_show(window);

}



GtkWidget *create_response_windows (void)
{
  GtkWidget *entry1;
  GtkWidget *entry2;
  GtkWidget *entry3;

  GtkWidget *label_one;
  GtkWidget *label_two;
  GtkWidget *label_three;
  GtkWidget *response_windows;
  GtkWidget *vbox_main;
  GtkWidget *hbox_status;
  GtkWidget *table1;
  GtkWidget *entry4;
  GtkWidget *entry5;
  GtkWidget *checkbutton5;
  GtkWidget *checkbutton4;
  GtkWidget *scrolledwindow2;
  GtkWidget *selection_clist;
  GtkWidget *label3;
  GtkWidget *label4;

  GtkWidget *close_button;
  GtkWidget *apply_button;
  GtkWidget *deactivate_button;
  GtkWidget *edit_button;
  GtkWidget *add_button;
  GtkWidget *delete_button;
  GtkWidget *status_label;
  static GtkTargetEntry target = { "text/plain",0,0 };

  response_info  *two_way_stuff;
  GdkPixmap      *red, *green;  
  GdkBitmap      *mask, *mask1;
  GdkColormap    *colormap;
  GtkWidget      *red_pix, *green_pix;
  GtkWidget      *bar;
  GtkWidget      *handle;

  GdkPixmap      *icon_plus;
  GtkWidget      *add_pix;
  GdkPixmap      *icon_delete;
  GtkWidget      *delete_pix;  
  GdkPixmap      *icon_close;
  GtkWidget      *close_pix;  
  GdkPixmap      *icon_edit;
  GtkWidget      *edit_pix;  
  GdkPixmap      *icon_activate;
  GtkWidget      *activate_pix;  
  GdkPixmap      *icon_deactivate;
  GtkWidget      *deactivate_pix;  
  GdkBitmap      *imask;
  //GtkWidget      *mcr_status;

  two_way_stuff = g_malloc(sizeof(*two_way_stuff));

  response_windows = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (response_windows), "response_windows", response_windows);
  gtk_container_set_border_width (GTK_CONTAINER (response_windows), 1);
  gtk_window_set_title (GTK_WINDOW (response_windows), "2 Way Message Response Options");

  gtk_widget_set_usize (response_windows, 550, 250); 

  vbox_main = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_main);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "vbox_main", vbox_main,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_main);
  gtk_container_add (GTK_CONTAINER (response_windows), vbox_main);

  handle = gtk_handle_box_new();
  gtk_handle_box_set_shadow_type((GtkHandleBox *)(handle), GTK_SHADOW_ETCHED_OUT);
  gtk_widget_show(handle);

/***************************************************/

  bar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_toolbar_set_button_relief(GTK_TOOLBAR(bar), GTK_RELIEF_NONE);
  gtk_toolbar_set_space_size(GTK_TOOLBAR(bar), 1);
  gtk_toolbar_set_space_style(GTK_TOOLBAR(bar), GTK_TOOLBAR_SPACE_LINE);
  gtk_widget_realize(response_windows);

  icon_activate = gdk_pixmap_create_from_xpm_d ( response_windows->window, &imask,
					&response_windows->style->white, icon_activate_xpm );

  activate_pix = gtk_pixmap_new(icon_activate, imask);

  apply_button = gtk_toolbar_append_element (GTK_TOOLBAR (bar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Activate",
                                NULL, NULL,
                                activate_pix, NULL, NULL);

  gtk_widget_ref (apply_button);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "apply_button", apply_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (apply_button);

  icon_deactivate = gdk_pixmap_create_from_xpm_d ( response_windows->window, &imask,
					&response_windows->style->white, icon_deactivate_xpm );

  deactivate_pix = gtk_pixmap_new(icon_deactivate, imask);

  deactivate_button = gtk_toolbar_append_element (GTK_TOOLBAR (bar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Deactivate",
                                NULL, NULL,
                                deactivate_pix, NULL, NULL);
  gtk_widget_ref (deactivate_button);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "deactivate_button", deactivate_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (deactivate_button);

  gtk_toolbar_append_space((GtkToolbar *)bar);



  icon_plus = gdk_pixmap_create_from_xpm_d ( response_windows->window, &imask,
					&response_windows->style->white, icon_plus_xpm );

  add_pix = gtk_pixmap_new(icon_plus, imask);
  add_button = gtk_toolbar_append_element (GTK_TOOLBAR (bar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Add",
                                NULL, NULL,
                                add_pix, NULL, NULL);
  gtk_widget_ref (add_button);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "add_button", add_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_button);

  icon_edit = gdk_pixmap_create_from_xpm_d ( response_windows->window, &imask,
					&response_windows->style->white, icon_edit_xpm );

  edit_pix = gtk_pixmap_new(icon_edit, imask);

  edit_button = gtk_toolbar_append_element (GTK_TOOLBAR (bar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Edit",
                                NULL, NULL,
                                edit_pix, NULL, NULL);
  gtk_widget_ref (edit_button);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "edit_button", edit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_button);

  icon_delete = gdk_pixmap_create_from_xpm_d ( response_windows->window, &imask,
					&response_windows->style->white, icon_delete_xpm );

  delete_pix = gtk_pixmap_new(icon_delete, imask);

  delete_button = gtk_toolbar_append_element (GTK_TOOLBAR (bar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Delete",
                                NULL, NULL,
                                delete_pix, NULL, NULL);
  gtk_widget_ref (delete_button);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "delete_button", delete_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_button);

  icon_close = gdk_pixmap_create_from_xpm_d ( response_windows->window, &imask,
					&response_windows->style->white, icon_close_xpm );

  close_pix = gtk_pixmap_new(icon_close, imask);

  close_button = gtk_toolbar_append_element (GTK_TOOLBAR (bar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Close",
                                NULL, NULL,
                                close_pix, NULL, NULL);
  gtk_widget_ref (close_button);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "close_button", close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_button);

  gtk_toolbar_append_space((GtkToolbar *)bar);
/**** here is the status stuff ***/

  hbox_status = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox_status);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "hbox_status", hbox_status,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_status);

  status_label = gtk_label_new (" Activation Status: ");
  gtk_widget_ref (status_label);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "status_label", status_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_label);
  gtk_box_pack_start (GTK_BOX (hbox_status), status_label, FALSE, TRUE, 0);

  colormap = gtk_widget_get_colormap(GTK_WIDGET(response_windows));
  gtk_widget_realize ( response_windows );

  red = gdk_pixmap_create_from_xpm_d ( response_windows->window, &mask,
						&response_windows->style->white, red_button_xpm );
  red_pix = gtk_pixmap_new(red, mask);
  gtk_widget_show(red_pix);

  gtk_box_pack_start (GTK_BOX (hbox_status), red_pix, FALSE, TRUE, 5);


  green = gdk_pixmap_create_from_xpm_d ( response_windows->window, &mask1,
						&response_windows->style->white, green_button_xpm );
  green_pix = gtk_pixmap_new(green, mask1);
  gtk_box_pack_start (GTK_BOX (hbox_status), green_pix, FALSE, TRUE, 5);



  gtk_toolbar_append_widget (GTK_TOOLBAR (bar),
                                GTK_WIDGET(hbox_status),
                                NULL,
                                NULL);

/***************************************************/


  gtk_widget_ref (response_windows);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "bar", bar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bar);
  gtk_container_add(GTK_CONTAINER(handle), bar);
  gtk_box_pack_start (GTK_BOX (vbox_main), handle, FALSE, FALSE, 0);


  table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox_main), table1, FALSE, TRUE, 0);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_table_attach (GTK_TABLE (table1), entry1, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry2 = gtk_entry_new ();
  gtk_widget_ref (entry2);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "entry2", entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry2);
  gtk_table_attach (GTK_TABLE (table1), entry2, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry3 = gtk_entry_new ();
  gtk_widget_ref (entry3);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "entry3", entry3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry3);
  gtk_table_attach (GTK_TABLE (table1), entry3, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry4 = gtk_entry_new ();
  gtk_widget_ref (entry4);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "entry4", entry4,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (entry4);
  gtk_table_attach (GTK_TABLE (table1), entry4, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry5 = gtk_entry_new ();
  gtk_widget_ref (entry5);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "entry5", entry5,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (entry5);
  gtk_table_attach (GTK_TABLE (table1), entry5, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label_one = gtk_label_new(" One ");
  gtk_widget_show(label_one);
  /*
  checkbutton1 = gtk_check_button_new_with_label (" One ");
  gtk_widget_ref (checkbutton1);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "checkbutton1", checkbutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton1);
  */
  gtk_table_attach (GTK_TABLE (table1), label_one, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_two = gtk_label_new(" Two ");
  gtk_widget_show(label_two);
/*
  checkbutton2 = gtk_check_button_new_with_label (" Two ");
  gtk_widget_ref (checkbutton2);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "checkbutton2", checkbutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton2);
*/
  gtk_table_attach (GTK_TABLE (table1), label_two, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_three = gtk_label_new(" Three ");
  gtk_widget_show(label_three);
/*
  checkbutton3 = gtk_check_button_new_with_label ("Three");
  gtk_widget_ref (checkbutton3);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "checkbutton3", checkbutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton3);
*/
  gtk_table_attach (GTK_TABLE (table1), label_three, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  checkbutton5 = gtk_check_button_new_with_label (" Five");
  gtk_widget_ref (checkbutton5);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "checkbutton5", checkbutton5,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (checkbutton5);
  gtk_table_attach (GTK_TABLE (table1), checkbutton5, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  checkbutton4 = gtk_check_button_new_with_label (" Four");
  gtk_widget_ref (checkbutton4);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "checkbutton4", checkbutton4,
                            (GtkDestroyNotify) gtk_widget_unref);
  // gtk_widget_show (checkbutton4);
  gtk_table_attach (GTK_TABLE (table1), checkbutton4, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox_main), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  selection_clist = gtk_clist_new (2);
  gtk_clist_set_column_visibility (GTK_CLIST(selection_clist), 0, FALSE);
  gtk_widget_ref (selection_clist);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "selection_clist", selection_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (selection_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), selection_clist);
  gtk_container_set_border_width (GTK_CONTAINER (selection_clist), 1);
  gtk_clist_set_column_width (GTK_CLIST (selection_clist), 0, 10);
  gtk_clist_set_column_width (GTK_CLIST (selection_clist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (selection_clist));

  load_pre_def_list(selection_clist, "TWO_WAY_RESPONSE.dat");

  label3 = gtk_label_new ("label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  //gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (selection_clist), 0, label3);

  label4 = gtk_label_new ("Drag n Drop Selection");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (response_windows), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_clist_set_column_widget (GTK_CLIST (selection_clist), 1, label4);


  two_way_stuff->list = selection_clist;
  two_way_stuff->entry1 = entry1;
  two_way_stuff->entry2 = entry2;
  two_way_stuff->entry3 = entry3;
  two_way_stuff->red_button = red_pix;
  two_way_stuff->green_button = green_pix;
  two_way_stuff->edit_flag = 0;
  two_way_stuff->main_win = response_windows;


  gtk_signal_connect (GTK_OBJECT (close_button), "clicked",
                      GTK_SIGNAL_FUNC (on_two_way_close_button_clicked),
                      two_way_stuff);

  gtk_signal_connect (GTK_OBJECT (edit_button), "clicked",
                      GTK_SIGNAL_FUNC (on_two_way_edit_button_clicked),
                      two_way_stuff );

  gtk_signal_connect (GTK_OBJECT (add_button), "clicked",
                      GTK_SIGNAL_FUNC (on_two_way_add_button_clicked),
                      two_way_stuff );

  gtk_signal_connect (GTK_OBJECT (delete_button), "clicked",
                      GTK_SIGNAL_FUNC (on_two_way_delete_button_clicked),
                      GTK_OBJECT(selection_clist));

  gtk_signal_connect (GTK_OBJECT (apply_button), "clicked",
                      GTK_SIGNAL_FUNC (on_two_way_apply_button_clicked),
                      two_way_stuff);

  gtk_signal_connect (GTK_OBJECT (deactivate_button), "clicked",
                      GTK_SIGNAL_FUNC (on_two_way_deactivate_button_clicked),
                      two_way_stuff);

  gtk_signal_connect (GTK_OBJECT(selection_clist), "drag_begin", 
		      GTK_SIGNAL_FUNC(dndDragBeginCallback), NULL);


  gtk_signal_connect (GTK_OBJECT(selection_clist), "drag_data_get", 
		      GTK_SIGNAL_FUNC(sendCallback), NULL);

  gtk_drag_source_set (selection_clist, GDK_BUTTON1_MASK, &target, 
		       1, GDK_ACTION_COPY);

  gtk_signal_connect (GTK_OBJECT (entry1), "drag_data_received",
                      GTK_SIGNAL_FUNC (receiveCallback),
                      NULL);

  gtk_drag_dest_set(entry1, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT | 
		    GTK_DEST_DEFAULT_DROP, &target, 1, GDK_ACTION_COPY);
  

  gtk_signal_connect (GTK_OBJECT (entry2), "drag_data_received",
                      GTK_SIGNAL_FUNC (receiveCallback),
                      NULL);

  gtk_drag_dest_set(entry2, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT | 
		    GTK_DEST_DEFAULT_DROP, &target, 1, GDK_ACTION_COPY);

  gtk_signal_connect (GTK_OBJECT (entry3), "drag_data_received",
                      GTK_SIGNAL_FUNC (receiveCallback),
                      NULL);

  gtk_drag_dest_set(entry3, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT | 
		    GTK_DEST_DEFAULT_DROP, &target, 1, GDK_ACTION_COPY);

  return response_windows;
}

void dndDragBeginCallback(GtkWidget *w, GdkDragContext *context, gpointer user_data)
{
    gint row, column, x, y;

    row = column = x = y = 0;

    gtk_clist_get_selection_info(GTK_CLIST(w), x, y, &row, &column);
    
}


void receiveCallback (GtkWidget *w, GdkDragContext *context, gint x, gint y, GtkSelectionData *selection, guint info, guint time)
{
    gtk_entry_set_text(GTK_ENTRY(w), selection->data);
}

void sendCallback (GtkWidget *w, GdkDragContext *context, GtkSelectionData *selection, guint info, guint time)
{
    gchar *data;

    if ( GTK_CLIST(w)->selection == NULL )
    {
	generic_error("\n You must select a row before dragging data from it \n", "G-Page Error");
	return;
    }
    gtk_clist_get_text( (GtkCList *)w, GPOINTER_TO_INT(GTK_CLIST(w)->selection->data), 1, &data);
    gtk_selection_data_set(selection, selection->target, 8, data, strlen(data));
    gtk_clist_unselect_all(GTK_CLIST(w));
}

void show_edit_box(response_info *user_data)
{
    GtkWidget  *edit_box;

    edit_box = create_edit_response_box(user_data);
    gtk_widget_show(edit_box);

}


GtkWidget *create_edit_response_box (response_info *user_data)
{
  GtkWidget *edit_response_box;
  GtkWidget *vbox5;
  GtkWidget *scrolledwindow3;
  GtkWidget *edit_text_box;
  GtkWidget *hbuttonbox3;
  GtkWidget *edit_cancel_button;
  GtkWidget *edit_save_button;
  GdkFont   *current_font;

  edit_response_box = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (edit_response_box), "edit_response_box", edit_response_box);
  gtk_window_set_title (GTK_WINDOW (edit_response_box), "Add / Create 2 Way Response");

  gtk_widget_set_usize (edit_response_box, 300, 150); 

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (edit_response_box), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (edit_response_box), vbox5);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (edit_response_box), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox5), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  edit_text_box = gtk_text_new (NULL, NULL);
  gtk_widget_ref (edit_text_box);
  gtk_object_set_data_full (GTK_OBJECT (edit_response_box), "edit_text_box", edit_text_box,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_text_box);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), edit_text_box);
  gtk_text_set_editable (GTK_TEXT (edit_text_box), TRUE);

  if ( user_data->edit_flag )
  {
      current_font = gdk_font_load(user_data->edit_string); 
      gtk_text_insert(GTK_TEXT(edit_text_box), current_font, NULL, NULL, user_data->edit_string, strlen(user_data->edit_string)); 
      g_free(user_data->edit_string);
      user_data->edit_flag = 0;
  }
      
      
  hbuttonbox3 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox3);
  gtk_object_set_data_full (GTK_OBJECT (edit_response_box), "hbuttonbox3", hbuttonbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox3);
  gtk_box_pack_start (GTK_BOX (vbox5), hbuttonbox3, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox3), GTK_BUTTONBOX_SPREAD);

  edit_cancel_button = gtk_button_new_with_label ("Done");
  gtk_widget_ref (edit_cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (edit_response_box), "edit_cancel_button", edit_cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_cancel_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), edit_cancel_button);
  gtk_container_set_border_width (GTK_CONTAINER (edit_cancel_button), 1);
  GTK_WIDGET_SET_FLAGS (edit_cancel_button, GTK_CAN_DEFAULT);

  edit_save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (edit_save_button);
  gtk_object_set_data_full (GTK_OBJECT (edit_response_box), "edit_save_button", edit_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_save_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox3), edit_save_button);
  gtk_container_set_border_width (GTK_CONTAINER (edit_save_button), 1);
  GTK_WIDGET_SET_FLAGS (edit_save_button, GTK_CAN_DEFAULT);

  user_data->box = edit_text_box;

  gtk_signal_connect (GTK_OBJECT (edit_text_box), "changed",
                      GTK_SIGNAL_FUNC (on_edit_text_box_changed),
                      user_data);

  gtk_signal_connect (GTK_OBJECT (edit_cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_edit_cancel_button_clicked),
                      GTK_OBJECT(edit_response_box));

  gtk_signal_connect (GTK_OBJECT (edit_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_edit_save_button_clicked),
                      (gpointer) user_data);

  return edit_response_box;
}

