/*
 * g-page Copyright (C) 2001 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */        

#include "constants.h"
#include "callbacks.h"
GtkWidget *log_clist;

void show_log_window(char *name, gint options)
{
    GtkWidget  *log_view;
    extern GtkWidget  *log_clist;

    log_view = create_log_window(name, options);
    load_log_list(log_clist, name, options);
    gtk_widget_show(log_view);
}


GtkWidget*
create_log_window (char *name, gint options)
{
  GtkWidget *log_window;
  GtkWidget *vbox19;
  GtkWidget *hbox17;
  GtkWidget *label45;
  GtkWidget *hbuttonbox12;
  GtkWidget *button1;
  GtkWidget *scrolledwindow13;
  GtkWidget *status_label;
  GtkWidget *via_label;
  GtkWidget *date_label;
  GtkWidget *message_label;
  GtkWidget *label44;
  GtkWidget *statusbar2;
  gchar     *name_label;
  log_status_bar_data *status_bar_data;

  GtkWidget *scrolledwindow2;
  GtkWidget *text1;


  status_bar_data = g_malloc(sizeof(*status_bar_data));
  status_bar_data->s_options = options;

  name_label = g_malloc(MAX_FIELD_LENGTH + 32);
  g_snprintf(name_label, MAX_FIELD_LENGTH + 32, " Messages for: %s", name);

  log_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  status_bar_data->main_window = log_window; 
  gtk_object_set_data (GTK_OBJECT (log_window), "log_window", log_window);
  gtk_window_set_title (GTK_WINDOW (log_window), "Log");
  gtk_window_set_modal (GTK_WINDOW (log_window), TRUE);
  gtk_widget_set_usize (log_window, 660, 350);

  vbox19 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox19);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "vbox19", vbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox19);
  gtk_container_add (GTK_CONTAINER (log_window), vbox19);

  hbox17 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox17);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "hbox17", hbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox17);
  gtk_box_pack_start (GTK_BOX (vbox19), hbox17, FALSE, FALSE, 0);

  label45 = gtk_label_new (name_label);
  g_free(name_label);
  gtk_widget_ref (label45);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "label45", label45,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (hbox17), label45, FALSE, FALSE, 0);

  hbuttonbox12 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox12);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "hbuttonbox12", hbuttonbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox12);
  gtk_box_pack_start (GTK_BOX (hbox17), hbuttonbox12, TRUE, TRUE, 0);

  button1 = gtk_button_new_with_label ("Close");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox12), button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  scrolledwindow13 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow13);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "scrolledwindow13", scrolledwindow13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow13);
  gtk_box_pack_start (GTK_BOX (vbox19), scrolledwindow13, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow13), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  log_clist = gtk_clist_new (6);

  gtk_clist_set_selection_mode(GTK_CLIST(log_clist), GTK_SELECTION_BROWSE); 
  gtk_widget_ref (log_clist);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "log_clist", log_clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (log_clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow13), log_clist);
  if ( options == NAME )
  {
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 0, 61);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 1, 56);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 2, 145);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 3, 350);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 4, 1);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 5, 10);
      gtk_clist_set_column_visibility (GTK_CLIST(log_clist), 4, FALSE);
      gtk_clist_set_column_visibility (GTK_CLIST(log_clist), 5, FALSE);
      gtk_clist_column_titles_show (GTK_CLIST (log_clist));
  }
  else
  {
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 0, 55);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 1, 50);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 2, 100);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 3, 140);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 4, 250);
      gtk_clist_set_column_width (GTK_CLIST (log_clist), 5, 10);
      gtk_clist_set_column_visibility (GTK_CLIST(log_clist), 5, FALSE);
      gtk_clist_column_titles_show (GTK_CLIST (log_clist));
  }      

  status_label = gtk_label_new ("Status");
  gtk_widget_ref (status_label);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "status_label", status_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_label);
  gtk_clist_set_column_widget (GTK_CLIST (log_clist), 0, status_label);

  via_label = gtk_label_new ("Via");
  gtk_widget_ref (via_label);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "via_label", via_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (via_label);
  gtk_clist_set_column_widget (GTK_CLIST (log_clist), 1, via_label);

  date_label = gtk_label_new ("Date");
  gtk_widget_ref (date_label);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "date_label", date_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (date_label);
  gtk_clist_set_column_widget (GTK_CLIST (log_clist), 2, date_label);

  if ( options == NAME )
      message_label = gtk_label_new ("Message prewview:");
  else
      message_label = gtk_label_new ("Sent to:");
  gtk_widget_ref (message_label);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "message_label", message_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_label);
  gtk_clist_set_column_widget (GTK_CLIST (log_clist), 3, message_label);

  if ( options == NAME )
      label44 = gtk_label_new ("");
  else
      label44 = gtk_label_new ("Message preview:");
  gtk_widget_ref (label44);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "label44", label44,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label44);
  gtk_clist_set_column_widget (GTK_CLIST (log_clist), 4, label44);

  statusbar2 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar2);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "statusbar2", statusbar2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar2);
  gtk_box_pack_start (GTK_BOX (vbox19), statusbar2, FALSE, FALSE, 0);

  status_bar_data->st_bar = statusbar2;

/*****************************/

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox19), scrolledwindow2, FALSE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow2, 580, 50);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (log_window), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), text1);

  status_bar_data->text_box = text1;

/************************************/

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_close_button_clicked),
                      status_bar_data);


  gtk_signal_connect( GTK_OBJECT(log_clist), "select_row",
                      GTK_SIGNAL_FUNC(select_row_callback_log), status_bar_data);
  if ( options == NAME )
  {
      gtk_signal_connect( GTK_OBJECT(log_clist), "button_press_event",
			  GTK_SIGNAL_FUNC(select_row_popup), status_bar_data);

      gtk_signal_connect (GTK_OBJECT (log_clist), "click_column",
			  GTK_SIGNAL_FUNC (on_click_column_log_name),
			  name);

  }
  else
  {
      gtk_signal_connect( GTK_OBJECT(log_clist), "button_press_event",
			  GTK_SIGNAL_FUNC(select_row_popup_date), status_bar_data);

      gtk_signal_connect (GTK_OBJECT (log_clist), "click_column",
			  GTK_SIGNAL_FUNC (on_click_column_log),
			  name);
  }

  gtk_widget_grab_focus (button1);
  return log_window;
}



