/*
 * g-page (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */   

#include "my_header.h"
#include "data_structures.h"
#include "function_def.h"

#define NUMBER_OF_ARGUMENTS 5

static void clean_string(char *buffer);

void telnet_page(int socket_fd, char *client_adr)
{

  char           *buf = "";
  int            amount;
  int            index;
  page_profile   *page_list = NULL;
  page_profile   *head = NULL;
  page_profile   *temp = NULL;
  email_data     *email_info = NULL;


  if ( ( email_info = malloc(sizeof(*email_info))) == NULL)
      error_quit("Error allcoating memory - email_info - server_utilities.c ");

  email_info->isp = get_memory(MAX_LENGTH, "auto_page - email_info_isp - auto_page");

  email_info->email_domain = get_memory(MAX_LENGTH, "auto_page email_info->email_domain -   auto_page");

  email_info->email_address = get_memory(MAX_LENGTH, "auto_page - email_info->email_address - auto_page");

  buf = get_memory(MAX_LENGTH, "auto_page - buf");

  page_list = get_page_list_memory(page_list);  
  head = get_page_list_memory(head);  
  head = page_list;

  memset(email_info->isp, '\0', sizeof(email_info->isp));
  memset(buf, '\0', sizeof(buf));

/*  Get the domain name of the isp  */

  write_num(socket_fd, "Enter ISP Domain name: ", sizeof("Enter ISP Domain name: "));
  if ( ( amount = read_a_line(socket_fd, email_info->isp, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
      return;
  clean_string(email_info->isp);

  memset(email_info->email_domain, '\0', sizeof(email_info->email_domain));
  memset(buf, '\0', sizeof(buf));

/* Get the email domain */
  write_num(socket_fd, "Enter email domain: ", sizeof("Enter email domain: "));
  if ( ( amount = read_a_line(socket_fd, email_info->email_domain, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
      return;
  clean_string(email_info->email_domain);

  memset(email_info->email_address, '\0', sizeof(email_info->email_address));
  memset(buf, '\0', sizeof(buf));

/* Get the email address */
  write_num(socket_fd, "Enter return email address: ", sizeof("Enter return email address: "));
  if ( ( amount = read_a_line(socket_fd, email_info->email_address, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
      return;
  clean_string(email_info->email_address);

  memset(buf, '\0', sizeof(buf));
  write_num(socket_fd, "Enter pager number: ", sizeof("Enter pager number: "));
  for(index = 0; index < NUMBER_OF_ARGUMENTS; index++)
  {
      memset(buf, '\0', MAX_LENGTH);
      if ( ( amount = read_a_line(socket_fd, buf, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
	  return;
        clean_string(buf);
      switch (index)
      {
      case 0:
	  strcpy(page_list->receiver_number, buf);
	  write_num(socket_fd, "Enter pager email address: ", sizeof("Enter pager email address: "));
	  break;
      case 1:
	  strcpy(page_list->smtp, buf);
	  write_num(socket_fd, "Enter snpp address: ", sizeof("Enter snpp address: "));
	  break;
      case 2:
	  strcpy(page_list->snpp_url, buf);
	  write_num(socket_fd, "Enter snpp port: ", sizeof("Enter snpp port: "));
	  break;
      case 3:
	  strcpy(page_list->snpp_port, buf);
	  write_num(socket_fd, "Enter message: ", sizeof("Enter message: "));
	  break;
      case 4:
	  strcpy(page_list->message, buf);
	  break;
      }
  }

  strcpy(page_list->user_id, "1\n");
  strcpy(page_list->wctp_url, "none\n");
  strcpy(page_list->snpp_password, "none\n");
  strcpy(page_list->max_msg_length, "80\n");
  strcpy(page_list->sig, "none\n");
  strcpy(page_list->receiver_name, "auto\n");
  strcpy(page_list->wctp_url,"none\n");
  strcpy(page_list->cc_email,"no\n");
  strcpy(page_list->protocols_order,"231\n");
  strcpy(page_list->protocols,"0110\n");
  strcpy(page_list->sched_data,"none\n");
  page_list->pwd_yes_no = 0;
  page_list->auto_split = 0;

  temp = get_page_list_memory(temp);
  temp->previous = page_list;
  page_list->next = temp;
  page_list = page_list->next;
  page_list->next = NULL;

  send_messages(head, socket_fd, email_info, SEND_NOW, client_adr);

  free_page_mem(page_list);
  free(email_info->email_address);
  free(email_info->email_domain);
  free(email_info->isp);
  free(email_info);
  close(socket_fd);
  return;
}

static void clean_string(char *buffer)
{
    if ( buffer[strlen(buffer) -1] == '\n' )
	buffer[strlen(buffer) -1] = '\0';
    if ( buffer[strlen(buffer) -1] == '\r' )
	buffer[strlen(buffer) -1] = '\n';
}

/*  This needs to be scrapped */
void auto_page(int socket_fd, char *client_adr)
{

  char           *buf = "";
  int            amount;
  int            index;
  page_profile   *page_list = NULL;
  page_profile   *head = NULL;
  page_profile   *temp = NULL;
  email_data     *email_info = NULL;


  if ( ( email_info = malloc(sizeof(*email_info))) == NULL)
      error_quit("Error allcoating memory - email_info - server_utilities.c ");

  email_info->isp = get_memory(MAX_LENGTH, "auto_page - email_info_isp - auto_page");

  email_info->email_domain = get_memory(MAX_LENGTH, "auto_page email_info->email_domain -   auto_page");

  email_info->email_address = get_memory(MAX_LENGTH, "auto_page - email_info->email_address - auto_page");

  buf = get_memory(MAX_LENGTH, "auto_page - buf");

  page_list = get_page_list_memory(page_list);  
  head = get_page_list_memory(head);  
  head = page_list;

  memset(email_info->isp, '\0', sizeof(email_info->isp));
  memset(buf, '\0', sizeof(buf));

/*  Get the domain name of the isp  */

  if ( ( amount = read_a_line(socket_fd, email_info->isp, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
      return;
  write_num(socket_fd, email_info->isp, amount);

  memset(email_info->email_domain, '\0', sizeof(email_info->email_domain));
  memset(buf, '\0', sizeof(buf));

/* Get the email domain */

  if ( ( amount = read_a_line(socket_fd, email_info->email_domain, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
      return;
  write_num(socket_fd, email_info->email_domain, amount);

  memset(email_info->email_address, '\0', sizeof(email_info->email_address));
  memset(buf, '\0', sizeof(buf));

/* Get the email address */

  if ( ( amount = read_a_line(socket_fd, email_info->email_address, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
      return;
  write_num(socket_fd, email_info->email_address, amount);

  memset(buf, '\0', sizeof(buf));

  for(index = 0; index < NUMBER_OF_ARGUMENTS; index++)
  {
      memset(buf, '\0', MAX_LENGTH);
      if ( ( amount = read_a_line(socket_fd, buf, MAX_LENGTH, MAX_TIMEOUT) ) <= 0) 
	  return;
      switch (index)
      {
      case 0:
	  strcpy(page_list->receiver_number, buf);
	  break;
      case 1:
	  strcpy(page_list->smtp, buf);
	  break;
      case 2:
	  strcpy(page_list->snpp_url, buf);
	  break;
      case 3:
	  strcpy(page_list->snpp_port, buf);
	  break;
      case 4:
	  strcpy(page_list->message, buf);
	  break;
      }
      /* print_debug_data(buf); */
      write_num(socket_fd, buf, strlen(buf));
  }

  strcpy(page_list->user_id, "1\n");
  strcpy(page_list->wctp_url, "none\n");
  strcpy(page_list->snpp_password, "none\n");
  strcpy(page_list->max_msg_length, "80\n");
  strcpy(page_list->sig, "none\n");
  strcpy(page_list->receiver_name, "auto\n");
  strcpy(page_list->cc_email, "no\n");
  strcpy(page_list->protocols_order, "0110A123\n");
  page_list->pwd_yes_no = 0;
  page_list->auto_split = 0;

  temp = get_page_list_memory(temp);
  temp->previous = page_list;
  page_list->next = temp;
  page_list = page_list->next;
  page_list->next = NULL;

  send_messages(head, socket_fd, email_info, SEND_NOW, client_adr);

  free_page_mem(page_list);
  free(email_info->email_address);
  free(email_info->email_domain);
  free(email_info->isp);
  free(email_info);
  close(socket_fd);
  return;
}
