/*
 * g-page (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */   

#include "my_header.h"
#include "data_structures.h"
#include "function_def.h"

int get_resource_data(char *filename, char *match_field, char *return_value)
{

    FILE    *fp;
    char    buffer[MAX_LENGTH];
    char    temp_string[MAX_LENGTH];
    int     i, x;

    if ( ( fp = fopen(filename, "r")) == NULL)
    {
	error_ret("Error opening gpage.conf");
	return 0;
    }
    while (1)
    {
	memset(buffer, '\0', sizeof(buffer));
	fgets(buffer, sizeof(buffer), fp);
	if ( feof(fp) )
	    return 0;
	memset(temp_string, '\0', sizeof(temp_string));
	i = 0;
	while (buffer[i] != '=')
	{
	    temp_string[i] = buffer[i];
	    i++;
	}
	i++;
	if ( !(strcmp(temp_string, match_field)) )
	{
	    x = 0;
	    memset(temp_string, '\0', sizeof(temp_string));
	    while( buffer[i] != '\n' )
		temp_string[x++] = buffer[i++];

	    strcpy(return_value, temp_string);
	    return 1;
	}
    }
}
    

char *get_id(int  function)
{
    char   *id;    
    char   tmp[MAX_LENGTH];
    char   ch;
    char   *home;
    char   *logfile = "/.gpage/SCH_ID.dat";
    FILE   *fp, *wfp;
    int    position, curr_id;
    int    index;
    int    path_length = 0;
    char   *temp_line;

    
    id = get_memory(MAX_LENGTH, "data_routines - id");

    path_length = strlen(getenv("HOME")) + strlen(logfile) + 10;
    
    home = get_memory(path_length, "data_routines - home");

    strcpy(home, getenv("HOME"));
    strcat(home, logfile);
        
    if ( (fp = fopen(home, "r")) == NULL)
        return("-1");

    if( (wfp = get_temp_file()) == NULL)
        return("-1");

    switch (function){
    case SCHEDULE:
        position = 0;
	break;
    default:
	return ("-1");
	break;
    }

    for (index = 0; index < position; index++)
    {
        while( (ch = fgetc(fp)) != '\n' )
            fputc(ch, wfp);
        fputc('\n', wfp);
    }
    ch = '\0';
    memset(tmp, '\0', sizeof(tmp));
    index = 0;
    while( (ch != '\n') && ch != ',')
    {
        ch = fgetc(fp);
        tmp[index++] = ch;
    }
    tmp[(strlen(tmp) - 1)] = '\0';
    if (ch == '\n')
    {
        fputs(tmp, wfp);
        fputc('\n', wfp);
        memset(tmp, '\0', sizeof(tmp));
        while ( (ch = fgetc(fp)) != ',' )
            fputc(ch, wfp);
        fputc(ch, wfp);
        index = 0;
        while ( (ch = fgetc(fp)) != '\n')
	    tmp[index++] = ch;
	strcpy(id, tmp);
	curr_id = atoi(tmp);
        memset(tmp, '\0', sizeof(tmp));
        sprintf(tmp, "%d\n", (curr_id + 1) );
        fputs(tmp, wfp);
    }
    else
	strcpy(id, tmp);

    while( (ch = fgetc(fp)) != EOF ) 
        fputc(ch, wfp);

    fclose(fp);
    rewind(wfp);

    temp_line = get_memory(MAX_LENGTH, "data_routines - temp_line");

    if ( ( fp = fopen(home, "w")) == NULL)
	return("-1");

    while(fgets(temp_line, MAX_LENGTH, wfp))
	fputs(temp_line, fp);
    fclose(wfp);
    fclose(fp);
    free(temp_line);

    free(home); 

    return (id);
}

FILE   *get_temp_file()
{
    FILE    *fp;

    fp = tmpfile();    
    return (fp);
}


char *get_memory(int size, char *function)
{
    char *str;
    static int total = 0;

    total += size;
    //fprintf(stderr, "Here's the memory toal: %d\n", total);
    if ( (str = malloc(size)) == NULL)
	error_quit("Error allcoating memory %s ", function);

    memset(str, '\0', size);
    /* fprintf(stderr, "Allocating: %s - %d\n", function, size); */
    return str;
}

void write_to_status_line(int sock, char *buffer, int amount, int opcode)
{
    char        *buff;
    int         new_size;

    if ( sock == -1 )
	return;
    new_size = (strlen(buffer) + 3);
    //fprintf(stderr, "NEW SIZE: %d\n", new_size);
    buff = get_memory(new_size, "buff - data_routines");
    sprintf(buff, "%d%s", opcode, buffer);
    //fprintf(stderr, "STATUS: %s", buff);
    write_num(sock, buff, strlen(buff));    
    free(buff);
    //write_num(sock, buffer, amount);    
}
