/*
 * g-page (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */   

#include "my_header.h"
#include "data_structures.h"
#include "function_def.h"


void delete_msg(int sock)
{
    char   *id = NULL;
    char   *tid = NULL;
    char   *result = NULL;
    int    length = 0;


    id = get_memory(MAX_LENGTH, "msg_edit_delete - id");
    tid = get_memory(MAX_LENGTH, "msg_edit_delete - tid");

    read_a_line(sock, id, MAX_LENGTH, 60);
    write_num(sock, id, strlen(id));
    
    strcpy(tid, id);
    result = delete_id(id);

    read_a_line(sock, id, MAX_LENGTH, 60);
    write_num(sock, result, strlen(result));

    close(sock);
    if ( !strcmp(result, "true\n") )
    {
	clean_up_data(tid);
	update_status(tid, sock, 1); /* remove any old log files with this id */
	if ( tid[strlen(tid) -1] == '\n' )
	{
	     tid[strlen(tid) -1] = '\0';
	}
	length = strlen(tid);
	if ( *(tid + --length) == 'r' )
	    *(tid + length) = '\0';
	recycle_id("SCHEDULE", tid) ;
    }

    free(id);
    free(tid);

    return;
}

void clean_up_data(char *id)
{
    enum
    {
	lock = 0,
	unlock = 1
    };

    char   *log_file = "/.gpage/gsched.dat";
    char   *full_path = NULL;
    char   *line = NULL;
    char   *t_id = NULL;
    char   *temp_line;
    FILE   *fp, *fp1;
    int    i, x;
    int    file_locked = 1;
    int    wait = 0;
    int    path_length = 0;

    

    path_length = strlen(getenv("HOME")) + strlen(log_file) + 10;
    full_path = get_memory(path_length, "msg_edit_delete - full_path");

    strcpy(full_path, getenv("HOME"));
    strcat(full_path, log_file);

    line = get_memory(MAX_LENGTH, "msg_edit_delete - line");
    t_id = get_memory(MAX_LENGTH, "msg_edit_delete - t_is");

    while ( file_locked )
    {
	if ( wait == 300 )	/* If the file is locked for 5 minutes something evil has happened */
	    return;

	fp = file_locking(full_path, "r+", "gsched.dat", lock);

	if (fp)
	    file_locked = 0;
	else
	{
	    sleep(1);
	    wait++;
	}
    }

    if ( (fp1 = get_temp_file()) == NULL)
    {
	perror("Error opening tmp_file clean_up_data msg_edit_delete");
	return;
    }

    while(fgets(line, MAX_LENGTH, fp))
    {
	i = x = 0;
	while( *(line + i++) != ' ');
	strcpy(t_id, (line + i));
	if ( !strcmp(id, t_id) )
	{
		x = 0;
		while( x++ < SCHEDULED_FILE_ENTRIES )
		    fgets(line, MAX_LENGTH, fp);
	}
	else
	{
	    fputs(line, fp1);
	    x = 0;
	    while( x++ < SCHEDULED_FILE_ENTRIES )
	    {
		fgets(line, MAX_LENGTH, fp);
		fputs(line, fp1);
	    }
	}
    }
    rewind(fp1);
    fclose(fp);

    temp_line = get_memory(MAX_LENGTH, "msg_edit_delete - temp_line");

    if ( ( fp = fopen(full_path, "w")) == NULL)
	return;
    while(fgets(temp_line, MAX_LENGTH, fp1))
	fputs(temp_line, fp);

    fclose(fp1);
    fclose(fp);
    free(temp_line);

    file_locking(full_path, "r+", "gsched.dat", unlock);

    free(full_path);
    free(line);
    free(t_id);
}

char *delete_id(char *id)
{
    enum
    {
	lock = 0,
	unlock = 1
    };

    char           *result;
    FILE           *fp, *fp1;
    int            flag;
    char           *file = NULL;
    char           *line = NULL;
    char           *msg_id = NULL;
    char           *status = NULL;
    char           *logfile = "/.gpage/gsched_id.dat";
    char           *temp_line;
    int            x, i;
    int            wait = 0;
    int            file_locked;
    int            path_length = 0;
    struct stat    file_info;


    line = get_memory(MAX_LENGTH, "msg_edit_delete - line");
    status = get_memory(MAX_LENGTH, "msg_edit_delete - status");
    msg_id = get_memory(MAX_LENGTH, "msg_edit_delete - msg_id");

    flag = 0;
    id[strlen(id) - 1] = '\0';

    path_length = strlen(getenv("HOME")) + strlen(logfile) + 10;
    file = get_memory(path_length, "msg_edit_delete - file");

    strcpy(file, getenv("HOME"));
    strcat(file, logfile);
    
    if ( (stat(file, &file_info)) == -1 ) 
	return ("false\n");

    result = get_memory(MAX_FIELD, "msg_edit_delete - result");

    file_locked = 1;
    while ( file_locked )
    {
	if ( wait++ == 120 )	
	{
	    return ("false\n");
	}

	fp = file_locking(file, "r+", "gsched_id.dat", lock);

	if (fp)
	    file_locked = 0;
	else
	    sleep(1);	    
    }

    if ( (fp1 = get_temp_file()) == NULL)
    {
	fclose(fp);
	file_locking(file, "r+", "gsched_id.dat", unlock);
	error_ret("Error opening temp file delete_id msg_edit_delete.c");
	return ( "false\n" );
    }

    while(fgets(line, MAX_LENGTH, fp))
    {
	x = i = 0;
	while ( *(line + i++) != ' ' );
	while ( *(line + i) != ' ' )
	    *(msg_id + x++) = *(line + i++);
	*(msg_id + x) = '\0';
	if ( !strcmp(msg_id, id) )
	{
	    flag = 1;
	    continue;
	}
	else
	    fputs(line, fp1);
    }

    fclose(fp);
    
    if ( flag )
    {
	rewind(fp1);
	strcpy(result, "true\n");
	temp_line = get_memory(MAX_FIELD, "msg_edit_delete - temp_line");	
	
	if ( (fp = fopen(file, "w")) == NULL)
	{
	    fclose(fp1);
	    free(temp_line);
	    return ( "false\n" );
	}
	while(fgets(temp_line, MAX_LENGTH, fp1))
	    fputs(temp_line, fp);
	fclose(fp1);
	fclose(fp);
	free(temp_line);
    }
    else
    {
	fclose(fp1);
	strcpy(result, "false\n");
    }

    free(line);
    free(status);
    free(msg_id);
    free(file);

    file_locking(file, "r+", "gsched_id.dat", unlock);
    return (result);
}
