/*
 * g-page (C) 2000 Hiro Protagonist
 *
 * This software is released under the GNU General Public License.
 * Please read the included LICENSE file for more information.
 * This software comes with no warranty of any kind, use at you own risk!
 */   

#define IP_LENGTH 20
#define MAX_LENGTH 2500

#include <stdio.h>
#include <unistd.h>
#include <stdarg.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <sys/types.h>
#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <syslog.h>
#include <fcntl.h>
#include <pthread.h>
#include <netdb.h>

#ifndef CMSG_DATA
#define CMSG_DATA(cmsg) ((cmsg)->cmsg_data)
#endif


/*
 *   GLOBALS
 */

int   debug_flag;
int   daemon_flag;

typedef void Sigfunc (int);
void sig_chld(int signo);
Sigfunc *Signal(int signo, Sigfunc *func);

typedef struct blocked_ips{
    char                 *bad_ip;
    struct blocked_ips   *next;
}banned_ips;

void get_data(int connected_fd, char *client_ip);

char *get_memory(int size, char *function);
ssize_t read_a_line(int file_desc, char return_buff[MAX_LENGTH], size_t maxlen, int timeout);
ssize_t write_num(int file_desc, char *strptr, size_t num);


void debug_log(const char *fmt,...);
void error_ret(const char *fmt,...);
void info_msg(const char *fmt,...);
void error_sys(const char *fmt,...);
void error_core(const char *fmt,...);
void error_quit(const char *fmt,...);


